/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: AddressManager.java,v 1.1 2004/08/16 09:33:11 slobodan Exp $
 */

package com.lutris.airsent.business.address;

import com.lutris.airsent.business.AirSentBusinessException;
import com.lutris.airsent.spec.address.Address;
import com.lutris.airsent.data.person.AddressDO;

/**
 * Address Factory
 * 
 * 
 * @author joseph shoop
 * @version %I%, %G%
 */
public class AddressManager {

    /**
     * Creates an Address object.
     * @return CustomerFac
     * @exception AirSentBusinessException
     */
    public AddressImpl create() 
        throws AirSentBusinessException {
	try {
	    return new AddressImpl();
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Error creating Messenger");
	} 
    } 

    /**
     * Creates an Address object from a data object
     * @return CustomerFac
     * @exception AirSentBusinessException
     */
    public AddressImpl create(AddressDO address) 
        throws AirSentBusinessException {
	try {
	    return new AddressImpl(address);
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Error creating Messenger");
	} 
    } 


}



