/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: CustomerManagerImpl.java,v 1.1 2004/08/16 09:33:11 slobodan Exp $
 */

package com.lutris.airsent.business.customer;

import com.lutris.airsent.business.AirSentBusinessException;

import com.lutris.airsent.spec.customer.*;

import com.lutris.airsent.data.person.CustomerDO;
import com.lutris.airsent.data.person.CustomerQuery;

/**
 * Class declaration
 */
public class CustomerManagerImpl implements CustomerManager{

    /**
     * Creates an empty customer.
     * 
     * 
     * @return
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer create() throws AirSentBusinessException {
	try {
	    return new CustomerImpl();
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Error creating Messenger");
	} 
    } 

    /**
     * Finds a customer by business.
     * 
     * 
     * @param business
     * 
     * @return
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer findByBusiness(String business) 
	    throws AirSentBusinessException {
	Customer theCustomer = null;

	try {
	    CustomerQuery query = new CustomerQuery();

	    // Require that we only find ONE Customer
	    query.setQueryBusiness(business);

	    CustomerDO[] customerDO = query.getDOArray();

	    if (customerDO.length == 0) {
		return null;
	    } else {
		return new CustomerImpl(customerDO[0]);
	    } 
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Exception in findByBusiness", 
					       ex);
	} 
    } 

    /**
     * Finds a Customer by login.
     * 
     * 
     * @param login
     * 
     * @return
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer findByLogin(String login) 
	    throws AirSentBusinessException {
	Customer theCustomer = null;
  String exe="Test";
	try {
	    CustomerQuery query = new CustomerQuery();

	    // Require that we only find ONE Customer
	    query.setQueryLogin(login);
      exe="Dato Queriju";
	    CustomerDO[] customerDO = query.getDOArray();
      exe="Dato Queriju i vracen DO";
	    if (customerDO.length == 0) {
		return null;
	    } else {
		return new CustomerImpl(customerDO[0]);
	    } 
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Exception in findByLogin"+exe, 
					       ex);
	} 
    } 

    /**
     * Validates the customer based password and login.
     * 
     * 
     * @param login
     * @param password
     * 
     * @return
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer validatePassword(String login, String password) 
	    throws AirSentBusinessException {
	Customer theCustomer = null;

	try {
	    if ((theCustomer = findByLogin(login)) == null) {
		return null;
	    } else {
		if (theCustomer.getPassword().equals(password)) {
		    return theCustomer;
		} else {
		    return null;
		} 
	    } 
	} catch (Exception ex) {
	    throw new AirSentBusinessException("Exception in findByPassword", 
					       ex);
	} 
    } 

}

