/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: AirSentConstants.java,v 1.1 2004/08/16 09:33:16 slobodan Exp $
 */

package com.lutris.airsent.presentation;

/**
 * Holds all the constants used by the AirSent presentation objects.
 * 
 * 
 * @author
 * @version %I%, %G%
 */
public class AirSentConstants {

    /*
     * System constants
     */
    public static final long   SECONDS_DAY = 86400;

    /*
     * User constants
     */
    public static final int    UNAUTH_USER = 0;
    public static final int    CUSTOMER_USER = 1;
    public static final int    MESSENGER_USER = 2;
    public static final int    ADMINISTRATOR_USER = 3;

    
    /**
     * PO Constants
     */
    public static final String EXIT_PO = "Exit.po";
    public static final String ORDERSTEP1_PO = "OrderPage1.po";
    public static final String ORDERSTEP2_PO = "OrderPage2.po";
    public static final String ORDERSTEP3_PO = "OrderPage3.po";
    public static final String CONFIRMATION_PO = "OrderPage4.po";
    public static final String AIRSENT_HOME_PO = "AirSentHome.po";
    public static final String ADMIN_HOME_PO = "AdminHome.po";
    public static final String LOGIN_PO = "Login.po";
    public static final String FORGOT_PASSWORD_PO = "ForgotPassword.po";
    public static final String DETAILS_PO = "Details.po";
    public static final String DISPLAY_PO = "Display.po";
    public static final String USER_KEY = "AirSentPerson";
    public static final String CUSTOMER_LOGIN_PAGE = "Login.po";
    public static final String ADMIN_MAIN_PAGE = "AdminMain.po";
    public static final String ADMIN_LOGIN_PAGE = "AdminLogin.po";
    public static final String MESSENGER_MAIN_PAGE = "MessengerMain.po";
    public static final String ADMINDETAILS_PAGE = "AdminDetails.po";
    public static final String NEW_MESSENGER_PAGE = "NewMessenger.po";
    public static final String HTML_PAGE = "Welcome.po";
    public static final String WAP_PAGE = "/messenger/MessengerLogin.po";
    public static final String XML_PAGE = "/messenger/MessengerLogin.po";
    public static final String CHTML_PAGE = "/messenger/MessengerLogin.po";


    /**
     * Accept-type routing
     */
    public static final String HTML_CONTENT = "text/html";
    public static final String WAP_CONTENT = "wap";
    public static final String XML_CONTENT = "text/xml";
    public static final String XHTML_CONTENT = "text/xhtml";
    public static final String CHTML_CONTENT = "text/chtml";
    public static final String ACCEPT = "Accept";

    /**
     * Parameter Constants for POs
     */
    public static final String LOGIN_NAME = "login";
    public static final String PASSWORD_NAME = "password";
    public static final String PASSWORD_VERIFY_NAME = "passwordverify";
    public static final String FIRST_NAME = "firstname";
    public static final String MIDDLEINITIAL_NAME = "middleinitial";
    public static final String LAST_NAME = "lastname";
    public static final String EMAIL_NAME = "email";
    public static final String BADGE_NAME = "badge";
    public static final String COMPANY_NAME = "company";
    public static final String STREET1_NAME = "street1";
    public static final String STREET2_NAME = "street2";
    public static final String STREET3_NAME = "street3";
    public static final String CITY_NAME = "city";
    public static final String STATE_NAME = "state";
    public static final String POSTAL_CODE_NAME = "postalcode";
    public static final String COUNTRY_NAME = "country";
    public static final String PHONE_NAME = "phone";
    public static final String DELIVERYID = "deliveryID";
    public static final String MESSENGER_NAME = "messenger";
    public static final String EDIT_FLAG = "edit";
    public static final String ORDER_NAME = "ordername";
    public static final String PICKUP = "pickup";
    public static final String PICKUP_NAME = "pickupname";
    public static final String PICKUP_ADDRESS = "pickupaddress";
    public static final String PICKUP_PHONE = "pickupphone";
    public static final String PICKUP_DIRECTIONS = "pickupdirections";
    public static final String DROPOFF = "dropoff";
    public static final String DROPOFF_NAME = "dropoffname";
    public static final String DROPOFF_ADDRESS = "dropoffaddress";
    public static final String DROPOFF_PHONE = "dropoffphone";
    public static final String DROPOFF_DIRECTIONS = "dropoffdirections";
    public static final String FRAGILE = "fragile";
    public static final String URGENT = "urgent";
    public static final String SIZE = "size";
    public static final String DESCRIPTION = "description";
    public static final String ORDER_PAGE = "orderpage";
    public static final String ORDERSTEP1 = "orderstep1";
    public static final String ORDERSTEP2 = "orderstep2";
    public static final String ORDERSTEP3 = "orderstep3";
    public static final String ORDERSTEP4 = "orderstep4";
    public static final String SELECTION_NAME = "selection";
    public static final String DIRECTION = "direction";
    public static final String FOREWARD = "foreward";
    public static final String BACK = "back";
    public static final String EDITLINK = "editlink";
    
    /*
     * Admin page special constants
     */
    public static final String REFRESH = "refresh";
    public static final String STANDALONE_MAIN = "standalone";
    public static final String PICKUP_FILTER = "pickupfilter";
    public static final String DROPOFF_FILTER = "dropofffilter";

    /**
     * Image constants
     * 
     */
    public static final String URGENT_IMAGE = "../media/ArtAlert.jpg";
    public static final String BLANK_IMAGE = "../media/spacer.gif";

    /**
     * Other Constants
     */
    public static String       NOT_ASSIGNED = "Not Assigned.";
}

