/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: ErrorHandler.java,v 1.2 2005/04/27 10:41:56 slobodan Exp $
 */

package com.lutris.airsent.presentation;
import  com.lutris.airsent.presentation.messenger.*;
import com.lutris.logging.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.*;
import java.io.*;
import org.enhydra.xml.xmlc.XMLObject;
import java.lang.reflect.Method;
/**
 * Class to handle exceptions not caught anywhere else in the framework of
 * our application
 * 
 * @author
 * @version
 */
public class ErrorHandler implements HttpPresentation {

    /**
     * This implements the run method in HttpPresentation.
     * 
     * @param HttpPresentationComms
     * @exception HttpPresentationException
     */
    public void run(HttpPresentationComms comms) 
	    throws HttpPresentationException {
	
	java.util.Enumeration enumeration = comms.request.getHeaderNames();
	while(enumeration.hasMoreElements()) {
	    String name = (String)enumeration.nextElement();
		System.out.println("HEADER " + name + " = "+ comms.request.getHeader(name));
	}
	
	
	Class tempClass=null;
	Object zvek= null;
	Method errorTemp = null;
  Method stackTemp = null;
  
	try{
  	Class stringClass=Class.forName("java.lang.String");
  	tempClass = Class.forName(DeviceUtils.getPageName(comms, "com.lutris.airsent.presentation.messenger.Error")); 
    zvek= comms.xmlcFactory.create(tempClass);
    Class[] argTypeArr={stringClass};
    errorTemp = tempClass.getMethod("setTextErrorMessage",argTypeArr);
    stackTemp = tempClass.getMethod("setTextStackTrace",argTypeArr);
  }catch(Exception e){}
	
	
	//ErrorPage errorPage = (ErrorPage)comms.xmlcFactory.create(DeviceUtils.getPageName(comms, 
		//								     "com.lutris.airsent.presentation.messenger.Error"));
	
	try{
  	if (null != comms.exception) {
  	    Enhydra.getLogChannel().write(Logger.DEBUG, 
  					  "Exception in Airsent", 
  					  comms.exception);
  	    Object [] temp={comms.exception.getMessage()};
  	    errorTemp.invoke(zvek,temp);
  	    //errorPage.setTextErrorMessage((comms.exception.getMessage()));
  	} 
  	
  	
  	if (null != comms.exception) {
  	    StringWriter stringWriter = new StringWriter();
  	    
  	    comms.exception.printStackTrace(new PrintWriter(stringWriter));
  
  	    LogChannel logChannel = Enhydra.getLogChannel();
  	    int	       level = logChannel.getLevel("DEBUG");
  	    
  	    // Write to log
  	    logChannel.write(level, 
  			     "airSent.presentation.ErrorHandler stack trace = ");
  	    logChannel.write(level, stringWriter.toString());
  	    logChannel.write(level, 
  			     "airSent.presentation.ErrorHandler caught an exception - " 
  			     + comms.exception.toString(), comms.exception);
  
  	    // Write to stdout
  	    System.out.print("airSent.presentation.ErrorHandler stack trace = ");
  	    System.out.print(stringWriter.toString());
  	    System.out.print(comms.exception.toString());
  
  	    // Write to page
  	    Object [] temp1={comms.exception.getMessage()};
  	    Object [] temp2={stringWriter.toString()};
  	    errorTemp.invoke(zvek,temp1);
  	    stackTemp.invoke(zvek,temp2);
  	    //errorPage.setTextStackTrace(stringWriter.toString());
  	    //errorPage.setTextErrorMessage(comms.exception.getMessage());
  	} 
  }catch (Exception e){}  
    comms.response.writeDOM((XMLObject)zvek);
    } 

}



