/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: help.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.presentation;

import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.lutris.util.*;
import org.enhydra.xml.xmlc.XMLObject;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import java.util.Date;
import com.lutris.airsent.presentation.BasePO;

/**
 * Login.java handles the login functionality of the DiscRack app.
 * 
 * @author
 * @version
 */
public class help extends BasePO {

    /**
     * Constants
     */
    private static final int AUTH_LEVEL = AirSentConstants.UNAUTH_USER;

    /**
     * Superclass method override.
     * returns the authorization level necessary to access this po.
     * 
     * @return int required authorization level
     */
    public int getRequiredAuthLevel() {
	return AUTH_LEVEL;
    } 

    /**
     * Default event. Just show the page.
     */
    public XMLObject handleDefault() throws HttpPresentationException {
	return showPage(null);
    } 

    /**
     * handle throw exception event.
     * 
     * @return html document
     * @exception Exception
     */
    public XMLObject handleThrowException() throws Exception {
	throw new Exception("This is a test exception thrown from Login.java handleThrowException()");
    } 

    /**
     * display page
     * 
     * @param errorMsg, the error messages
     * @return html document
     */
    public XMLObject showPage(String errorMsg) 
	    throws AirSentPresentationException {
	helpHTML page = 
	    (helpHTML) getComms().xmlcFactory.create(helpHTML.class);

	    return page;
    } 

}

