/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: DisplayPage.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.presentation.messenger;

import org.w3c.dom.*;
import org.enhydra.xml.xmlc.XMLObject;

/**
 * Interface declaration
 * 
 * 
 * @author
 * @version %I%, %G%
 */
public interface DisplayPage extends XMLObject {

    /**
     * Gets the error tag.
     * 
     * 
     * @return
     * 
     * 
     */
    public Element getTagErrorText();

    /**
     * Gets the Display Template Name
     * 
     * 
     * @return
     * 
     * 
     */
    public Element getTagDisplayTemplateName();

    /**
     * Gets the template row
     * 
     * 
     * @return
     * 
     * 
     */
    public Element getTagDisplayTemplateRow();

    /**
     * Gets the Template Complete Element
     * 
     * 
     * @return
     * 
     * 
     */
    public Element getTagDisplayTemplateComplete();

    /**
     * gets the name tag.
     * 
     * 
     * @return
     * 
     * 
     */
    public Element getTagNameField();

    
    /**
     *Sets the error text.
     *
     */
    public void setTextErrorText(String name);


    /**
     *Sets the name field text.
     *
     */
    public void setTextNameField(String name);


     /**
     *Sets the name field text.
     *
     */
    public void setTextDisplayTemplateName(String name);


     /**
     *Sets the link text.
     *
     */
    public void setTextDisplayTemplateComplete(String name);

}



