/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: ErrorHandler.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.presentation.messenger;

import com.lutris.logging.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.*;
import java.io.*;
import org.enhydra.xml.xmlc.XMLCUtil;
import com.lutris.airsent.presentation.DeviceUtils;
import org.enhydra.xml.xmlc.XMLObject;
import java.lang.reflect.Method;


/**
 * Class to handle exceptions not caught anywhere else in the framework of
 * our application
 * 
 * @author
 * @version
 */
public class ErrorHandler implements HttpPresentation {

    /**
     * This implements the run method in HttpPresentation.
     * 
     * @param HttpPresentationComms
     * @exception HttpPresentationException
     */
    public void run(HttpPresentationComms comms) 
	    throws HttpPresentationException {
		Class tempClass=null;
	Object page= null;
	Method setTextErrorMessage = null;
  
	try{
  	Class stringClass=Class.forName("java.lang.String");
  	tempClass = Class.forName(DeviceUtils.getPageName(comms, "com.lutris.airsent.presentation.messenger.Error")); 
    page= comms.xmlcFactory.create(tempClass);
    Class[] argTypeArr={stringClass};
    setTextErrorMessage = tempClass.getMethod("setTextErrorMessage",argTypeArr);
  }catch(Exception e){}
	
	
	//ErrorPage errorPage = (ErrorPage)comms.xmlcFactory.create(DeviceUtils.getPageName(comms, 
		//								     "com.lutris.airsent.presentation.messenger.Error"));
try{	
	if (null != comms.exception) {
	    Enhydra.getLogChannel().write(Logger.DEBUG, 
					  "Exception in Airsent", 
					  comms.exception);
	    System.out.println("Setting ERROR page..");
	    Object [] temp={(comms.exception.getMessage())};
	    setTextErrorMessage.invoke(page,temp);
	    //errorPage.setTextErrorMessage((comms.exception.getMessage()));
	    
	    //StringWriter stringWriter = new StringWriter();
	    //comms.exception.printStackTrace(new PrintWriter(stringWriter));
	    //errorPage.setTextStackTrace(stringWriter.toString());
    } 
}catch(Exception e){}
	try {
	    comms.response.writeDOM((XMLObject)page);
	} catch (Exception ex) {
	    throw new HttpPresentationException(ex);
	} 
    } 

}

