/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 */

package com.lutris.airsent.spec;

import com.lutris.util.Config;
import com.lutris.airsent.spec.delivery.DeliveryManager;
import com.lutris.airsent.spec.messenger.MessengerManager;
import com.lutris.airsent.spec.sms.SMSManager;
import com.lutris.airsent.spec.customer.CustomerManager;
import com.lutris.airsent.spec.email.EmailManager;


/**
 * Interface declaration
 * 
 * 
 */
public interface HomeManager {
public void initialize(Config config) throws AirSentException;
public HomeManager getInst()throws AirSentException;
public DeliveryManager getDeliveryManager();
public MessengerManager getMessengerManager();
public SMSManager getSMSManager();
public CustomerManager getCustomerManager();
public EmailManager getEmailManager();

 
}