/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: Address.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.spec.address;

import com.lutris.airsent.spec.AirSentException;

/**
 * Interface declaration
 * 
 * 
 * @author joseph shoop
 * @version %I%, %G%
 */
public interface Address {

    /**
     *
     */
    public final static int MAX_NAME = 48;

    /**
     *
     */
    public final static int MAX_ADDRESS = 48;

    /**
     *
     */
    public final static int MAX_CITY = 64;

    /**
     *
     */
    public final static int MAX_ZIP_CODE = 24;

    /**
     *
     */
    public final static int MAX_PHONE = 21;

    /**
     *
     */
    public final static int MAX_AREA_CODE = 21;

    /**
     *
     */
    public final static int MAX_STATE = 32;

    /**
     *
     */
    public final static int MAX_COUNTRY = 64;

    /**
     *
     */
    public final static int MAX_DIRECTIONS = 1024;




    /**
     * Gets the handle
     * 
     * 
     * @return the handle
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getHandle() throws AirSentException;






    /**
     * Gets the name
     * 
     * 
     * @return Name
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getName() throws AirSentException;

    /**
     * Sets the name
     * 
     * 
     * @param name
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setName(String name) throws AirSentException;

    /**
     * Gets street1
     * 
     * 
     * @return Street1
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getStreet1() throws AirSentException;

    /**
     * Sets street1
     * 
     * 
     * @param street
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setStreet1(String street) throws AirSentException;

    /**
     * Gets street2
     * 
     * 
     * @return Street2
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getStreet2() throws AirSentException;

    /**
     *  Sets street2
     * 
     * 
     * @param street
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setStreet2(String street) throws AirSentException;

    /**
     *  Gets street3
     * 
     * 
     * @return Street3
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getStreet3() throws AirSentException;

    /**
     *  Sets street3
     * 
     * 
     * @param street
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setStreet3(String street) throws AirSentException;

    /**
     * Gets the city.
     * 
     * 
     * @return City
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getCity() throws AirSentException;

    /**
     * Sets the city.
     * 
     * 
     * @param city
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setCity(String city) throws AirSentException;

    /**
     * Gets the postal code.
     * 
     * 
     * @return Postal code
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getPostalCode() throws AirSentException;

    /**
     * Sets the postal code.
     * 
     * 
     * @param code
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setPostalCode(String code) throws AirSentException;

    /**
     * Gets the local number.
     * 
     * 
     * @return Local number
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getLocalNumber() throws AirSentException;

    /**
     * Sets the local number
     * 
     * 
     * @param number
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setLocalNumber(String number) throws AirSentException;

    /**
     * Gets the area code.
     * 
     * 
     * @return AreaCode
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getAreaCode() throws AirSentException;

    /**
     * Sets the area code.
     * 
     * 
     * @param area
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setAreaCode(String area) throws AirSentException;

    /**
     * Gets the state.
     * 
     * 
     * @return State
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getState() throws AirSentException;

    /**
     * Sets the state.
     * 
     * 
     * @param state
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setState(String state) throws AirSentException;

    /**
     * Gets the country.
     * 
     * 
     * @return Country
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getCountry() throws AirSentException;

    /**
     * Sets the country.
     * 
     * 
     * @param country
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setCountry(String country) throws AirSentException;

    /**
     * Gets the directions.
     * 
     * 
     * @return Directions
     * 
     * @throws AirSentException
     * 
     * 
     */
    public String getDirections() throws AirSentException;

    /**
     * Sets the directions.
     * 
     * 
     * @param directions
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void setDirections(String directions) 
	    throws AirSentException;

    /**
     * Saves an address.
     * 
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void save() throws AirSentException;

    /**
     * Deletes an address.
     * 
     * 
     * @throws AirSentException
     * 
     * 
     */
    public void delete() throws AirSentException;
}

