/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: CustomerManager.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.spec.customer;

import com.lutris.airsent.spec.AirSentException;
import com.lutris.airsent.spec.customer.Customer;

/**
 * Interface declaration
 * 
 * 
 * @author joseph shoop
 * @version %I%, %G%
 */
public interface CustomerManager {

    /**
     * Creates a new customer.
     * 
     * 
     * @return new customer.
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer create() throws AirSentException;

    /**
     * Finds a customer by business.
     * 
     * 
     * @param business
     * 
     * @return Customer
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer findByBusiness(String business) 
	    throws AirSentException;

    /**
     * Gets a customer by login.
     * 
     * 
     * @param login
     * 
     * @return Customer
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer findByLogin(String login) throws AirSentException;

    /**
     * Validates a customer based on login and password.
     * 
     * 
     * @param login
     * @param password
     * 
     * @return Customer
     * 
     * @throws AirSentBusinessException
     * 
     * 
     */
    public Customer validatePassword(String login, String password) 
	    throws AirSentException;
}

