/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: CustomerManagerFactory.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */
package com.lutris.airsent.spec.customer;



public class CustomerManagerFactory {
    
    /**
     * Constructor can't be used.
     */
    private CustomerManagerFactory() {
    }

    /**
     * Create a CustomerManager as state object/value object/data transfer object
     */
    public static CustomerManager getCustomerManager(String fullClassName){
        
        CustomerManager result = null;
       
        Class objectClass = null;

        try {
            // Create the value object
       
      
         objectClass = Class.forName(fullClassName);
                                   
          result = (CustomerManager)objectClass.newInstance();
               
                       
                    
      } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }
}