/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: Update.java,v 1.2 2004/10/14 11:13:11 lola Exp $
 */

package com.lutris.airsent.spec.delivery;

import com.lutris.airsent.spec.AirSentException;
/**
 * Interface declaration
 * 
 * 
 * @author joseph shoop
 * @version %I%, %G%
 */
public interface Update {

    /**
     * Provides the time for an update.
     * 
     * 
     * @param browserState
     * @param wait
     * 
     * @return
     * 
     * 
     */
    public long needUpdate(long browserState, long wait) throws AirSentException ;

    /**
     * Set the update state.
     * 
     * 
     * @param updateState
     * 
     * 
     */
    public void setUpdateState(long updateState);

    /**
     * Gets the update state.
     * 
     * 
     * @return
     * 
     * 
     */
    public long getUpdateState();
}

