/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: EmailManager.java,v 1.1 2004/08/16 09:33:18 slobodan Exp $
 */

package com.lutris.airsent.spec.email;

import com.lutris.airsent.spec.AirSentException;

/**
 * Email Factory to send smtp mail.
 * 
 * 
 * @author joseph shoop
 * @version %I%, %G%
 */
public interface EmailManager {

    /**
     * Sends mail using smtp.
     * 
     * 
     * @param to
     * @param toAddress
     * @param subject
     * @param body
     * @param type
     * 
     * @throws AirSentException
     * 
     */
    public void send(String to, String toAddress, String subject, 
		     String body, 
		     String type) throws AirSentException;
}

