/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: DiscRackGateway.java,v 1.5 2006/03/29 15:55:20 alex Exp $
 */

package barracudaDiscRack;

// import disc rack specifics
import barracudaDiscRack.presentation.personMgmt.LoginEventGateway;
import barracudaDiscRack.presentation.personMgmt.RegistrationEventGateway;
import org.barracudamvc.core.event.ApplicationGateway;

// import java specifics
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

import org.apache.log4j.*;

public class DiscRackGateway extends ApplicationGateway {

  protected static Logger theirLogger = Logger.getLogger(DiscRackGateway.class.getName());
	
	//-------------------- ApplicationGateway --------------------
	/**
	 * Perform any local initialization (this is where you should
	 * specify any known EventGateways)
	 */
	public void initializeLocal() {
		//specify the event gateways
		this.specifyEventGateways(new LoginEventGateway());
		this.specifyEventGateways(new RegistrationEventGateway());
	}
	
}
