/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: PublicEvent.java,v 1.4 2004/12/03 14:12:34 slobodan Exp $
 */
package barracudaDiscRack.presentation.events;

/**
 * This event is the parent of all events which
 * are publically accessible and do NOT require
 * the user to be logged in
 */
public class PublicEvent extends LocalRequestEvent {
	/**
	 * Default noargs constructor
	 */
	public PublicEvent() {super();}

	/**
	 * Public constructor. Automatically sets the source parameter.
	 * If you do not use this method you should manually set the
	 * source before dispatching the event.	
	 */
	public PublicEvent(Object source) {
		super(source);
	}
}
