/*
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1999 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Cactus", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * formatted with JxBeauty (c) johann.langhofer@nextra.at
 */


package  org.hamletsoft.enhydra.cactus.business;

import  java.io.*;
import  java.lang.reflect.*;
import  java.net.*;
import  java.util.*;
import  javax.servlet.*;
import  javax.servlet.http.*;
import  org.apache.cactus.*;
import  org.apache.cactus.util.log.*;
import  org.hamletsoft.enhydra.cactus.data.*;
import  org.apache.cactus.server.AbstractWebTestController;
import  org.apache.cactus.server.WebImplicitObjects;
import  org.apache.cactus.server.AbstractWebTestCaller;
import  org.hamletsoft.enhydra.cactus.spec.*;

/**
 * EnhydraApp Controller that extracts the requested service from the
 * HTTP request and executes the request by calling a
 * <code>EnhydraAppTestCaller</code>. There are 2 services available : one for
 * executing the test and one for returning the test result.
 *
 * @author <a href="mailto:hattori@hitachizosen.co.jp">Ryuji "The Hamlet" Hattori</a>
 *
 * @version $Id: EnhydraAppTestControllerImpl.java,v 1.1 2004/08/16 09:35:01 slobodan Exp $
 */
public class EnhydraAppTestControllerImpl extends AbstractWebTestController implements EnhydraAppTestController {

  /**
   * @return the test caller that will be used to execute the test
   */
  protected AbstractWebTestCaller getTestCaller (WebImplicitObjects theObjects) {
    return  new EnhydraAppTestCaller((EnhydraAppImplicitObjectsImpl)theObjects);
  }
  
   public void handleRequest(EnhydraAppImplicitObjects theObjects)
  throws ServletException
   {
   super.handleRequest((EnhydraAppImplicitObjectsImpl)theObjects);
   }
   
}



