/*
 * put your module comment here
 * formatted with JxBeauty (c) johann.langhofer@nextra.at
 */


package  org.hamletsoft.enhydra.cactus.business.sample;

import  org.hamletsoft.enhydra.cactus.business.EnhydraAppTestCase;
import  org.hamletsoft.enhydra.cactus.presentation.RedirectPresentation;
import  junit.framework.Test;
import  junit.framework.TestSuite;
import  java.io.IOException;
import  org.apache.cactus.WebRequest;
import  java.util.Map;
import  com.meterware.httpunit.WebResponse;
import  com.lutris.appserver.server.httpPresentation.ClientPageRedirectException;
import  java.util.Hashtable;
import  javax.servlet.http.HttpUtils;
import  org.apache.log4j.PropertyConfigurator;


/**
 * SampleEnhydraRedirectionTestCase.java
 *
 *
 * Created: Wed Feb 13 17:53:50 2002
 *
 * @author <a href="mailto:hattori@hitachizosen.co.jp">Ryuji Hattori</a>
 * @version
 */
public class SampleEnhydraRedirectionTestCase extends EnhydraAppTestCase {
  static {
    // instructs PropertyConfigurator to parse a configuration file and set up logging accordingly
    PropertyConfigurator.configure("log_client.properties");
  }

  public SampleEnhydraRedirectionTestCase (String name) {
    super(name);
  }

  /**
   * Start the tests.
   *
   * @param theArgs the arguments. Not used
   */
  public static void main (String[] theArgs) {
    junit.awtui.TestRunner.main(new String[] {
      SampleEnhydraRedirectionTestCase.class.getName()
    });
  }

  /**
   * @return a test suite (<code>TestSuite</code>) that includes all methods
   *         starting with "test"
   */
  public static Test suite () {
    // All methods starting with "test" will be executed in the test suite.
    return  new TestSuite(SampleEnhydraRedirectionTestCase.class);
  }
  String answer1 = "http://localhost:9000/WelcomePresentation.po";

  /**
   * Verify that we can assert the client side redirection.
   */
  public void testRedirection1 () throws Exception {
    RedirectPresentation samplePO = new RedirectPresentation();
    samplePO.run(comms);
  }

  /**
   * Verify that we can assert the client side redirection.
   *
   * @param theResponse the response from the server side.
   */
  public void endRedirection1 (WebResponse theResponse) throws IOException {
    assertEquals(theResponse.getHeaderField("Location"), answer1);
  }

  /**
   * Verify that we can assert the client side redirection.
   */
  public void testRedirection2 () throws Exception {
    RedirectPresentation samplePO = new RedirectPresentation();
    try {
      samplePO.run(comms);
    } catch (ClientPageRedirectException cpre) {
      cpre.addArgument("test1", "TEST1");
      cpre.addArgument("test2", "TEST2");
      cpre.addArgument("test3", "TEST3");
      throw  cpre;
    }
  }

  /**
   * Hook method on Server Side for client page redirection.
   *
   * @param url URL of Page Redirection.
   * @param ht HTTP parameter table for the URL of Page Redirection.()
   */
  protected void hookForClientPageRedirect (String url, Hashtable ht) {
    if (ht == null)
      return;                   //for Test1
    assertEquals("TEST3", ((String[])ht.get("test3"))[0]);
    assertEquals("TEST2", ((String[])ht.get("test2"))[0]);
    assertEquals("TEST1", ((String[])ht.get("test1"))[0]);
  }

  /**
   * Verify that we can assert the client side redirection.
   *
   * @param theResponse the response from the server side.
   */
  public void endRedirection2 (WebResponse theResponse) throws IOException {
    String str = theResponse.getHeaderField("Location");
    Hashtable ht = getRedirectParameters(str);
    assertEquals("TEST3", ((String[])ht.get("test3"))[0]);
    assertEquals("TEST2", ((String[])ht.get("test2"))[0]);
    assertEquals("TEST1", ((String[])ht.get("test1"))[0]);
  }
}               // SampleEnhydraRedirectionTestCase



