package org.hamletsoft.enhydra.cactus.presentation.sample;

import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import java.util.Map;
import java.util.HashMap;
import java.util.Enumeration;
import javax.servlet.http.Cookie;

/**
 * SamplePO.java <br>
 * Test sample presentation object for Enhydra Testing framework using Jakarta Cactus.  
 *
 * Created: Thu Jan 31 11:29:30 2002
 *
 * @author <a href="mailto:hattori@hitachizosen.co.jp">Ryuji Hattori</a>
 * @version
 */

public class SamplePO implements HttpPresentation  {

    // public SamplePO (){;} 
    // implementation of com.lutris.appserver.server.httpPresentation.HttpPresentation interface

    public static final String Answer1 = "<html><head/><body>A GET request</body></html>";
    private String method = null;
    private Map headers = new HashMap();
    private Map params = new HashMap();
    private Map cookies = new HashMap();
    
    /**
     *
     * @param comms <description>
     * @exception java.lang.Exception <description>
     */
    public void run(HttpPresentationComms comms) throws Exception {
	
	method = comms.request.getMethod();
	
	for(Enumeration em = comms.request.getParameterNames();em.hasMoreElements();){
	    String key = (String)em.nextElement();
	    String value = comms.request.getParameter(key);
	    params.put(key, value);
	}
	for(Enumeration em = comms.request.getHeaderNames();em.hasMoreElements();){
	    String key = (String)em.nextElement();
	    String value = comms.request.getHeader(key);
	    headers.put(key, value);
	}
        Cookie[] cookieArray = comms.request.getCookies();
        if (cookieArray != null) {
            for (int i = 0; i < cookieArray.length; i++) {
                Cookie cookie = cookieArray[i];
                cookies.put(cookie.getName(), cookie.getValue());
            }
        }
	comms.response.writeHTML(Answer1);
    }
    
    public String checkMethod(){
	return method;
    }

    public Map getRequestParameters(){
	return params;
    }

    public String getRequestHeader(String name){
	return (String)headers.get(name);
    }

    public Map getRequestCookies(){
	return cookies;
    }

}// SamplePO
