/*
 * EncodingSampleApp 
 *
 * This type of presentation object could be the target of a form's 
 * submit button, process the data, and then decide where to send 
 * the user (back or on to the next page).
 *  
 */

package org.enhydra.encodingsample.presentation;

import org.enhydra.encodingsample.EncodingSampleSessionData;

import com.lutris.appserver.server.httpPresentation.*;

public class ServerRedirectPresentation implements HttpPresentation {
	
	private EncodingSampleSessionData sessionData = null;
	
	/*
	 * There is the only function needed in order to be a presentation object.
	 */
	public void run(HttpPresentationComms comms) throws Exception {
		
		initSessionData(comms);
		
		/*
		 * ServerPageRedirectException Option
		 */
		ServerPageRedirectException pageRedirect = new ServerPageRedirectException(
				"EncodingPresentation.po", sessionData.getEncoding());

		throw pageRedirect;
	}
	
	/**
	 * Method to get or create the SessionData object from the user session
	 * 
	 * @param comms
	 *            HttpPresentationComms
	 */
	protected void initSessionData(HttpPresentationComms comms) {
		try {
			Object obj = comms.sessionData
					.get(EncodingSampleSessionData.SESSION_KEY);
			// If we found the session data, save it in a private data member
			if (null != obj) {
				this.sessionData = (EncodingSampleSessionData) obj;
			} else {
				// If no session data was found, create a new session data
				// instance
				this.sessionData = new EncodingSampleSessionData();
				comms.sessionData.set(EncodingSampleSessionData.SESSION_KEY,
						this.sessionData);
			}
		} catch (Exception ex) {
			this.sessionData = new EncodingSampleSessionData();
		}
	}

}
