/**
 * A Swing-based AboutBox class.
 * <P>
 * @author Stefanovic Nenad, Bojanic Sasa
 * @Date:   July-November 2001.
 */

import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;


   /** Used to get the <b>about</b> information for the <b>TextEditor</b> applet,
    * and information of default parameters which are set by the <i>property file</i>.
   */
   public class InfoPanel extends JPanel {

   JLabel jLabel1 = new JLabel();
   JLabel jLabel2 = new JLabel();
   JLabel jLabel3 = new JLabel();
   JLabel jLabel4 = new JLabel();
   JLabel jLabel5 = new JLabel();
   JLabel jLabel6 = new JLabel();
   JLabel jLabel8 = new JLabel();
   JLabel jLabel9 = new JLabel();
   JLabel jLabel7 = new JLabel();
   JLabel jLabel10 = new JLabel();
   Border bord = new EtchedBorder();
   GridBagLayout gridBagLay = new GridBagLayout();

   JLabel jL;

   /**
    * Constructs a new instance of 'About' panel.
    */
   public InfoPanel() {
      try  {
            jbAbout();
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }
   /**
    * Constructs a new instance of 'ParameterInfo' panel.
	 * @param rb ResorceBoundle representing "main" property file context
    * @param lang String representing the abbreviation for language 
    * @param pf String representing the name of "main" property file
    * @param defHyph String representing the 'hyphenation language'        
    */
   public InfoPanel(ResourceBundle rb,String lang,String pf,String defHyph) {
      try  {
         jbParam(rb,lang,pf,defHyph);
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }
   /**
    * Initializes the state of this instance for "About".
    */
   private void jbAbout() throws Exception {
      jLabel4.setText("chupo@iis.ns.ac.yu");
      jLabel4.setFont(new Font("Dialog", 1, 12));
      jLabel1.setText("Authors:");
      jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
      jLabel2.setText("Stefanovic Nenad");
      jLabel2.setFont(new Font("Dialog", 1, 12));
      jLabel7.setText("Bojanic Sasa");
      jLabel7.setFont(new Font("Dialog", 1, 12));
      jLabel10.setText("Puskas Vladimir");
      jLabel10.setFont(new Font("Dialog", 1, 12));
      jLabel9.setText("FOP applet");
      jLabel9.setFont(new Font("Dialog", 3, 14));
      jLabel3.setText("e-mail:");
      jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
      jLabel5.setText("version:");
      jLabel5.setHorizontalAlignment(SwingConstants.RIGHT);
      jLabel6.setText("1.0");
      jLabel6.setFont(new Font("Dialog", 1, 12));
      this.setLayout(gridBagLay);
      this.add(jLabel9, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(2, 0, 5, 0), 0, 0));
      this.add(jLabel1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 8, 0, 5), 0, 0));
      this.add(jLabel2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
      this.add(jLabel7, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
      this.add(jLabel10, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
      this.add(jLabel3, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 8, 0, 5), 0, 0));
      this.add(jLabel4, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
      this.add(jLabel5, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 8, 0, 5), 0, 0));
      this.add(jLabel6, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0,
            GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));
      this.setBorder(bord);
   }
   /**
    * Initializes the state of this instance for "Parameter Info".
    * Reads the default values from <i>property file</i> and displays it along
    * with some other properties.
    * @param rb ResorceBoundle representing "main" property file context
    * @param lang String representing the abbreviation for language 
    * @param pf String representing the name of "main" property file
    * @param defHyph String representing the 'hyphenation language'        
    */
   private void jbParam(ResourceBundle rb,String lang,String pf,String defHyph) throws Exception {
			this.add(new JLabel(" 'Main' property file = "+pf+".properties "));
			this.add(new JLabel(" 'Language' property file = Text_"+lang+".properties "));
			this.add(new JLabel(" Height of lines = "+getResourceString("lineHeight",rb)));
			this.add(new JLabel(" Hyphenation language = "+defHyph));   
         String[] defKeys = TextEditor.tokenize(getResourceString("defvalues",rb));
			this.setLayout(new GridLayout(defKeys.length+4,1));
			for (int i=0; i<defKeys.length; i++)
				this.add(new JLabel(" "+defKeys[i]+" = "+getResourceString(defKeys[i],rb)));
			this.setBorder(bord);
   }
   /**
	 * Gets a resource string from the resource bundle.<p>
    * Resource bundle represents the <i>property file</i>. For example, if
    * property file contains something like this:<BR>
    * <CENTER>defFontFamily=SansSerif</CENTER>
    * method call getResourceString("defFontFamily",pf), where resource
    * boundle <b>pf</b> represents given <i>property file</i>,
    * will give the string <i>SansSerif</i> as a result.
	 * @param nm name of the resource to fetch.
	 * @param rb ResorceBoundle representing "main" property file context    
    * @return String value of named resource.
	 */
   protected String getResourceString(String nm,ResourceBundle rb) {
      String str;
      try {
         str = rb.getString(nm);
      }
      catch (MissingResourceException mre) {
      	str = null;
      }
      if (str != null) str=str.trim();      
      return str;
   }
}
