/*
 * fopes
 *
 * Enhydra super-servlet
 *
 */

package fops;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.lutris.logging.Logger;
import com.lutris.util.*;

import java.io.*;


/**
 * The application object.
 *
 * Application-wide data would go here.
 */
public class Fopes extends StandardApplication {

   File userConfigFile;
   
   protected String DEFAULT_FILE = "userconfig.xml";
   protected String FOP_BASE_DIR = "Config";
   
   String fopBaseDir;
    /*
     *  A few methods you might want to add to.
     *  See StandardApplication for more details.
     */
    public void startup(Config appConfig) throws ApplicationException {
        super.startup(appConfig);
        
        if (logChannel != null) {
            logChannel.write(Logger.INFO,
                             "Welcome to FopApplet Enhydra Application!");
        }
        
        //  Here is where you would read application-specific settings from
        //  your config file.

        String tempString = null;
        String file = null;
        File tempFile=null;
        
        // FopBaseDir parameter initialization
        
        try{
        	fopBaseDir = appConfig.getString("FopBaseDir");
            tempFile = new File(fopBaseDir+File.separator+FOP_BASE_DIR);
            if (!tempFile.exists()||!tempFile.isDirectory()){
            	// in case a relative path is given (relative from configuration file)
            	tempString = appConfig.getConfigFile().getFile().getParent();
            	fopBaseDir = tempString+File.separator+fopBaseDir;
            	tempFile = new File(fopBaseDir+File.separator+FOP_BASE_DIR);
            	
            	if (!tempFile.exists()||!tempFile.isDirectory()){
            		fopBaseDir = null;
            		if (logChannel != null) {
          	            logChannel.write(Logger.INFO,
          	                             "FopBaseDir application parameter not initialized - will be red from UserConfigFile!");
          	        }
            	}
            }
       } catch (ConfigException e) {
       		fopBaseDir = null;
       		if (logChannel != null) {
  	            logChannel.write(Logger.INFO,
  	            		"FopBaseDir application parameter not initialized - will be red from UserConfigFile!");
  	        }
       }
           
        // UserConfigFilePath parameter initialization
         
        try{
        	file = appConfig.getString("UserConfigFilePath");
        	userConfigFile = new File(file);

         if (!userConfigFile.exists()){
         	// in case a relative path is given (relative from configuration file)
         	tempString = appConfig.getConfigFile().getFile().getParent();
         	file = tempString+File.separator+file;
         	userConfigFile = new File(file);
         	
         	if (!userConfigFile.exists()){
         		try{
             		tempString = this.getClass().getClassLoader().getResource(DEFAULT_FILE).getPath();
             		file = tempString;
             		userConfigFile = new File(file);
         		} catch (NullPointerException exc){
         			file = DEFAULT_FILE;
         			userConfigFile = new File(file);
                	if (logChannel != null) {
                        logChannel.write(Logger.INFO,
                                         "UserConfigFilePath application parameter isn't properly initialized!");
                    }
         		}
         	}
         }
        } catch (ConfigException e) {
        	try{
         		tempString = this.getClass().getClassLoader().getResource(DEFAULT_FILE).getPath();
         		file = tempString;
         		userConfigFile = new File(file);
     		} catch (NullPointerException exc){
     			file = DEFAULT_FILE;
     			userConfigFile = new File(file);
            	if (logChannel != null) {
                    logChannel.write(Logger.INFO,
                                     "UserConfigFilePath application parameter isn't properly initialized!");
                }
     		}
        }
        
    }
    
    public boolean requestPreprocessor(HttpPresentationComms comms)
                   throws Exception {
        return super.requestPreprocessor(comms);
    }

    /**
     * This is an optional function, used only by the Multiserver's graphical
     * administration. This bit of HTML appears in the status page for this
     * application. You could add extra status info, for example
     * a list of currently logged in users.
     *
     * @return HTML that is displayed in the status page of the Multiserver.
     */
    public String toHtml() {
        return "This is <I>fopes</I>";
    }

   public File getUserConfigFile () {
      return userConfigFile;
   }
   
   public String getFopBaseDir () {
    return fopBaseDir;
 }
}

