/**
 * Servlet ServletEditor
 * <P>
 * @author: Stefanovic Nenad, Bojanic Sasa
 * @Date:   August 2001 - May 2003
 */

package fops.presentation;

import java.io.*;
import java.net.*;
import java.util.Date;
import java.text.DateFormat;

import org.apache.fop.apps.Driver;
import org.apache.fop.apps.Options;
import org.apache.fop.apps.Version;
import org.apache.fop.apps.XSLTInputHandler;
import org.apache.fop.messaging.MessageHandler;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import org.apache.avalon.framework.logger.ConsoleLogger;
import org.apache.avalon.framework.logger.Logger;

import fops.spec.*;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.*;


public class ServletEditor implements HttpPresentation {

   private Logger log = null;

   private String DateHTML = null;
   private String NameHTML = null;
   private String SubjHTML = null;
   private String AppletHTML = null;
   private String xmlParam =null;
   private String xslParam = null;
   private String foParam = null;

   private File userConfigFile;
   private String fopBaseDir;
   
   boolean noParams = false;

   public void run(HttpPresentationComms comms) throws Exception {
      if (log == null)
      {
         log = new ConsoleLogger(ConsoleLogger.LEVEL_WARN);
         MessageHandler.setScreenLogger(log);
      }

      xmlParam = comms.request.getParameter("xml");
      xslParam = comms.request.getParameter("xsl");
      foParam = comms.request.getParameter("fo");
      DateHTML=comms.request.getParameter("date");
      NameHTML=comms.request.getParameter("name");
      SubjHTML=comms.request.getParameter("subject");
      AppletHTML = comms.request.getParameter("context");

   
try{
	  RenderManager renderManager = RenderManagerFactory.getRenderManager("fops.business.RenderManagerImpl");

	  //User defined configuration file for embeded fonts
      userConfigFile=((fops.Fopes)comms.application).getUserConfigFile();
      //User defined configuration directory
      fopBaseDir=((fops.Fopes)comms.application).getFopBaseDir();
      Options options = new Options(userConfigFile);
      
      if (fopBaseDir!=null)
      	org.apache.fop.configuration.Configuration.put("baseDir",fopBaseDir);

      if((xmlParam != null) && (xslParam != null)){
      	//Rendering a PDF from XML+XSL files
         System.out.println("PDF from XML: "+xmlParam+" and XSL: "+xslParam);
                  

        byte[] content = renderManager.renderXML(xmlParam,xslParam,log);
        comms.response.setContentType("application/pdf");
        comms.response.setContentLength(content.length);
		comms.response.getOutputStream().write(content);
		comms.response.getOutputStream().flush();
		

      }else if(foParam !=null){
      	// Rendering a PDF from FO file
        
        
        byte[] content = renderManager.renderFOFile(foParam,log);
        comms.response.setContentType("application/pdf");
        comms.response.setContentLength(content.length);
		comms.response.getOutputStream().write(content);
		comms.response.getOutputStream().flush();

		}else if(DateHTML!=null || NameHTML!=null || SubjHTML!=null || AppletHTML!=null){
      	// Rendering a PDF from applet parameters
        
      byte[] content = renderManager.renderFO(noParams,DateHTML,NameHTML,SubjHTML,AppletHTML,log);
      comms.response.setContentType("application/pdf");
      comms.response.setContentLength(content.length);
	  comms.response.getOutputStream().write(content);
	  comms.response.getOutputStream().flush();
                  
   	}else{
			System.out.println("There is no any request parameter given!!!");
			noParams = true;
        
          byte[] content = renderManager.renderFO(noParams,DateHTML,NameHTML,SubjHTML,AppletHTML,log);
      comms.response.setContentType("application/pdf");
      comms.response.setContentLength(content.length);
	  comms.response.getOutputStream().write(content);
	  comms.response.getOutputStream().flush();
         
      
    }
}catch(NullPointerException e){
	throw new ClientPageRedirectException("IndexPO.po");
	}
}
  }

