/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

/** 
 * This class is used to associate quantities with items.  When you ask the
 * cart for it's contents, you get an enumeration of these objects. The cart
 * object its self also uses these objects, thus the use of protected methods.
*/
package golfShop.business.cart;

import java.lang.Cloneable;
import golfShop.business.item.*;
import golfShop.spec.cart.*;

import golfShop.business.item.*;

public class CartItemPairImpl implements CartItemPair,java.io.Serializable{
    private CartItem item;
    private int quantity;

    // Constructor. Only my package-mates can create me.
    protected CartItemPairImpl(CartItem item, int quantity) {
        this.item = item;
        this.quantity = quantity;
    }
    
    public CartItem getItem() {
        return item;
    }

    public int getQuantity() {
        return quantity;
    }

    // Only my package-mates can modify me.
    protected void setQuantity(int quantity) {
        this.quantity = quantity;
    }

    // Only my package-mates can modify me.
    protected void addToQuantity(int more) {
        this.quantity += more;
    }

    // Make a copy of ourselfs. Both coppies will point to the same
    // CartItem, but they will have distinct quantaties.
    protected CartItemPairImpl copy() {
        return new CartItemPairImpl(this.item, this.quantity);
    }

    /**
     * Generate information for debugging.
     */
    public String toString() {
        return item.toString() + "(" + quantity + ")";
    }
}

