/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.business.item;


import golfShop.data.item.ItemDO;
import golfShop.spec.cart.CartItem;
/**
 */
public class Item implements CartItem, java.io.Serializable {
    private ItemDO itemDO;
   
    static public Item getItem(long ObjectId) {
	return new Item(ItemDO.getItemByObjectId(ObjectId));
    }
 
    /**
     * Constructor
     * 
     * @param itemDO An ItemDO data object. 
     */ 
    public Item(ItemDO itemDO) {
	this.itemDO = itemDO;
    }

    public String getName() {
	return itemDO.getName();
    }

    // needs error-checking
    public void setName(String name) {
	itemDO.setName(name);
    }

    public String getDescription() {
	return itemDO.getDescription();
    }

    // needs error-checking
    public void setDescription(String description) {
	itemDO.setDescription(description);
    }

    public long getObjectId()
    {
	return itemDO.getObjectId();
    }

    public double getPrice()
    {
	return itemDO.getPrice();
    }

    // needs error-checking
    public void setPrice(double price)
    {
	itemDO.setPrice(price);
    }

    /*
     * Generate info for debugging.
     */
    public String toString() {
        return getName() + "|"
            + getDescription() + "|"
            + getObjectId() + "|"
            + getPrice();
    }
}
