/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.business.item;



import golfShop.business.cart.CartItemQuery;

import golfShop.spec.cart.*;
/**
	This object is the glue between the shopping cart, which needs an
	object it can use to lookup Objectids, and the Item buiness objects, 
	which has a class method that can do just that.
 */
public class ItemQuery implements CartItemQuery, java.io.Serializable {
	//
	// All shopping cart hold pointers to this object.
	//	
	public static final ItemQuery global = new ItemQuery();

	// Only let the one static object be created. More is a waste of memory.
	private ItemQuery() {
	}
  
	// This is how the shopping cart talks to the Item class. 
	public CartItem getItem(long ObjectId) {
		return (CartItem) Item.getItem(ObjectId);
	}
}

