/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import java.io.*;
import java.util.*;
import com.lutris.util.Config;
import com.lutris.util.ConfigException;
import com.lutris.logging.Logger;
import com.lutris.logging.LogChannel;
import com.lutris.appserver.server.Enhydra;
import golfShop.data.item.CategoryDO;
import golfShop.data.item.CategoryStore;


/**
 *
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public class CategoryStoreFile extends CategoryStore {

    /*----------------------------------------------------------------------*/
    // Class Data
    /*----------------------------------------------------------------------*/
    
    private static Vector allCategories = new Vector();

    /*----------------------------------------------------------------------*/
    // Class Methods
    /*----------------------------------------------------------------------*/
   protected void initializeCategoryStore() {
     
   }
    protected void initializeCategoryStore(String dir) {

    // Create the top level directory
    CategoryDO newCategory = new CategoryDO(0, 0, "Main Menu");
    allCategories.addElement(newCategory);

    // Fill in the subcategories
    dirList(dir,newCategory, "");
    }


    protected boolean isCategoryInStore(long findId) {
    Enumeration e = allCategories.elements();
    while (e.hasMoreElements()) {
        CategoryDO c = (CategoryDO) e.nextElement();
        if (c.getObjectId() == findId)
        return true;
    }
    return false;
    }

    protected CategoryDO findCategoryInStore(long findId) {
    Enumeration e = allCategories.elements(); 
    while (e.hasMoreElements()) {
        CategoryDO c = (CategoryDO) e.nextElement();
        if (c.getObjectId() == findId) {
        return c;
            }
    }
    return null;
    }

    /*----------------------------------------------------------------------*/
    // Private Methods
    /*----------------------------------------------------------------------*/
    private static int nextObjectId = 1;

 private static void dirList (String root, CategoryDO pc, String dir) {
 
    String names[] = new String[0]; // list of files in a diretory
    String filename;
    File    path, fpath;

  
 
    path = new File(root + 
            ((dir.length())>0 ? File.separator + dir : ""));

    // get list of files in this dir
    names = path.list();
        if (names == null) {
            return;
        }
    for (int i=0; i < names.length; i++) {
        filename = root +
            ((dir.length())>0 ? File.separator + dir : "") +
            File.separator + names[i];
        
        fpath = new File(filename);
        if (fpath.isDirectory()) {
        CategoryDO newCategory = new CategoryDO(nextObjectId++, 
                            pc.getObjectId(),
                            names[i]);
    
        allCategories.addElement(newCategory);

        // recursively descend dir tree
        dirList(root, newCategory, dir+File.separator+names[i]);
        }
            if (fpath.isFile()) {
        pc.addItem(Long.parseLong(names[i]));
        }
        
    }
    }
    
}
