/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import java.util.Vector;
import java.util.Enumeration;
import golfShop.data.item.CategoryDO;
import golfShop.data.item.CategoryStore;



/**
 * This is one flavor of a CategoryStore. The storage medium in this case
 * is memory. 
 * 
 * A item list is kept in memory. When the application exits,
 * all the items are lost.
 *
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public class CategoryStoreMemory extends CategoryStore 
{ 
    /*----------------------------------------------------------------------*/
    // Data
    /*----------------------------------------------------------------------*/
    /* 
     * This is the storage medium. Keep a set of categories in memory.  
     */ 
    private Vector allCategories = new Vector(); 

    /*----------------------------------------------------------------------*/
    // Methods
    /*----------------------------------------------------------------------*/
    /*
     * Initialize the set of items.  
     */ 
    protected void initializeCategoryStore(String dir)
    {}
    protected void initializeCategoryStore()
    { 
                             // <objectid> <parentid> <Name> 
    CategoryDO main = new CategoryDO (0, 0, "Main Menu");
    allCategories.addElement(main);
    main.addItem(1);

    CategoryDO tech = new CategoryDO (1, 0, "High Tech");
    allCategories.addElement(tech);
    tech.addItem(2);
    tech.addItem(3);
    tech.addItem(4);

    CategoryDO cds = new CategoryDO (2, 0, "CD Companies");
    allCategories.addElement(cds);
    cds.addItem(5);
    cds.addItem(6);

    CategoryDO finance = new CategoryDO(3, 0, "Financial Institutions");
    allCategories.addElement(finance);

    CategoryDO banks = new CategoryDO(4, 3, "Banks");
    allCategories.addElement(banks);
    banks.addItem(7);
    banks.addItem(8);
    banks.addItem(9);

    CategoryDO brokers = new CategoryDO(5, 3, "Brokers");
    allCategories.addElement(brokers);
    brokers.addItem(10);
    }

    protected boolean isCategoryInStore(long findId) 
    {
    Enumeration e = allCategories.elements(); 
    while (e.hasMoreElements()) 
    {
        CategoryDO c = (CategoryDO) e.nextElement();
        if (c.getObjectId() == findId)
        return true;
    }
    return false;
    }

    protected CategoryDO findCategoryInStore(long findId) 
    {
    Enumeration e = allCategories.elements(); 
    while (e.hasMoreElements()) 
    {
        CategoryDO c = (CategoryDO) e.nextElement();
        if (c.getObjectId() == findId)
        return c;
    }
    return null;
    }
}
