/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import java.util.Vector;
import java.util.Enumeration;


/**
 * Individual items for sale.
 *
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public class ItemDO implements java.io.Serializable
{
    /*----------------------------------------------------------------------*/
    // Class Data
    /*----------------------------------------------------------------------*/
    private static ItemStore	storage = null;

    /*----------------------------------------------------------------------*/
    // Class Methods
    /*----------------------------------------------------------------------*/

    /*
     * Determine the store media selected for the category and item database
     */


public static void InitializeStorageOption(String opt,String dir) 
  {
	try 
	{
  if (opt.equalsIgnoreCase("memory"))
	   {	
		storage = new ItemStoreMemory();
	        storage.initializeItemStore();
	    }
	    else if (opt.equalsIgnoreCase("file"))
	    { 
	    	storage = new ItemStoreFile();
	        storage.initializeItemStore(dir);
	    }
	    else
	    {
		storage = new ItemStoreMemory();
	        storage.initializeItemStore();
	    }
	} catch (Exception e)
	{
	}
  	
  	
  }




    /**
     * Constructor.  
     */ 
    protected ItemDO(long objectid, String SKU, double price, 
		    String name, String desc)
    {

	this.objectid = objectid;
	this.SKU = SKU;
	this.price = price;
	this.name = name;
	this.desc = desc;
    }

    // TODO - delete this method

    /*
     * Find the item with the given object id.
     */
    public static ItemDO getItemByObjectId(long objectId)
    {

	return(storage.findItemInStore(objectId));
    }

    /*----------------------------------------------------------------------*/
    // Instance Data
    /*----------------------------------------------------------------------*/
    private long 	objectid ;	// Application index
    private String 	SKU ;		// Corporate index
    private double 	price ;		// Item cost
    private String 	name ;		// Human-readable
    private String 	desc ;		// Description or location of desc

    /*----------------------------------------------------------------------*/
    // Instance Methods
    /*----------------------------------------------------------------------*/

    public long getObjectId()
    {
	return this.objectid;
    }
    // This is a key so it shouldn't be changed by anyone.
    protected void setObjectId(long newId)
    {
	this.objectid = newId;
    }

    public String getSKU()
    {
	return this.SKU;
    }
    public void setSKU(String newSKU)
    {
	this.SKU = newSKU;
    }

    public double getPrice()
    {
	return this.price;
    }
    public void setPrice(double newPrice)
    {
	this.price = newPrice;
    }

    public String getName()
    {
	return this.name;
    }
    public void setName(String newName)
    {
	this.desc = newName;
    }

    public String getDescription()
    {
	return this.desc;
    }
    public void setDescription(String newDesc)
    {
	this.desc = newDesc;
    }

    /*----------------------------------------------------------------------*/	
    // Private Methods
    /*----------------------------------------------------------------------*/	
}
