/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import golfShop.data.item.ItemDO;


/**
 * This abstract class defines the template for the tree kinds of item 
 * stores: memory, file and database.
 * This object represents the physical medium that the list of all store items 
 * is stored in. Only the ItemDO class needs to access this class.
 * 
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public abstract class ItemStore implements java.io.Serializable
{
    //If user store option is memory
    protected abstract void	initializeItemStore() ;
    //If user store option is File we need directory
    protected abstract void	initializeItemStore(String dir) ;
    protected abstract boolean	isItemInStore(long thisId);
    protected abstract ItemDO	findItemInStore(long thisId);
}

