/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import java.io.*;
import java.util.*;
import java.lang.Double;
import com.lutris.logging.Logger;
import com.lutris.logging.LogChannel;
import com.lutris.appserver.server.Enhydra;
import com.lutris.util.Config;
import com.lutris.util.ConfigException;
import golfShop.data.item.ItemDO;
import golfShop.data.item.ItemStore;


/**
 *
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public class ItemStoreFile extends ItemStore 
{

    /*----------------------------------------------------------------------*/
    // Class Data
    /*----------------------------------------------------------------------*/
   
    private static Vector allItems = new Vector();

    /*----------------------------------------------------------------------*/
    // Class Methods
    /*----------------------------------------------------------------------*/
   protected void initializeItemStore()
    {}
   
    protected void initializeItemStore(String dir)
    {


    // Find all items in the inventory tree
    findAllItems(dir, "");
    }


    protected boolean isItemInStore(long findId) 
    {
    Enumeration e = allItems.elements();
    while (e.hasMoreElements())
    {
        ItemDO c = (ItemDO) e.nextElement();
        if (c.getObjectId() == findId)
        return true;
    }
    return false;
    }

    protected ItemDO findItemInStore(long findId) 
    {
    	
    Enumeration e = allItems.elements(); 
    while (e.hasMoreElements()) 
    {
        ItemDO c = (ItemDO) e.nextElement();
        if (c.getObjectId() == findId)
        return c;
    }
    return null;
    }

    /*----------------------------------------------------------------------*/
    // Private Methods
    /*----------------------------------------------------------------------*/

    private static void findAllItems (String root, String dir)
    {
    String names[] = new String[0]; // list of files in a diretory
    String filename;
    File    path, fpath;

    
    path = new File(root + 
            ((dir.length())>0 ? File.separator + dir : ""));

    // get list of files in this dir
    
    
    names = path.list();
  
    for (int i=0; i < names.length; i++)
    { 
        filename = root +
            ((dir.length())>0 ? File.separator + dir : "") +
            File.separator + names[i];
        
        fpath = new File(filename);
        if ( fpath.isDirectory() )
        {
        // recursively descend dir tree
        findAllItems(root, dir+File.separator+names[i]);
        }
        if ( fpath.isFile() )
        {
        try
        {

            // Read details from file
            BufferedReader br = new BufferedReader(new FileReader(filename));

            allItems.addElement(new ItemDO(
                        (Long.parseLong(names[i])),
                        br.readLine(),
                        (Double.valueOf(br.readLine())).doubleValue(),
                        br.readLine(),
                        br.readLine()));
        } catch (Exception ioErr) {
            LogChannel chan = Enhydra.getLogChannel();
            if (chan != null)
                chan.write(Logger.ERROR, "Error reading products.\n" +
                           "Couln't open file " + filename);
            }
        }
        
    }
    }
    
}
