/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.item;

import java.util.Vector;
import java.util.Enumeration;
import golfShop.data.item.ItemDO;
import golfShop.data.item.ItemStore;



/**
 * This is one flavor of a ItemStore. The storage medium in this case
 * is memory. 
 * 
 * A item list is kept in memory. When the application exits,
 * all the items are lost.
 *
 * @author Scott Pirie
 * @version $Revision: 1.1 $
 */
public class ItemStoreMemory extends ItemStore 
{

    /*---------------------------------------------------------------------*/
    // Class Data
    /*---------------------------------------------------------------------*/
    /*
     *  This is the storage medium. Just keep a set of items in memory.
     */
    private Vector allItems = new Vector();

    /*---------------------------------------------------------------------*/
    // Instance Methods
    /*---------------------------------------------------------------------*/
    /*
     * Initialize the set of items.
     */
     protected void initializeItemStore(String dir)
    {}
    protected void initializeItemStore()
    {
    // <objectid> <SKU> <price> <name> <description>
    ItemDO i;

    i = new ItemDO(1, "1", 1.1, "Lutris", "http://www.lutris.com");
    allItems.addElement(i);

    // High Tech Companys
    i = new ItemDO(2, "2", 1.2, "SCO", "http://www.sco.com");
    allItems.addElement(i);

    i = new ItemDO(3, "3", 1.3, "SIII", "http://www.siii.com");
    allItems.addElement(i);
    i = new ItemDO(4, "4", 1.4, "COMS", "http://www.3com.com");
    allItems.addElement(i);

    // Music Companies
    i = new ItemDO(5, "5", 1.5, "BMG", 
                "http://www.bmgmusicservice.com");
    allItems.addElement(i);
    i = new ItemDO(6, "6", 1.6, "CD-NOW", 
                "http://www.cdnow.com");
    allItems.addElement(i);

    // Financial Companies
        // Banks
        i = new ItemDO(7, "7", 1.7, "Wells Fargo", 
                        "http://www.wellsfargo.com");
        allItems.addElement(i);
        i = new ItemDO(8, "8", 1.8, "Citibank", 
                        "http://www.citibank.com");
        allItems.addElement(i);
        i = new ItemDO(9, "9", 1.9, "Great West", 
                        "http://www.greatwest.com");
        allItems.addElement(i);
        // Stock Brokers
        i = new ItemDO(10, "10", 1.10, "Etrade", 
                        "http://www.etrade.com");
        allItems.addElement(i);
    }

    protected boolean isItemInStore(long findId) 
    {
    Enumeration e = allItems.elements(); 
    while (e.hasMoreElements()) 
    {
        ItemDO i = (ItemDO) e.nextElement();
        if (i.getObjectId() == findId)
        return true;
    }
    return false;
    }

    protected ItemDO findItemInStore(long findId) 
    {
    Enumeration e = allItems.elements(); 
    while (e.hasMoreElements()) 
    {
        ItemDO i = (ItemDO) e.nextElement();
        if (i.getObjectId() == findId)
        return i;
    }
    return null;
    }
}
