/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.data.user;

import golfShop.data.user.UserDOImpl;


/**
 * This abstract class defines the template for the tree kinds of user 
 * stores: memory, file and ldap.
 * This object represents the physical medium that the list of all users is
 * stored in. Only the UserDOImpl class needs to access this class.
 * 
 * @author Andrew John
 * @version $Revision: 1.1 $
 */
public abstract class UserStore {

   //If user store option is memory
    protected abstract void initializeUserStore();
    //If user store option is File we need file name
    protected abstract void initializeUserStore(String fn);

    protected abstract boolean usernameInUserStore(String username);
    protected abstract UserDOImpl lookupUserFromUserStore(String username);
    protected abstract void addUserToUserStore(UserDOImpl user);
    protected abstract void updateUserInUserStore(UserDOImpl user);

}

