/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: ErrorHandler.java,v 1.1 2004/08/16 09:45:47 slobodan Exp $
 */

package golfShop.presentation.xmlc;

import org.enhydra.xml.xmlc.*;
import org.enhydra.xml.xmlc.html.*;
import com.lutris.logging.*;
import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import org.w3c.dom.*;
import golfShop.presentation.xmlc.utilities.*;

/**
 * Error handler presentation for GolfShop.  This logs the error and
 * displays a friendly screen to the used.
 */
public class ErrorHandler implements HttpPresentation {
    /**
     * Entry.
     */
    public void run(HttpPresentationComms comms)
        throws HttpPresentationException {

        LogChannel chan = Enhydra.getLogChannel();
        chan.write(Logger.ERROR, "application error", comms.exception);
        ErrorHandlerHTML htmlObj = (ErrorHandlerHTML)comms.xmlcFactory.create(ErrorHandlerHTML.class);
        comms.response.writeDOM(htmlObj);
    }
}
