/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.presentation.xmlc.cart;

import org.w3c.dom.*;
import org.w3c.dom.html.*;

/**
 * Interface for XMLC compiled pages containing the cart table.
 */
public interface ContentsTable extends HTMLDocument {
    /**
     * Get the value of element <CODE>itemTable</CODE>.
     * @see HTMLTableElement
     */
    public HTMLTableElement getElementItemTable();
    
    /**
     * Get the value of element <CODE>headerRow</CODE>.
     * @see HTMLTableRowElement
     */
    public HTMLTableRowElement getElementHeaderRow();
    
    /**
     * Get the value of element <CODE>protoRow</CODE>.
     * @see HTMLTableRowElement
     */
    public HTMLTableRowElement getElementProtoRow();
    
    /**
     * Get the value of element <CODE>costRow</CODE>.
     * @see HTMLTableRowElement
     */
    public HTMLTableRowElement getElementCostRow();
    
    /**
     * Set the first child text node of the element <CODE>cost</CODE>.
     */
    public void setTextCost(String str);
}
