/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.presentation.xmlc.login;

import org.enhydra.xml.xmlc.*;
import org.enhydra.xml.xmlc.html.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import java.io.*;
import org.w3c.dom.*;
import org.w3c.dom.html.*;
import golfShop.GolfShop;
import golfShop.spec.user.*;
import golfShop.presentation.xmlc.utilities.*;


/**
 * This presentation object dynamically creates an HTML page showing 
 * that the user is logged out.  A button allows the user to login again.
 */
public class Logout implements HttpPresentation {
    /**
     * Entry.
     */
    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, IOException, SessionException {

        GolfShop application = (GolfShop)comms.application;
        GolfShopUserManager userManager = application.getUserManager();
       try{
        userManager.logout(comms.session);
/* 
 * We need  to allow GolfShop_pres to be functional 
 */ 
   
    } catch(NullPointerException ex) { 
       }
        LogoutHTML htmlObj
            = (LogoutHTML)comms.xmlcFactory.create(LogoutHTML.class);
        comms.response.writeDOM(htmlObj);
    }
}
