/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * 
 */

package golfShop.spec;

/**
 * An exception representing a login service refusal.
 * The reason for refusal is indicated by the "reason" member.
 *
 * @author	John Marco
 * @author	Shawn McMurdo
 * @version	$Revision: 1.1 $
 */
public class LoginException extends Exception {
    /**
     * Indicates the reason why this exception was thrown.
     */
    public int reason;
    
    /**
     * LoginException constructor.  Sets the reason
     * field to the reason indicated;
     * 
     * @param reason The numeric reason code for this exception.
     */
    public LoginException(int reason) {
        super("login failed: reason = " + reason);
	this.reason = reason;
    }
}

