/*
 *  JivanExample
 *
 *  Enhydra super-servlet presentation object
 *
 */

package org.enhydra.jivan.test.presentation;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import java.util.*;
import org.enhydra.util.jivan.JivanSimpleXMLObjectImpl;

import org.jivan.html.document.*;
import org.jivan.html.util.DOMUtil;
import org.jivan.apache.xerces.xni.parser.XMLInputSource;
import org.w3c.dom.html.HTMLAnchorElement;
import java.net.URL;
import com.lutris.logging.Logger;
import org.enhydra.jivan.test.JivanExample;

import java.io.File;

// Enhydra SuperServlet specification imports
import org.enhydra.jivan.test.spec.*;

// Standard imports
import java.io.IOException;

public class WelcomePresentation implements HttpPresentation {


    public void run(HttpPresentationComms comms)
        throws HttpPresentationException {

      String protocol = "";
      try {
        protocol = JivanExample.rootPath + File.separator + comms.application.getConfig().getString("UserParameter.Jivan.ResourcesPath");
        protocol = "file:///" + protocol + "/Welcome.html";
        
        //URL url = this.getClass().getClassLoader().getResource("org/enhydra/jivan/test/resources/Welcome.html");
        //protocol = url.getProtocol() + "://" + url.getFile();

        //String protocol = System.getProperty("user.dir");
        //protocol = "file:///" + protocol + "resources/Welcome.html";
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }

      comms.jivanFactory.getLogger().write(Logger.INFO, "Loaded resources is: " + protocol); // logging
      DocumentManager man = comms.jivanFactory.docManFor(protocol);

      String datetime;
        try {
          Dater dater = DaterFactory.createDater("org.enhydra.jivan.test.business.DaterImpl");
          datetime = dater.getDate();
        }
        catch (Exception ex){
            System.out.println("Exception: "+ex);
            datetime="Could not get business object!!!";
        }

      DOMUtil.setTextChild(man.lookup("time"), datetime);
      HTMLAnchorElement link = (HTMLAnchorElement) man.lookup("link");
      link.setHref("RedirectPresentation.po");

      JivanSimpleXMLObjectImpl xmlObject = new JivanSimpleXMLObjectImpl();
      xmlObject.setDocument(man, "UTF-8");
      comms.response.writeDOM(xmlObject);
    }

}
