/*
 * Enhydra Java Application Server Project
 * 
 
 * 
 * Contributor(s):
 * 
 * $Id: Welcome.java,v 1.1 2004/08/16 10:50:22 slobodan Exp $
 */

package com.lutris.appserver.welcome.presentation;

//dr2806 import com.lutris.xml.xmlc.*;
//dr2806 import com.lutris.xml.xmlc.html.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.lutris.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.w3c.dom.html.*;

/**
 * Output the welcome page.
 */
public class Welcome implements HttpPresentation {
    /*
     * Used to keep track of the total number of times this page has been
     * served.
     */
    private static int counter = 0;

    /*
     * Set counters in the page.
     */
    public void setCounters(Session session,
                            WelcomeHTML htmlObj)
        throws KeywordValueException {
        /*
         * Fill the tag that holds the total number of times this page has
         * been served, to all users. We use a static variable to hold this
         * information.
         */
        counter++;
        htmlObj.setTextTotalHits(Integer.toString(counter));

        /*
         * Fill in the tag that holds the number of times this user
         * has been served this page. Since this is a per-user thing, 
         * we use session data. The first time a user loads this page,
         * the session data will not contain the counter, treat this
         * as if the counter was zero.
         */
        SessionData sessionData = session.getSessionData();
        String userCounterString = sessionData.getString("counter");
        int userCounter = 0;
        if (userCounterString != null) {
            userCounter = Integer.parseInt(userCounterString);
        }
        userCounter++;
        userCounterString = Integer.toString(userCounter);
        sessionData.set("counter", userCounterString);

        htmlObj.setTextUserHits(userCounterString);
    }

    /**
     * Entry.
     */
    public void run(HttpPresentationComms comms)
        throws HttpPresentationException {
        try {
            WelcomeHTML htmlObj
                = (WelcomeHTML)comms.xmlcFactory.create(WelcomeHTML.class);
            setCounters(comms.session, htmlObj);
            comms.response.writeHTML(htmlObj);
        } catch (KeywordValueException except) {
            throw new HttpPresentationException(except);
        }
    }   
}
