package org.enhydra.wlh.presentation;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import org.enhydra.wlh.WorkListHandler;
import org.enhydra.wlh.business.WHLTools;
import org.enhydra.wlh.business.XMLBuilderImpl;
import org.enhydra.wlh.presentation.session.UserImp;
import org.enhydra.wlh.presentation.utils.NavigConsts;
import org.enhydra.wlh.presentation.utils.ParamConsts;
import org.enhydra.wlh.spec.TransformManager;
import org.enhydra.wlh.spec.TransformManagerFactory;
import org.enhydra.wlh.spec.User;
import org.enhydra.xml.xmlc.XMLObject;
import org.w3c.dom.CDATASection;

import com.lutris.appserver.server.httpPresentation.ClientPageRedirectException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.appserver.server.httpPresentation.HttpPresentationOutputStream;

public class WorklistHandlerPO extends BasePO {

	BaseHTML htmlPage = null;
	String xslSheme=null;

	public XMLObject handleDefault() throws HttpPresentationException {
		return showPage();
	}

	public XMLObject handleComplete() throws HttpPresentationException {

		
		try {
			
		String procId = myComms.request.getParameter(ParamConsts.PROCESS_ID);
		String actId = myComms.request.getParameter(ParamConsts.ACTIVITY_ID);
		
		if(actId!=null && !actId.equals("") && procId!=null && !procId.equals(""))
		WHLTools.completeActivity(procId,actId,mySessionData.getUser());
		
		
		} catch (Exception e) {
			
			throw new PresentationException("Error wile compliting activiti",e);
		}
		

	
		return showPage();
	}

	protected boolean loggedInUserRequired() {
		return false;
	}

	private XMLObject showPage() throws HttpPresentationException {

		htmlPage = (BaseHTML) myComms.xmlcFactory.create(BaseHTML.class);
		try {
			
			
			xslSheme = myComms.request.getParameter(ParamConsts.XSL);
			
		    if (xslSheme == null) {    	
				xslSheme = "default";
		    }
		    
			
			String xslDir = WorkListHandler.getXslDirectory();

			User user =super.mySessionData.getUser();
			
			String pro_Id = myComms.request.getParameter(ParamConsts.PROCESS_ID);
			String act_Id = myComms.request.getParameter(ParamConsts.ACTIVITY_ID);
			String activity=myComms.request.getParameter(ParamConsts.ACTIVITY);
			

			XMLBuilderImpl xmlImp = new XMLBuilderImpl(user, pro_Id, act_Id);
			//String xml = xmlImp.getResult();
			String finall = null;
		if(!xslSheme.equals("none")) {
				String resultXML = null;
				
				
				if(activity!=null && activity.equals("yes")){
					resultXML=xmlImp.getResult(1);
				}else{
					resultXML=xmlImp.getResult(0);
				}
				

				TransformManager manager = TransformManagerFactory.getTransformManager("org.enhydra.wlh.business.TransformManagerImpl");

				finall = manager.transform(resultXML, xslDir + "/" + xslSheme + ".xsl");

			} else {
				myComms.response.setContentType("text/xml");
				HttpPresentationOutputStream os = myComms.response.getOutputStream();
				
				if(activity!=null && activity.equals("yes")){
					xmlImp.writeResult(os,1);
				}else{
					xmlImp.writeResult(os,0);
				}
				
				myComms.response.flush();
				return null;
			}

			CDATASection cdata = htmlPage.createCDATASection(finall);

			htmlPage.getElementContent().appendChild(cdata);

			return htmlPage;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new PresentationException("Can't show page", ex);
		}
	}
	
public XMLObject handleAccepted() throws HttpPresentationException {

		
		try {
		String procId = myComms.request.getParameter(ParamConsts.PROCESS_ID);
		String actId = myComms.request.getParameter(ParamConsts.ACTIVITY_ID);
		String accepted=myComms.request.getParameter(ParamConsts.ACCEPTED);
		WHLTools.acceptedActivity(procId,actId,accepted,mySessionData.getUser());
		
		} catch (Exception e) {
			
			
		}
		

		return showPage();
	}


public XMLObject handleUpdate() throws HttpPresentationException {
	this.htmlPage = (BaseHTML) myComms.xmlcFactory.create(BaseHTML.class);
	try {
	Map map = extractValuesFromHttp(myComms);
	String procId = myComms.request.getParameter(ParamConsts.PROCESS_ID);
	String actId = myComms.request.getParameter(ParamConsts.ACTIVITY_ID);
	
		WHLTools.setResult(map,mySessionData.getUser(),procId,actId);
	} catch (Exception e) {
		
		throw new PresentationException("Problems while updating variables !!!",e);
	}
	throw new ClientPageRedirectException(NavigConsts.CLOSE_WINDOW);

}

private Map extractValuesFromHttp(HttpPresentationComms comms) {

	Map map = new HashMap();

	try {
		Enumeration enu = comms.request.getParameterNames();
		String name = null;
		String value = null;

		while (enu.hasMoreElements()) {
			name = (String) enu.nextElement();
			if (name.startsWith(ParamConsts.VARIABLE_PREFIX)) {
				value = (String) comms.request.getParameter(name);
				map.put(name.substring(ParamConsts.VARIABLE_PREFIX.length()), value);

			}

		}

	
	} catch (Exception ex) {
		ex.printStackTrace();

	}

	return map;
}


}
