package org.enhydra.wlh.presentation.session;

import java.io.Serializable;

import org.enhydra.wlh.spec.User;

public class SessionData  implements Serializable{

	/**
	 * Current user
	 */
	private User currentUser = null;

	/**
	 * New session user. This object is null until some user data (as username or
	 * password) need to be changed. Then this object holds the new data until
	 * the method for user data replace is invoked.
	 */
	private User newUser = null;

	/**
	 * Session key to save session data for application in the session
	 */
	public static final String SESSION_KEY = "WLHSessionData";

	

	/**
	 * Constructs a empty session data object.
	 */
	public SessionData(User user) {
		this.currentUser = user;

	}

	/**
	 * Returns current user
	 * @return User object
	 */
	public User getUser() {
		if (this.newUser != null) {
			this.currentUser = this.newUser;
			this.newUser = null;
		}
		return this.currentUser;
	}

	/**
	 * Sets the new SessionUser object to temporary value
	 */
	public void setNewUser(UserImp newSes) {
		this.newUser = newSes;
	}

	/**
	 * Method to remove the current user from the session
	 */
	public void removeUser() {

		this.currentUser = null;
	}

}
