/*
 *  calculator
 *
 *  Enhydra super-servlet specification object
 *  
 */

package calculator.business;


import calculator.spec.State;

// Enhydra SuperServlet imports
import com.lutris.util.KeywordValueException;
import com.lutris.appserver.server.session.*;


public class StateImpl implements State{
//DigitsChack
 public String checkDigits(SessionData sd)throws KeywordValueException
  {
    String digits = (String) sd.get("digits");

    if (digits == null)
      digits = "0";
 
    // If it's an integer, don't show the decimal point.
    if (digits.endsWith(".0"))
        digits = digits.substring(0, digits.length()-2);
    
    
    // If it's too long to show, trim it or just show 0.
    // An error indication would be nice to add (hint hint... :)
      
    if (digits.indexOf(".") != -1) {
      if (digits.length() > 6)
         {
      digits=digits.substring(0,7);
       
         int dot= digits.indexOf(".");
      
      if(dot==6)  
         digits = digits.substring(0,6);
          
       }         
    } else {
      if (digits.length() > 7)
        digits = "0"; // Overflow.
     }
    
    return digits;
  }


public String convertDigitsToHTML(String digits)
  {
   // Convert the string of digits to HTML.
    String digitHtml = "";
    for (int i=0; i<digits.length(); i++) {
      char c = digits.charAt(i);
      if (c == '0')
        digitHtml += "<img src=media/zero.jpeg>";
      else if (c == '1')
        digitHtml += "<img src=media/one.jpeg>";
      else if (c == '2')
        digitHtml += "<img src=media/two.jpeg>";
      else if (c == '3')
        digitHtml += "<img src=media/three.jpeg>";
      else if (c == '4')
        digitHtml += "<img src=media/four.jpeg>";
      else if (c == '5')
        digitHtml += "<img src=media/five.jpeg>";
      else if (c == '6')
        digitHtml += "<img src=media/six.jpeg>";
      else if (c == '7')
        digitHtml += "<img src=media/seven.jpeg>";
      else if (c == '8')
        digitHtml += "<img src=media/eight.jpeg>";
      else if (c == '9')
        digitHtml += "<img src=media/nine.jpeg>";
      else if (c == '-')
        digitHtml += "<img src=media/dash.jpeg>";
      else if (c == '.')
        digitHtml += "<img src=media/point.jpeg>";
    }
    if (digitHtml.length() == 0)
      digitHtml = "<img src=media/zero.jpeg>";

	
     return digitHtml;	
  }


}