package chat.business;

import java.util.Vector;
import chat.spec.*;

/**
 *  This class is used as a way to return both a vector and a long from
 *  a method in the Discussion class. It holds a "snapshot in time" of the
 *  state of the discussion. The state field holds the timestamp of that
 *  state.
 */
public class SnapshotImpl implements Snapshot{

  /**
   *  A list of all the messages (Message objects).
   */
  public Vector contents;

  /**
   *  The timestamp in place when this snapshot was taken.
   */
  public long state;

  /**
   *  Create a new snapshot. Be sure that the contents of the vector
   *  are in sync with the state value.
   */
  public SnapshotImpl(Vector contents, long state) {
    this.contents = contents;
    this.state = state;
  }
  public Vector getContents(){
  	 return contents;
  }
  public long getState(){
  	  return state;
  }
}

