/*
 *
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: ShowName.java,v 1.2 2004/08/16 10:57:12 slobodan Exp $
 */

package enhydraFlash.presentation;

//import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.httpPresentation.*;

import java.util.Date;
import java.text.DateFormat;

import enhydraFlash.presentation.xml.*;

public class ShowName implements HttpPresentation {

    
    public void run(HttpPresentationComms comms) 
        throws HttpPresentationException {
	try {
	    if(comms.request.getParameter("flash") != null) {
		handleFlash(comms);
	    }
	    else {
	    	
		ShowNamePageHTML page = (ShowNamePageHTML)comms.xmlcFactory.create(ShowNamePageHTML.class);
		comms.response.writeDOM(page);
	    }
	} catch (Exception e) {
	    System.out.println("EXCEPTION in ShowPage" + e);
	}
    }
    
    
    public void handleFlash(HttpPresentationComms comms) {

	try {
	    String name = comms.session.getSessionData().getString("NAME");
	    if(name == null) 
		name =  DateFormat.getTimeInstance(DateFormat.SHORT).format(new Date());

	    ShowNameXML page = (ShowNameXML)comms.xmlcFactory.create(ShowNameXML.class);
	    page.setTextName(name);
	    comms.response.setEncoding("ISO8859-1");
	    comms.response.writeDOM(page);
	} catch (Exception e) {
	    System.out.println("EXCEPTION in ShowPage" + e);
	}
    }
    
}
