/*
 *
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: Welcome.java,v 1.2 2004/08/16 10:57:12 slobodan Exp $
 */
package enhydraFlash.presentation;

import java.util.Date;
//import com.lutris.xml.xmlc.*;
import com.lutris.appserver.server.httpPresentation.*;

public class Welcome implements HttpPresentation {


    public void run(HttpPresentationComms comms) 
        throws HttpPresentationException {
	String name = null;
	try {
	    if((name = comms.request.getParameter("name")) != null) {
		handleSubmit(comms, name);
	    }
	    else {
		WelcomeHTML welcome = (WelcomeHTML)comms.xmlcFactory.create(WelcomeHTML.class);
		comms.response.writeDOM(welcome);
	    }
	} catch (Exception e) {
	    System.out.println("EXCEPTION in Welcome" + e);
	}
    }

    public void handleSubmit(HttpPresentationComms comms, String name) {
	
	//Put the name in the session.
	try {
	    comms.session.getSessionData().set("NAME", name);
	    String test = comms.session.getSessionData().getString("NAME");
	    throw new ClientPageRedirectException("ShowName.po");
	} catch (Exception e) {
	    System.out.println("EXCEPTION in Welcome" + e);
	}
    }

}
