package scioworks.imap.presentation.base;

import com.lutris.appserver.server.Enhydra;

public class Logger {

  public static int DEBUG    = com.lutris.logging.Logger.DEBUG;
  public static int WARNING  = com.lutris.logging.Logger.WARNING;
  public static int ERROR    = com.lutris.logging.Logger.ERROR;
  public static int CRITICAL = com.lutris.logging.Logger.CRITICAL;
  public static int INFO     = com.lutris.logging.Logger.INFO;

  public Logger() {
  }

  public static void writeDebug(String msg) {
    Enhydra.getLogChannel().write(DEBUG, msg);
  }

  public static void writeWarning(String msg, Throwable t) {
    t.printStackTrace(System.err);
    Enhydra.getLogChannel().write(WARNING, msg, t);
  }

  public static void writeError(String msg, Throwable t) {
    t.printStackTrace(System.err);
    Enhydra.getLogChannel().write(ERROR, msg, t);
  }

  public static void writeCritical(String msg, Throwable t) {
    t.printStackTrace(System.err);
    Enhydra.getLogChannel().write(CRITICAL, msg, t);
  }

  public static void write(int level, String msg, Throwable t) {
    t.printStackTrace(System.err);
    Enhydra.getLogChannel().write(level, msg, t);
  }

  public static void writeInfo(String msg) {
    Enhydra.getLogChannel().write(INFO, msg);
  }
}
