package scioworks.imap.presentation.imapWeb;

import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.StringReader;
import java.util.Date;
import java.util.Vector;

import com.lutris.util.Config;
import com.lutris.util.ConfigException;
import com.lutris.appserver.server.Enhydra;

public class TextUtil {

  private static TextUtil fSingleton;

  // Constants
  String INDENT = "  ";

  // Format date and time
  SimpleDateFormat df;
  SimpleDateFormat tf;
  SimpleDateFormat dtf;

  private TextUtil() {

    Config config = Enhydra.getApplication().getConfig();

    try {
      String dateFormat = config.getString("ImapWeb.Util.DateFormat");
      df = new SimpleDateFormat(dateFormat);

    } catch (ConfigException e) {
      e.printStackTrace();
    }
  }

  public static synchronized TextUtil singleton() {
    if (fSingleton == null) {
      fSingleton = new TextUtil();
    }
    return fSingleton;
  }

  public String dateFormat(Date date) {
    return df.format(date);
  }

  public String textToHtml(String str) {
    StringBuffer buf = new StringBuffer();
    try {
      BufferedReader in = new BufferedReader(new StringReader(str));
      String line;
      while ((line = in.readLine()) != null) {
        buf.append(line).append("<br>");
      }
      in.close();
    } catch (IOException e) {
      buf.append("<p><b>Error: </b>"+e.getMessage());
    }
    return buf.toString();
  }

  public String verboseFilesize(int size) {
    if (size > 1000000) {
      return Long.toString(Math.round(size/1000000.0))+"mb";
    } else if (size > 1000) {
      return Long.toString(Math.round(size/1000.0))+"k";
    } else {
      return size + "b";
    }
  }

  public String initCap(String str) {
    StringBuffer buf = new StringBuffer();
    buf.append(Character.toUpperCase(str.charAt(0)));
    buf.append(str.substring(1));
    return buf.toString();
  }
}
