/*
 *  imapWeb
 *
 *  Enhydra super-servlet specification object
 *  
 */
package scioworks.imap.spec.beans;

import java.lang.reflect.Constructor;
    
public class FileRecordFactory {


    /**
     * Constructor can't be used.
     */
    private FileRecordFactory() {
    }

    /**
     * Create a FileRecord as state object/value object/data transfer object
     */
    public static FileRecord getFileRecord(String fullClassName,String tmpFilename,String filename,int size,String contentType) {
        
        FileRecord result = null;
       
        Class objectClass = null;

        try {
            // Create the value object
       
      
         objectClass = Class.forName(fullClassName);
         
         Class[] parameterTypes =new Class[4];
         
         parameterTypes[0]= String.class;                
         parameterTypes[1]= String.class;
         parameterTypes[2]= int.class;
         parameterTypes[3]= String.class;
       
         Constructor constr =  objectClass.getConstructor(parameterTypes);
        
        
         
        Object[] objects = new Object[4];
        objects[0]=tmpFilename;
        objects[1]=filename;
        objects[2]=new Integer(size);
        objects[3]=contentType;
        
         Object obj =   constr.newInstance(objects);
   
      return (FileRecord)obj;
                        
                    
      } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }
}