/*
 *  imapWeb
 *
 *  Enhydra super-servlet specification object
 *  
 */

package scioworks.imap.spec.beans;


import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
import java.util.Vector;
import scioworks.imap.spec.ImapWebException;

public interface IWMessage {

public String getMessageBody(Message mesg)
      throws ImapWebException;
public Message getMessage(Folder folder, long uid)
      throws ImapWebException;
public Message getMessage(Store imapStore,
      String folderName, long uid) throws ImapWebException ;
public Message forwardMessage(Session imapSession, Store imapStore,
      String folderName, long uid, boolean isInline)
      throws ImapWebException;
public Message replyMessage(Session imapSession, Store imapStore,
      String folderName, long uid, boolean replyAll, boolean quoteOrig)
      throws ImapWebException;
public void sendMessage(Store imapStore, Session imapSession, URLName imapURL,
      String imapDomain,
      String to, String subject, String cc, String bcc, String message,
      Vector attachments, boolean isInline, boolean saveCopy,
      boolean isForwardAttach, String origFolderName, long origUid)
      throws ImapWebException;
public void deleteMessage(Store imapStore,
      String folderName, long[] uidArr) throws ImapWebException;
public void moveMessage(Store imapStore, String folderName,
      long[] uidArr, String targetFolderName) throws ImapWebException;
public Part getMessagePart(Session imapSession, Store imapStore,
      String folderName, long uid, String partIdList) throws ImapWebException;
public Vector getFolderNames(Store imapStore, String currentFolder)
      throws ImapWebException;
public void createFolder(Store imapStore, String name)
      throws ImapWebException;
public void renameFolder(Store imapStore, String folderName, String name)
      throws ImapWebException;
public void removeFolder(Store imapStore, String folderName)
      throws ImapWebException;      
}





