package multibase.business;

import multibase.data.employee.*;
import multibase.data.employee.programer.*;

import multibase.spec.*;

public class MyDataManagerImpl implements MyDataManager {

	public void loadPr(){
		String[][] programers={
								{ "Scott", "Tiger", "advance", "DODS" },
								{ "Urchin", "Spinnes", "novice", "DODS" },
								{ "Jhon", "Erp", "advance", "Enhydra" },
								{ "Jim", "Earth", "advance", "Enhydra" }
							 };
		for (int i=0 ; i<programers.length; i++){
			try{
				ProgramerDO newP=ProgramerDO.createVirgin("programer");
				newP.setFirstName(programers[i][0]);
				newP.setLastName(programers[i][1]);
		 		newP.setExpirience(programers[i][2]);
				newP.setProject(programers[i][3]);
				newP.save();
										
			}catch(Exception e){}
		}
	}
	
	
		public void loadEm(){
		String[][] employees={
								{ "Bily", "Kid", "manager", "finance" },
								{ "Jerry", "Sttock", "manager", "consulting" },
								{ "Elly", "Beluchi", "director", "masterhood" },
								{ "Nattaly", "Sky", "seller", "marketing" }
							 };
		for (int i=0 ; i<employees.length; i++){
			try{
				EmployeeDO newE=EmployeeDO.createVirgin("employee");
				newE.setFirstName(employees[i][0]);
				newE.setLastName(employees[i][1]);
		 		newE.setOccupation(employees[i][2]);
				newE.setDepartment(employees[i][3]);
				newE.save();
										
			}catch(Exception e){}
		}
	}
	
	
	public void transferPr(){
		try{
			ProgramerDO[] programers;
			ProgramerQuery pQuery = new ProgramerQuery("programer");
			programers = pQuery.getDOArray();
			for(int i=0; i< programers.length; i++) {
				EmployeeDO newEmployee=EmployeeDO.createVirgin("employee");
				newEmployee.setFirstName(programers[i].getFirstName());
				newEmployee.setLastName(programers[i].getLastName());
				newEmployee.setOccupation("programer");
				newEmployee.setDepartment("IT");
				newEmployee.save();
			}
		} catch ( Exception e){ System.out.println(e.getMessage());
			
		}
		
		
	}
	
	
	
	public void deleteTr(){
		try{
			EmployeeDO[] emArray;
			EmployeeQuery eQuery = new EmployeeQuery("employee");
			eQuery.setQueryOccupation("programer");
			emArray = eQuery.getDOArray();
			for(int i=0; i< emArray.length; i++) {
				emArray[i].delete();
			}
		} catch ( Exception e){ System.out.println(e.getMessage());
		
		}
	}
	
		public void deleteAll(){
		try{
			ProgramerDO[] pArray;
			ProgramerQuery pQuery = new ProgramerQuery("programer");
			pArray = pQuery.getDOArray();
			for(int i=0; i< pArray.length; i++) {
				pArray[i].delete();
			}
			
	    	EmployeeDO[] eArray;
			EmployeeQuery eQuery = new EmployeeQuery("employee");
			eArray = eQuery.getDOArray();
			for(int i=0; i< eArray.length; i++) {
				eArray[i].delete();
			}
		} catch ( Exception e){ System.out.println(e.getMessage());
		
		}
	}
	
	
	
	public String[][] getProgramers(){
		String[][] result=null;
		try{
			ProgramerDO[] pArray;
			ProgramerQuery pQuery = new ProgramerQuery("programer");
			pArray = pQuery.getDOArray();
			result = new String[pArray.length][4];
			for(int i=0; i< pArray.length; i++) {
				result[i][0] = pArray[i].getFirstName();
				result[i][1] = pArray[i].getLastName();
				result[i][2] = pArray[i].getExpirience();
				result[i][3] = pArray[i].getProject();
			}
		} catch ( Exception e){
			System.out.println(e.getMessage());
		}
		return result;
	}
	
	
	
	public String[][] getEmployees(){
		String[][] result=null;
		try{
			EmployeeDO[] eArray;
			EmployeeQuery eQuery = new EmployeeQuery("employee");
			eArray = eQuery.getDOArray();
			result = new String[eArray.length][4];
			for(int i=0; i< eArray.length; i++) {
				result[i][0] = eArray[i].getFirstName();
				result[i][1] = eArray[i].getLastName();
				result[i][2] = eArray[i].getOccupation();
				result[i][3] = eArray[i].getDepartment();
			}
		} catch ( Exception e){
			System.out.println(e.getMessage());
		}
		return result;
	}

}
