/*
 *  multibaseExemple
 *
 *  Enhydra super-servlet presentation object
 *
 */

package multibase.presentation;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import org.w3c.dom.html.*;
import org.w3c.dom.Node;

// Standard imports
import java.io.IOException;
import java.util.Date;
import java.text.DateFormat;

// App imports
import multibase.spec.*;
import org.w3c.dom.Node;

public class MultibasePresentation implements HttpPresentation {


    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, IOException {

        MultibaseHTML multibase;
        MyDataManager dataManager;

		
        multibase = (MultibaseHTML)comms.xmlcFactory.create(MultibaseHTML.class);
      
	    dataManager = MyDataManagerFactory.getMyDataManager("multibase.business.MyDataManagerImpl");
	     
	
	try{								
		String event = comms.request.getParameter("AppActionRg");
		if (event!=null){
			if (event.equals("loadPr")) {
				dataManager.loadPr();
			
			} else if (event.equals("loadEm")){
				dataManager.loadEm();
				
			} else if (event.equals("transferPr")){
				dataManager.transferPr();
				
			} else if (event.equals("deleteTr")){
				dataManager.deleteTr();
				
			} else if (event.equals("deleteAll")){
				dataManager.deleteAll();
			}
		}

		String[][] programerArray=dataManager.getProgramers();
		String[][] employeeArray=dataManager.getEmployees();
		
		
		HTMLTableRowElement prTemplateRow = multibase.getElementPrTemplateRow();
		HTMLElement pFirstNameCellTemplate = multibase.getElementPFirstName();
		HTMLElement pLastNameCellTemplate = multibase.getElementPLastName();
		HTMLElement expirienceCellTemplate = multibase.getElementExpirience();
		HTMLElement projectCellTemplate = multibase.getElementProject();
        Node prTable = prTemplateRow.getParentNode();
		
		
		
		prTemplateRow .removeAttribute("id");
		pFirstNameCellTemplate.removeAttribute("id");
		pLastNameCellTemplate.removeAttribute("id");
		expirienceCellTemplate.removeAttribute("id");
		projectCellTemplate.removeAttribute("id");
		
		
		
		if (programerArray!=null){
			for (int numDiscs = 0; numDiscs < programerArray.length; numDiscs++) {
				multibase.setTextPFirstName(programerArray[numDiscs][0]);
				multibase.setTextPLastName (programerArray[numDiscs][1]);
				multibase.setTextExpirience (programerArray[numDiscs][2]);
				multibase.setTextProject (programerArray[numDiscs][3]);
				prTable.appendChild(prTemplateRow.cloneNode(true));
			}
		}
		
		
		
		HTMLTableRowElement emTemplateRow = multibase.getElementEmTemplateRow();
		HTMLElement eFirstNameCellTemplate = multibase.getElementEFirstName();
		HTMLElement eLastNameCellTemplate = multibase.getElementELastName();
		HTMLElement occupationCellTemplate = multibase.getElementOccupation();
		HTMLElement departmentCellTemplate = multibase.getElementDepartment();
        Node emTable = emTemplateRow.getParentNode();
		
		
		
		emTemplateRow .removeAttribute("id");
		eFirstNameCellTemplate.removeAttribute("id");
		eLastNameCellTemplate.removeAttribute("id");
		occupationCellTemplate.removeAttribute("id");
		departmentCellTemplate.removeAttribute("id");
		
		
		
		if (employeeArray!=null){
			for (int numDiscs = 0; numDiscs < employeeArray.length; numDiscs++) {
				multibase.setTextEFirstName(employeeArray[numDiscs][0]);
				multibase.setTextELastName (employeeArray[numDiscs][1]);
				multibase.setTextOccupation(employeeArray[numDiscs][2]);
				multibase.setTextDepartment(employeeArray[numDiscs][3]);
				emTable.appendChild(emTemplateRow.cloneNode(true));
			}
		}
		
		
		prTemplateRow.getParentNode().removeChild(prTemplateRow);
		emTemplateRow.getParentNode().removeChild(emTemplateRow);
    
    /*
 * We want to allow multibase_pres to be functional , we cannot create instances of business layer when we run bultibase_pres
 * catch NullPointerException and show default HTML page
 */		
	 }catch(NullPointerException e){
	 	multibase.setTextMessage("MultiDb default page");
	 	}
        comms.response.writeDOM(multibase);
    }

}
