/*
 *  multibase 
 *
 *  Enhydra super-servlet specification object
 *  
 */
package multibase.spec;

public class MyDataManagerFactory {
    
    /**
     * Constructor can't be used.
     */
    private MyDataManagerFactory() {
    }

    /**
     * Create a MyDataManager as state object/value object/data transfer object
     */
    public static MyDataManager getMyDataManager(String fullClassName) {
        MyDataManager result = null;
        Class objectClass = null;

        try {
            // Create the value object
            objectClass = Class.forName(fullClassName);
            result = (MyDataManager) objectClass.newInstance();
        } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }
}
