package phoneList.presentation;

import com.lutris.appserver.server.httpPresentation.*;

import phoneList.spec.*;

public class DoActionPresentation implements HttpPresentation {

    public void run(HttpPresentationComms comms) throws Exception {
        String first = null;
        try {
            first = comms.request.getParameter("first");
        } catch (Exception e) {
        }
        String last = null;
        try {
            last = comms.request.getParameter("last");
        } catch (Exception e) {
        }
        String phone = null;
        try {
            phone = comms.request.getParameter("phone");
        } catch (Exception e) {
        }
        String id = null;
        try {
            id = comms.request.getParameter("id");
        } catch (Exception e) {
        }
        String action = null;
        try {
            action = comms.request.getParameter("action");
        } catch (Exception e) {
        }
        String okTarget = comms.request.getAppFileURIPath("ListPresentation.po");
        String errTarget = comms.request.getAppFileURIPath("ErrorPresentation.po");
        ClientPageRedirectException err =
                                    new ClientPageRedirectException(errTarget);
       
       PhoneList phoneList = PhoneListFactory.getPhoneList("phoneList.business.PhoneListImpl");
       
       if (action.equals("delete")) {
            if ((id == null) || (id.length() == 0)) {
                err.addArgument("err", "Error: no id specified.");
                throw err;
            }
       try{ 
            phoneList.deletePerson(id);
      /*
       * Catch Null pointer exception ( we canot make a instances of classes from business layer  when we run phoneBookClient_pres )
       * We need  to allow phoneBookClient_pres to be functional 
       */    
       } catch(NullPointerException ex) {
    	err.addArgument("err", "Error: You cannot delete person while runing phoneBookClient_pres!");
       throw err;
       }  
        } else if (action.equals("edit")) {
            if ((id == null) || (id.length() == 0)) {
                err.addArgument("err", "Error: no id specified.");
                throw err;
            }
            if ((first == null) || (first.length() == 0)) {
                err.addArgument("err", "Error: no first name specified.");
                throw err;
            }
            if ((last == null) || (last.length() == 0)) {
                err.addArgument("err", "Error: no last name specified.");
                throw err;
            }
            if ((phone == null) || (phone.length() == 0)) {
                err.addArgument("err", "Error: no phone number specified.");
                throw err;
            }
          try{
            phoneList.modifyPerson(id, first, last, phone);
         //same thing
        } catch(NullPointerException ex) {
    	   err.addArgument("err", "Error: You  cannot modify  person while runing phoneBookClient_pres!");
    	throw err;
    	}  
        } else if (action.equals("create")) {
            if ((first == null) || (first.length() == 0)) {
                err.addArgument("err", "Error: no first name specified.");
                throw err;
            }
            if ((last == null) || (last.length() == 0)) {
                err.addArgument("err", "Error: no last name specified.");
                throw err;
            }
            if ((phone == null) || (phone.length() == 0)) {
                err.addArgument("err", "Error: no phone number specified.");
                throw err;
            }
          try{
            phoneList.addPerson(first, last, phone);
          //same thing
        } catch(NullPointerException ex) {
    	   err.addArgument("err", "Error: You cannot add person while runing phoneBookClient_pres!");
    	throw err;
    	}  
        } else {
            // Shouldn't happen.
        }
        throw new ClientPageRedirectException(okTarget);
    }

}

