package phoneList.presentation;

import phoneList.spec.*;

// Standard imports
import java.util.Vector;
import java.io.IOException;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import org.w3c.dom.html.HTMLAnchorElement;
import org.w3c.dom.Node;

public class ListPresentation implements HttpPresentation {

  private static ListHTML list;

  public void run(HttpPresentationComms comms) throws HttpPresentationException, IOException {

    try{
      OutputList(comms);
    }catch(Exception e){
      e.printStackTrace();
    }
  }


  public static void OutputList(HttpPresentationComms comms) throws Exception {

    PhoneList phoneList = PhoneListFactory.getPhoneList("phoneList.business.PhoneListImpl");
    list = (ListHTML)comms.xmlcFactory.create(ListHTML.class);
  try{
    Vector[] lists = phoneList.getLists();
    Vector firsts = lists[0];
    Vector lasts = lists[1];
    Vector phones = lists[2];
    Vector ids = lists[3];

    

    Node phoneElementRow = list.getElementPhone_row();
    Node no_entries_row = list.getElementNo_entries_row();
    Node phone_row = list.getElementPhone_row();

    if (firsts.size() == 0) {

      phone_row.getParentNode().removeChild(phone_row);

    }else{
      no_entries_row.getParentNode().removeChild(no_entries_row);
      for (int i=0; i<firsts.size(); i++) {

        String first = (String) firsts.elementAt(i);
        String last = (String) lasts.elementAt(i);
        String phone = (String) phones.elementAt(i);
        String id = (String) ids.elementAt(i);

        list.setTextFirst(first);
        list.setTextLast(last);
        list.setTextPhone(phone);
        HTMLAnchorElement anchorDelete = list.getElementDelete();
        anchorDelete.setHref("DoActionPresentation.po?action=delete&id="+id);
        HTMLAnchorElement anchorEdit = list.getElementEdit();
        anchorEdit.setHref("EditPresentation.po?id="+id);

        phoneElementRow.getParentNode().insertBefore(phoneElementRow.cloneNode(true),
                                                               phoneElementRow);

     }
     phoneElementRow.getParentNode().removeChild(phoneElementRow);
    }
   
/*
 * Catch Null pointer exception ( we canot make a instances of classes from business layer  when we run phoneBook_pres )
 * We need  to allow phoneBookClient_pres to be functional , respone will be default HTML page 
 */ 
   }catch(NullPointerException e){}

    comms.response.writeDOM(list);

  }
}

