package phoneList.presentation;

import phoneList.spec.*;

// Standard imports
import java.util.Vector;
import java.io.IOException;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import org.w3c.dom.html.HTMLAnchorElement;
import org.w3c.dom.Node;

public class ModifyServerPresentation implements HttpPresentation {
  
  private static ModifyServerHTML ms;
  
  public void run(HttpPresentationComms comms) throws HttpPresentationException, IOException {

    try{
      modifyServer(comms);
    }catch(Exception e){
      e.printStackTrace();
    }
  }


  public static void modifyServer(HttpPresentationComms comms) throws Exception {
    ms = (ModifyServerHTML)comms.xmlcFactory.create(ModifyServerHTML.class);
    try{
       PhoneList phoneList = PhoneListFactory.getPhoneList("phoneList.business.PhoneListImpl");
      
       String server=phoneList.getServer();
       String port=phoneList.getPort();
      
    
      ms.getElementPort().setValue(port);
      ms.getElementServer().setValue(server);
      
/*
 * Catch Null pointer exception ( we canot make a instances of classes from business layer  when we run phoneBookClient_pres )
 * We need  to allow phoneBookClient_pres to be functional ,return default HTML page
 */ 
    } catch(NullPointerException ex) {}
   comms.response.writeDOM(ms);
   } 

}

