/**
 * Title:        EJOSA - Enterprise Java Open Source Architecture
 *               My Piggy Bank Example
 * Description:  Business Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
package net.sourceforge.ejosa.piggybank.business.session;

import java.util.*;
import net.sourceforge.ejosa.piggybank.spec.*;
import net.sourceforge.ejosa.piggybank.spec.business.*;
import net.sourceforge.ejosa.piggybank.spec.system.*;

import net.sourceforge.ejosa.piggybank.business.*;
import net.sourceforge.ejosa.piggybank.business.entity.*;
import net.sourceforge.ejosa.piggybank.data.coin.*;
//import com.lutris.dods.builder.generator.query.*;


/**
 * The workflow object business delegate ejb implementation.
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
public class CoinManagerImpl implements CoinManager {
    
    /**
    * Create a coin
    *
    * @param     Coin
    * @exception CoinException
    */
    public void createCoin(Coin coin) throws CoinException {
        try {
          CoinImpl coinImpl = new CoinImpl();
          coinImpl.setId(coin.getId());
          coinImpl.setCurrency(coin.getCurrency());
          coinImpl.setDate(coin.getDate());
          coinImpl.setAmount(coin.getAmount());
          coinImpl.save();
        } catch (Exception ex) {
            System.out.println("Exception: " + ex);
            //throw new CoinBusinessException("Exception in createCoin(Coin)", ex);
        }
    }

    /**
    * Update a coin
    *
    * @param     Coin
    * @exception CoinException
    */
    public void updateCoin(Coin coin) throws CoinException {
        try {
           
        } catch (Exception ex) {
            System.out.println("Exception: " + ex);
            //throw new CoinException("Exception in updateCoin(Coin)", ex);
        }
    }

    /**
    * Remove a coin
    *
    * @param     Coin
    * @exception CoinException
    */
    public void removeCoin(String id) throws CoinException {
        try {
          CoinImpl theCoin = null;
          CoinQuery query = new CoinQuery();
          // Order coins by date
          query.setQueryID(id);
          CoinDO[] DOcoinArray = query.getDOArray();
          theCoin = new CoinImpl(DOcoinArray[0]);
          theCoin.delete();
        } catch (Exception ex) {
            System.out.println("Exception: " + ex);
            //throw new CoinException("Exception in removeCoin(String)", ex);
        }
    }

    /*========================= Find Methods ============================*/

    /**
    * Find all coins
    *
    * @return    vector of coins
    * @exception RemoteException, CoinException
    */
    public Vector findAllCoins() throws CoinException {
        Vector result = new Vector();
        try {
          Coin[] theCoinArray = null;
          CoinQuery query = new CoinQuery();
          // Order coins by date
          query.addOrderByDATE();
          CoinDO[] DOarray = query.getDOArray();
          for ( int i = 0; i < DOarray.length; i++ )
    	         result.addElement(new CoinImpl(DOarray[i]));
        } catch (Exception ex) {
            System.out.println("Exception: " + ex);
            //throw new CoinException("Exception in findAllCoins()", ex);
        }
        return result;
    }
}