/**
 * Title:        EJOSA - Enterprise Java Open Source Architecture
 *               My Piggy Bank Example
 * Description:  Enhydra Presentation Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 */
package net.sourceforge.ejosa.piggybank;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;

import com.lutris.util.*;


/**
 * Enhydra Application
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 */
public class PiggyBankApplication extends StandardApplication {
    /*
     *  A few methods you might want to add to.
     *  See StandardApplication for more details.
     */
    public void startup(Config appConfig) throws ApplicationException {
        super.startup(appConfig);

        //  Here is where you would read application-specific settings from
        //  your config file.
    }

    public boolean requestPreprocessor(HttpPresentationComms comms)
                                throws Exception {
        return super.requestPreprocessor(comms);
    }

    /**
     * This is an optional function, used only by the Multiserver's graphical
     * administration. This bit of HTML appears in the status page for this
     * application. You could add extra status info, for example
     * a list of currently logged in users.
     *
     * @return HTML that is displayed in the status page of the Multiserver.
     */
    public String toHtml() {
        return "This is <I>piggybank</I>";
    }
}