/**
 * Title:        OpenUSS - Open Source University Support System
 *               My Piggy Bank Example
 * Description:  Enhydra Presentation Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 *
 * This is a sample presentation object written by hand (not using the
 * Jolt compiler). Since this presentation object only redirects, and does
 * not emit any HTML, it does not need Jolt.
 * This type of presentation object could, for example, be the target of
 * a form's submit button, process the data, and then decide where to send
 * the user (back or on to the next page).
 */
package net.sourceforge.ejosa.piggybank.presentation.enhydra;

import com.lutris.appserver.server.httpPresentation.*;


/**
 * The redirection object for Enhydra.
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 */
public class Redirect implements HttpPresentation {
    /*
     * There is the only function needed in order to be a presentation object.
     */
    public void run(HttpPresentationComms comms) throws Exception {
        throw new ClientPageRedirectException(comms.request.getAppFileURIPath(
                                                      "Welcome.po"));
    }
}