/**
 * Title:        OpenUSS - Open Source University Support System
 *               My Piggy Bank Example
 * Description:  Enhydra Presentation Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 */
package net.sourceforge.ejosa.piggybank.presentation.enhydra;

import com.lutris.appserver.server.httpPresentation.*;

//import com.lutris.xml.xmlc.*;

import java.io.*;

import java.util.*;

import org.openuss.presentation.enhydra.framework.*;

import org.openuss.utility.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;


/**
 * Welcome Page
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.1
 */
public class WelcomePage extends FoundationPO {
    /**
     * Default event. Just show the page.
     */
    public String handleDefault() throws HttpPresentationException {
        // Create the page
        WelcomeHTML page = (WelcomeHTML) this.getComms().xmlcFactory.create(
                                   WelcomeHTML.class);

        // Look for an error
        String errorMsg = this.getSessionData().getAndClearUserMessage();

        if (errorMsg == null) {
            // No error
            page.getElementTStatusbar().getParentNode()
                .removeChild(page.getElementTStatusbar());
        } else {
            // Error, put it in the statusbar
            page.setTextTStatusbar(errorMsg);
        }

        // Work with the page
        return page.toDocument();
    }

    /**
     * Superclass method override.
     */
    public boolean loggedInUserRequired() {
        // This page doesn't need a login
        return false;
    }
}