/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  Enhydra Presentation Object
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework;

/**
 * The base layout object for Enhydra. This
 * includes the treebar on the right side of the page,
 * the date and the method for showing it all.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public interface BaseLayout {
    /**
     * This method has to be implemented. This write down the right-side
     * information on the right side of the page. "Treebar".
     */
    public void showTreebar(Object page) throws BasePOException;

    /**
     * This method has to be implemented. This updates the date on
     * the top right.
     */
    public void showUpdatedDate(Object page) throws BasePOException;

    /**
     * This method has to be implemented. This shows all the page
     * layout. All layout methods should be called within
     * this method.
     */
    public String showLayout(Object page) throws BasePOException;
}