/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  BaseException Presentation Object
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework;

import com.lutris.appserver.server.httpPresentation.HttpPresentationException;

import com.lutris.util.ChainedException;


/**
 * The base exception presentation object for Enhydra.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public class BasePOException extends HttpPresentationException {
    /**
     * Public constructor to initialize an exception with a user message
     * and the exception that spawned it
     */
    public BasePOException(String msg, Exception ex) {
        super(msg, ex);
    }
}