/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  BaseTable Presentation Object
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework;

import org.w3c.dom.*;
import org.w3c.dom.html.*;


/**
 * The base table for Enhydra.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public abstract class BaseTable {
    // The document for showing this table
    protected Document mainPage;

    /**
     * Constructor.
     */
    public BaseTable() {
    }

    /**
     * Constructor.
     */
    public BaseTable(Document mainPage) throws BaseTableException {
        this.mainPage = mainPage;
    }

    /**
     * Set the document.
     */
    public void setDocument(Document mainPage) {
        this.mainPage = mainPage;
    }

    /**
     * Get the result table document.
     */
    abstract public Node getTable();

    /**
     * Get the result table document.
     */
    public Node getTableForDocument() {
        // Import the table into the current document
        Node currentNode = mainPage.importNode(this.getTable(), true);

        return currentNode;
    }
}