/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  TreeNavigator Presentation Object
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework;

/**
 * Base class for the tree navigator.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public interface BaseTreeNavigator {
    /**
     * Show method should be used to show the navigator
     * tree. This method must be implemented with the
     * reflection API from Java!
     */
    public void show() throws BasePOException;
}