/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  Base Page Translator for Presentation
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework.designer;

import java.util.*;

import org.enhydra.xml.xmlc.html.*;


/**
 * Base Page Designer for the presentation objects in Enhydra.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public interface BasePageDesigner {
    /** 
     * Get the design file.
     * @return the design file with its full package name.
     */
    public String getDesignFileName(Object page);

    /**
     * Design the page.
     */
    public void designPage();
}