/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  Base Page Translator for Presentation
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.presentation.enhydra.framework.multilanguage;

import java.util.*;

import org.enhydra.xml.xmlc.html.*;


/**
 * Base Page Translator for the presentation objects in Enhydra.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public interface BasePageTranslator {
    /**
     * Gets the page.
     */
    public HTMLObjectImpl getPage();

    /**
     * Translate the page.
     */
    public void translatePage();
}