/**
 * Title:        EJOSA - Enterprise Java Open Source Architecture
 *               My Piggy Bank Example
 * Description:  Specification Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
package net.sourceforge.ejosa.piggybank.spec.business;

/**
 * The business object factory.
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
public class CoinFactory {
    /**
     * Constructor can't be used.
     */
    private CoinFactory() {
    }

    /**
     * Create a coin as state object/value object/data transfer object
     */
    public static Coin createCoin(String fullClassName) {
        Coin result = null;
        Class objectClass = null;

        try {
            // Create the value object
            objectClass = Class.forName(fullClassName);
            result = (Coin) objectClass.newInstance();
        } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }
}