/**
 * Title:        EJOSA - Enterprise Java Open Source Architecture
 *               My Piggy Bank Example
 * Description:  Specification Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
package net.sourceforge.ejosa.piggybank.spec.system;

import java.util.*;

import net.sourceforge.ejosa.piggybank.spec.*;
import net.sourceforge.ejosa.piggybank.spec.business.*;


/**
 * The workflow object interface.
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
public interface CoinManager {
    /*========================= CRDU Methods ============================*/

    /**
     * Create a coin
     *
     * @param     Coin
     * @exception CoinException
     */
    public void createCoin(Coin coin) throws CoinException;

    /**
     * Update a coin
     *
     * @param     Coin
     * @exception CoinException
     */
    public void updateCoin(Coin coin) throws CoinException;

    /**
     * Remove a coin
     *
     * @param     id of the coin
     * @exception CoinException
     */
    public void removeCoin(String id) throws CoinException;

    /*========================= Find Methods ============================*/

    /**
     * Find all coins
     *
     * @return    collection of coins
     * @exception CoinException
     */
    public Vector findAllCoins() throws CoinException;

    /*========================= Use Case Methods ============================*/
    /*========================= Relationship Methods ============================*/
}