/**
 * Title:        EJOSA - Enterprise Java Open Source Architecture
 *               My Piggy Bank Example
 * Description:  Specification Object
 * Copyright:    Copyright (c) 2003 by B. Lofi Dewanto, T. Menzel
 * Company:      University of Muenster, HTWK Leipzig
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
package net.sourceforge.ejosa.piggybank.spec.system;

/**
 * The workflow object factory.
 *
 * @author  B. Lofi Dewanto, T. Menzel
 * @version 1.2
 */
public class CoinManagerFactory {
    /**
     * Constructor can't be used.
     */
    private CoinManagerFactory() {
    }

    /**
     * Create a coin manager workflow
     */
    public static CoinManager createCoinManager(String fullClassName) {
        CoinManager result = null;
        Class objectClass = null;

        try {
            // Create the delegate
            objectClass = Class.forName(fullClassName);
            result = (CoinManager) objectClass.newInstance();
        } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }
}