/**
 * Title:        OpenUSS - Open Source University Support System
 * Description:  Utility for OpenUSS
 * Copyright:    Copyright (c) B. Lofi Dewanto
 * Company:      University of Muenster
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
package org.openuss.utility;

import java.util.*;


/**
 * Mime type chooser.
 * This is used to choose the right content type for each
 * file type.
 *
 * @author  B. Lofi Dewanto
 * @version 1.0
 */
public class MimeTypeChooser {
    // Resource
    static ResourceBundle res = ResourceBundle.getBundle(
                                        "org.openuss.utility.MimeTypeChooser");

    // Constant
    public static String NOT_AVAILABLE = "not_available";

    /**
     * Get the mime type.
     */
    public static String getMimeType(String extensionType) {
        String result = "";

        // Ignore capital/case
        // Return null if you cannot find the mime type
        try {
            result = res.getString(extensionType.toLowerCase());
        } catch (MissingResourceException ex) {
            // Not Found, make a silent exception
            // Not available mime type
            result = getMimeType(MimeTypeChooser.NOT_AVAILABLE);
        }

        return result;
    }
}