package poker.business;

import java.util.Vector;
import poker.spec.*;
/**
 * 
 * EnhyDraw!, beta 4, 5/21/99
 *
 * Copyright 1999, Larry Wolcot & Daryl Tempesta
 * ALL rights reserved. Not for commercial use
 * without written permission from both authors.
 *
 * This class handles all of the cardGame rules,
 * distribution of cards, hand evaluation, etc.
 */
public class DealerImpl implements Dealer{

    int[] e = { 0, 0, 0, 0, 0}; 
    public Vector dealFiveCards(){
	Vector thisHand = new Vector(5);
	Vector usedCards = new Vector();
	for (int i = 0; i <5; i++){
	    thisHand.addElement(new Integer(0));
	}
	for (int i = 0; i <5; i++){
	     thisHand = getUnusedCard(usedCards, thisHand, i);    
  	}
	return thisHand;
    }

   /**
    * Insert an unused card at index, into theseCards
    */
    public Vector getUnusedCard(Vector usedCards, Vector theseCards,int
index){
	boolean shouldLoop = true;
	boolean isUsed = false;
	Integer aRandomCard = null; Integer thisCard = null;

	//Loop until we draw a uique, unused card
	while (shouldLoop){
	  shouldLoop = false;
	  aRandomCard = new Integer(((int)(Math.random()*52)+1));
	  if (usedCards.contains(aRandomCard)) { shouldLoop = true;
 	  } else { shouldLoop = false; }
	}
	usedCards.addElement(aRandomCard);
	theseCards.setElementAt(aRandomCard, index);

	return theseCards;	
    }

    /**
     * This method drops the selected cards and draws new ones
     */    
    public Vector drawMoreCards(Vector haveCards, Vector dropCards){
	Vector allCards = new Vector(0);

	//initialize a new Vector with the contents of another.
	//Yeah, there are better ways to do it. Feeling liniar?
	for (int i = 0; i < haveCards.size(); i++){
	    allCards.addElement(haveCards.elementAt(i));
	}
	String flag;

	//draw a new card for every one select to drop
	for (int i = 0; i < 5; i++){
	    flag = (String)dropCards.elementAt(i);
	    if (flag.equals("DROP")){
		haveCards = getUnusedCard(haveCards,haveCards, i);
	    }
	}

	return haveCards;
    }
    
    /**
     * This is one scary method. It checks the hand!
     * Not bad work for a mathaphobic  :)
     */
    public String checkHand(Vector cardsInHand){
	// init all of my boolean flags
	boolean flush = false;
	boolean lowStraight = false;
	boolean highStraight = false;
	boolean straightFlush = false;
	boolean two = false;
	boolean three = false;
	boolean twoPair = false;
	boolean four = false;
	boolean house = false;
	Integer[] card = new Integer[5];
	int[] c = { 0, 0, 0, 0, 0};
        int[] d = { 0, 0, 0, 0, 0};

	// set up cards and strip suits
	for (int i = 0; i < 5; i++){
	    card[i] = (Integer)cardsInHand.elementAt(i);// root card
	    c[i] = card[i].intValue(); // get int value
	    d[i] = c[i];// copy to d[] array for scratch work
	    while (d[i] > 13) { d[i] -= 13; }//strip suits from d[]
	}

	// Sort from high to low, put results into e[]
	for (int i = 0; i < 5; i++){
	    if (d[i] >= e[0]) { 
		shift(e, 0); e[0] = d[i];
	    }
	    if ((d[i] >= e[1]) & (d[i] < e[0])) { 
		shift(e, 1); e[1] = d[i];
	    }
            if ((d[i] >= e[2]) & (d[i] < e[1])) { 
		shift(e, 2); e[2] = d[i];
	    }
            if ((d[i] >= e[3]) & (d[i] < e[2])) { 
		shift(e, 3); e[3] = d[i]; 
	    }
            if ((d[i] >= e[4]) & (d[i] < e[3])) { 
		shift(e, 4); e[4] = d[i]; 
	    }
	}

	//Check for 2 and 3 of a kind
	//This is one of the scariest sorts I've ever created!  ;)
	int scratch1 = 0; int scratch2 = 0; int scratch3 = 0;
	for (int i = 0; i <4; i++){
	    for (int x = i + 1; x < 5; x++){
	    	if (e[x] == e[i]){
		    if ((two == true) & (e[x] != scratch1)){
			if (e[x] != scratch3){
			    twoPair = true;
			    scratch2 = e[x];
			}
		    } else {
			if (e[x] != scratch3){ 	
		            two = true;
		            scratch1 = e[x];
			}
		    }
		    if (x < 4){ 
		    	for (int y = x + 1; y < 5; y++){
		    	    if(e[y] == e [x]){
		    	        three = true;
				scratch3 = e[y];
				if (e[y] == scratch1){
			            two = false; scratch1 = 0;
				} else { 
			        if (e[y] == scratch2){
				    twoPair = false; scratch2 = 0;
				}
				}  
		    	    }
	 	        }
		    }
		}
	    }	     
	}

	//check for full house
	if ((two) & (three)){
	    house = true; three = false; two = false;
	    scratch1 = 0; scratch2 = 0; scratch3 = 0;
	}

	//check for lowStraight
        if ((e[0] == e[1] + 1) & (e[1] == e[2] + 1) & 
	    (e[2] == e[3] + 1) & (e[3] == e[4] + 1)) {
            lowStraight = true;
        }
        
        //check for highStraight
        if ((e[0] == 13) & (e[1] == 12) &
            (e[2] == 11) & (e[3] ==  10) & (e[4] == 1)) {
            highStraight = true;
        }

	//check for 4 of a kind
	if ( ((e[0] == e[1]) & (e[1] == e[2]) & (e[2] == e[3])) | 
	  ((e[4] == e[3]) & (e[3] == e[2]) & (e[2] == e[1])) ) {
	    four = true;
	    three = false; two = false;
	    scratch1 = 0; scratch2 = 0;
	}

	//check for flush in the 4 suits
	if ( ((c[0] < 14) & (c[0] > 0)) && ((c[1] < 14) & (c[1] > 0)) 
		&& ((c[2] < 14) & (c[2] > 0)) && ((c[3] < 14) & (c[3]>0)) 
		&& ((c[4] < 14) & (c[4] > 0)) ){
	flush = true; }
        if ( ((c[0] < 27) & (c[0] > 13)) && ((c[1] < 27) & (c[1] > 13))
                && ((c[2] < 27) & (c[2] > 13)) && ((c[3] <27) & (c[3]>13))
                && ((c[4] < 27) & (c[4] > 13)) ){
        flush = true; }
        if ( ((c[0] < 40) & (c[0] > 26)) && ((c[1] < 40) & (c[1] > 26))
                && ((c[2] < 40) & (c[2] >26)) && ((c[3] <40) & (c[3]>26))
                && ((c[4] < 40) & (c[4] > 26)) ){
        flush = true; }
        if ( ((c[0] < 53) & (c[0] > 39)) && ((c[1] < 53) & (c[1] > 39))
                && ((c[2] < 53) & (c[2] >39)) && ((c[3]< 53) & (c[3]>39))
                && ((c[4] < 53) & (c[4] > 39)) ){
        flush = true; }

	String results = "Nothing";

	//map boolean flags to english representation
	if (flush) { results = "Flush"; }
	if (three) { results = "Three of a kind"; }
	if (twoPair) { results = "Two pair";
	} else {
            if (two) { 
		if ((scratch1 == 1) | (scratch1 > 10)){
		     results = "Pair of Jacks or better";
	        } else {
		     results = "A low pair";
	 	} 
	    }
	}
	if (house){ results = "Full house";}
	if ((lowStraight) | (highStraight)){ results = "Straight";}
	if (four){ results = "Four of a kind"; }
	if ((lowStraight) & (flush)) { results = "Straight flush";}
	if ((highStraight) & (flush)) { results = "Royal flush";}

	return results;
    }

   /**
    * Return payout ration compared to 1 from english representation
    */
    public int getPayout(String hand){
	if (hand.equals("A low pair")) { return 0;}
        if (hand.equals("Pair of Jacks or better")) { return 1;}
        if (hand.equals("Two pair")) { return 2;}
        if (hand.equals("Three of a kind")) { return 4;}
        if (hand.equals("Straight")) { return 5;}
        if (hand.equals("Flush")) { return 9;}
        if (hand.equals("Full house")) { return 15;}
        if (hand.equals("Four of a kind")) { return 40;}
        if (hand.equals("Straight flush")) { return 150;}
        if (hand.equals("Royal Flush")) { return 400;}

	return 0;
    }

   /*
    * Method used by one of the sorts to shift cards from right to left
    */
    private void shift(int[] f, int x){
        for (int i = 4; i > x; i--){
            f[i] = f[i - 1];
	}	
	this.e = f;
    }

}
