package poker.business;

import poker.data.other.Fortune;
import java.util.Vector;
import poker.spec.*;
/**
 *
 * EnhyDraw!, beta 4, 5/21/99
 *
 * Copyright 1999, Larry Wolcot & Daryl Tempesta
 * ALL rights reserved. Not for commercial use
 * without written permission from both authors.
 *
 */
public class FortuneManagerImpl implements FortuneManager,java.io.Serializable {

   private Vector fortuneList = new Vector(0);
   private int lastFortuneNumber;

   public void addFortune(String fortune) {

    int num = 1;
    if (fortuneList.size() > 1) {
      Fortune lastFortune = (Fortune)fortuneList.lastElement();
      num = lastFortune.getFortuneNumber() + 1;
	  }

    Fortune newFortune = new Fortune(num, fortune);
    newFortune.setHasBeenUsed(false);
    fortuneList.addElement(newFortune);
  }

  public String getFortune() {
	  String fortune = "";
	  if (fortuneList.size() == 0) {
	    fortune = "";
    }
    else {
      Fortune nextFortune =	(Fortune)fortuneList.elementAt(lastFortuneNumber);
	    fortune = nextFortune.getFortune();
	    lastFortuneNumber++;
	  }

    if (lastFortuneNumber >= fortuneList.size()){
        lastFortuneNumber = 0;
    }

	  return fortune;
  }

}
