package poker.business;

import java.util.Vector;
import java.sql.SQLException;
import poker.data.DODS_GameData.*;
import poker.data.DODS_PitBoss.*;
import poker.data.game.*;
import com.lutris.appserver.server.sql.*;
import com.lutris.appserver.server.Enhydra;
import com.lutris.logging.Logger;
import com.lutris.util.*;
//import dods.builder.sourceGenerators.Query.*;
import com.lutris.dods.builder.generator.query.*;
import poker.spec.*;
/**
 *
 * EnhyDraw!, beta 4, 5/21/99
 *
 * Copyright 1999, Larry Wolcot & Daryl Tempesta
 * ALL rights reserved. Not for commercial use
 * without written permission from both authors.
 *
 * FIX: This thing only runs in "Vector" mode for now.
 * I ran outta time to finish  :(
 * Hopefully, I can get some time to finish in the next few months.
 *
 * This is the PitBossList object that does all of the database dirtywork.
 * specific to each game module like Poker, BlackJack21 and Slots.
 *
 */
public class PitBossListImpl extends Vector implements PitBossList,java.io.Serializable {
    private boolean useDB = false;
    private String appName = "Poker";

   /**
    * Public Constructor
    */
    public PitBossListImpl(){
	    super(0);
    }

    /**
     * This method returns a copy of the PitBoss object.
     */
    protected PitBossList getCopy() {
      PitBossListImpl newCopy = new PitBossListImpl();
      newCopy = this;
      return newCopy;
    }

    /**
     * Here is where we determine how to store our data.. db or memory.
     */
    public void setUseDB(boolean useDB) throws Exception{
      //FIX
      // This is all bunk. PitBoss DODS Object needs
      // to be finished.. It's 95% done but I ran out of time
      // for now.
      try {
        this.useDB = useDB;
          if (!getDoesExist(this.appName)){
            PitBossVDO newPitBossVDO = new PitBossVDO();
            newPitBossVDO.setGameName(appName);
            addPitBoss(newPitBossVDO);
          }

      }
      catch(Exception e) {
        e.printStackTrace();
        throw e;
      }
    }

   /**
    * Send to the Vector() or the DB depending on the useDB flag
    * This is where we hook into the DODS_GameData Object
    */
    public synchronized void addPitBoss(PitBossVDO thisPitBoss){
	    if (!useDB) {
	      super.addElement(thisPitBoss);
	    }
      else {
        try {
            addPitBossToDB(thisPitBoss);
        }
        catch (Exception e) {
      //There was a problem adding the game!  bummer..
        }
      }
    }

   /**
    * This is a private method that maps the PokerGame to
    * a GameDataDO Object so it can be inserted into the database.
    */
    public synchronized void addPitBossToDB(PitBossVDO thisPitBossVDO)
							throws Exception{
      //remap the PokerGame Object into a GameDataDO built by DODS.
      PitBossDO nullDO = null;
      PitBossDO newPitBossDO = mapToDO(nullDO, thisPitBossVDO);
      try {
          DBTransaction db =Enhydra.getDatabaseManager().createTransaction();
          try {
        //Insert the newly mapped object into the DB
        db.insert(newPitBossDO);
        db.commit();
          } catch (SQLException se) {
        //Something went wrong, so roll it back and pass it on!
        db.rollback();
              throw se;
          } finally {
        //This releases all resources allocated in last trans
        db.release();
          }
      } catch (Exception e) {
        throw e;
      }
    }

    /**
     * This private method takes a PitBossVDO (Vector) object and maps it
     * into a DODS PitBossDO object. Ideally, they would be the same
     * but this is used to illustrate adding a DODS object to
     * a completed application.
     */
    private synchronized PitBossDO mapToDO(
		PitBossDO newPitBossDO, PitBossVDO newPitBossVDO){
       try {
        newPitBossDO = PitBossDO.createVirgin();
        newPitBossDO.setGameName(newPitBossVDO.getGameName());
        newPitBossDO.setTotalDollars(newPitBossVDO.getTotalDollars());
	      newPitBossDO.setTotalHandsDealt(newPitBossVDO.getTotalHandsDealt());
        newPitBossDO.setTotalHandsWon(newPitBossVDO.getTotalHandsWon());
	      newPitBossDO.setTotalBankrupt(newPitBossVDO.getTotalBankrupt());
       }
       catch (Exception e){
	   //This is a DODS sourceGenetaror exception
       }
       return newPitBossDO;
    }

    /**
     * This private method takes a GameDataDO object and maps it
     * into a PokerGame object. Ideally, they would be the same
     * but this is used to illustrate adding a DODS objects to
     * a completed application.
     */
    private synchronized PitBossVDO
			mapNewPitBossVDO(PitBossDO thisPitBossDO){
	PitBossVDO newPitBossVDO = new PitBossVDO();

      try {
        newPitBossVDO.setGameName(thisPitBossDO.getGameName());
        newPitBossVDO.setTotalDollars(thisPitBossDO.getTotalDollars());
        newPitBossVDO.setTotalBankrupt(thisPitBossDO.getTotalBankrupt());
	      newPitBossVDO.setTotalHandsDealt(thisPitBossDO.getTotalHandsDealt());
        newPitBossVDO.setTotalHandsWon(thisPitBossDO.getTotalHandsWon());
      }
      catch (Exception e){
           //There really shouldn't be an exception
      }
      return newPitBossVDO;
    }

    /**
     * This is a provate method that returns the GameDataDO
     * from the database where oId = id
     */
    private PitBossDO getPitBossDOByName(String name)
						throws Exception{
      PitBossDO gotPitBossDO = null;
      PitBossQuery dq = new PitBossQuery();
      dq.setQueryGameName(name);

      try {
          gotPitBossDO = (PitBossDO) dq.getNextDO();
      }
      finally {
          // Free up any resources
          //dq.release();
      }
      return gotPitBossDO;
    }

    /**
     * This method ddtermines which storage medium is ised, then
     * doles the getGameByName request to the right place.
     */
    public PitBossVDO getPitBossVDO(String name){
        PitBossVDO thisPitBossVDO = new PitBossVDO();

      if (useDB){
          try {
             PitBossDO thisDO = null;
             thisDO = getPitBossDOByName(name);
             thisPitBossVDO = mapNewPitBossVDO(thisDO);

          }
          catch (Exception e) {
             //FIX: Still need to take care of some exceptions :)
          }
      }
      else {
          thisPitBossVDO = getPitBossInMemory(name);
      }

	    return thisPitBossVDO;
    }

    /**
     * Return the game that belongs to user name
     * from the Vector in memory
     */
    public synchronized PitBossVDO getPitBossInMemory(String name){

      PitBossVDO thisPitBossVDO = new PitBossVDO();

      //Get copy of the PitBossList object so we dont have to
      //worry about locking it for threadsafe opps
      PitBossListImpl PitBossListCopy = (PitBossListImpl)this.getCopy();
      //Yeah, I could have done this another way, but I didn't
      for (int i = 0; i < PitBossListCopy.size(); i++){
          thisPitBossVDO = (PitBossVDO)PitBossListCopy.elementAt(i);
          if (thisPitBossVDO.getGameName().equals(name)){
              return thisPitBossVDO;
          }
      }
      return thisPitBossVDO;
    }

    /**
     * Check to see if the DO changes need to be updated to the DB
     */
    public synchronized void updatePitBoss(PitBossVDO thisVDO){
	    if (this.useDB) {
	    try {
        PitBossDO pitBossDO = getPitBossDOByName(thisVDO.getGameName());
        pitBossDO.setGameName(thisVDO.getGameName());
        pitBossDO.setTotalDollars(thisVDO.getTotalDollars());
        pitBossDO.setTotalBankrupt(thisVDO.getTotalBankrupt());
        pitBossDO.setTotalHandsDealt(thisVDO.getTotalHandsDealt());
        pitBossDO.setTotalHandsWon(thisVDO.getTotalHandsWon());

        DBTransaction db = Enhydra.getDatabaseManager().createTransaction();
         try {
             db.update(pitBossDO);
             db.commit();
         }
         catch (SQLException sqle) {
             db.rollback();
             throw sqle;
         } finally {
             db.release();
         }
	    } catch (Exception e) {
                Enhydra.getLogChannel().write(Logger.DEBUG, "ERROR! " +
                        e.toString());
                //FIX: Still need to take care of some exceptions :)
	    }
	}
    }

    /**
     * This method ddtermines which storage medium is ised, then
     * doles the exists request to the right place.
     */
    public boolean getDoesExist(String name){
        boolean exists = false;
	PitBossVDO thisVDO = getPitBossVDO(name);

	if( (thisVDO != null) && (!thisVDO.getGameName().equals("") ) ){
	    exists = true;
	}

	return exists;
    }

}
