package poker.data.game;


import java.util.Vector;

/**
 * 
 * EnhyDraw!, beta 4, 5/21/99
 *
 * Copyright 1999, Larry Wolcot & Daryl Tempesta
 * ALL rights reserved. Not for commercial use
 * without written permission from both authors.
 *
 * Forgive the lack of docs and CR's in the Data Objects.
 * I don't have a lot of time for this project, and this
 * should be easy enough to figure out
 */
public class PokerGameDO implements java.io.Serializable {
    private int cash = 0;
    private int playRound = 0;
    private String id = "";
    private int bet = 0;
    private int largestBet = 0;
    private int smallestBet = 0;
    private int totalPlayed = 0;
    private int totalWon = 0;
    private int defaultBet = 100;
    private String deck = "deck1";
    private Vector cardsInHand = new Vector(5);
    private Vector cardsUsed = new Vector(0);
    private Vector dropCards = new Vector(0);
    private String lastError = "";
    private int version = 0;

   /**
    * Basic Constructor
    */
    public PokerGameDO(String id, int cash){
	this.id = id;
	this.cash = cash;
	String drop = "DROP";
	for (int i=0; i < 5; i++){
	    dropCards.addElement(drop);
	}
    }

    //basic "SET" encapsulation methods for this object.
    public void setCash(int cash){ this.cash = cash; }
    public void setVersion(int version){ this.version = version; }
    public void setPlayRound(int playRound){ this.playRound = playRound; }
    public void setID(String id){ this.id = id; }
    public void setBet(int bet){ this.bet = bet; }
    public void setLargestBet(int large){ this.largestBet = large;}
    public void setSmallestBet(int small){ this.smallestBet = small;}
    public void setTotalPlayed(int total){ this.totalPlayed = total;}
    public void setTotalWon(int total){ this.totalWon = total; }
    public void setCardsInHand(Vector cih){ this.cardsInHand = cih; }
    public void setCardsUsed(Vector cu){ this.cardsUsed = cu; }
    public void setDropCards(Vector dc){ this.dropCards = dc; }
    public void setDeck(String deck){ this.deck = deck; }
    public void setDefaultBet(int db){ this.defaultBet = db;}
    public void setLastError(String le){ this.lastError = le; }

    //basic "GET" encapsulation methods for this object.
    public int getCash(){ return cash; }
    public int getVersion(){ return version; }
    public int getPlayRound(){ return playRound; }
    public String getLastError(){ return lastError; }
    public String getID(){ return id; }
    public int getBet(){ return bet; }
    public int getLargestBet(){ return largestBet; }
    public int getSmallestBet(){ return smallestBet; }
    public int getTotalPlayed(){ return totalPlayed; }
    public int getTotalWon(){ return totalWon; }
    public Vector getCardsInHand(){ return cardsInHand; }
    public Vector getCardsUsed(){ return cardsUsed; }
    public Vector getDropCards(){ return dropCards; }
    public int getDefaultBet(){ return defaultBet; }
    public String getDeck(){ return deck; }
} 
