/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.login;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.util.KeywordValueException;
import org.w3c.dom.html.HTMLInputElement;

public class CreatePlayerPresentation implements HttpPresentation {


    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, KeywordValueException {

        CreatePlayerHTML createPlayer;
        createPlayer = (CreatePlayerHTML)comms.xmlcFactory.create(CreatePlayerHTML.class);

	      String name =(String)comms.request.getParameter("username");
        String pw = (String)comms.request.getParameter("password");
        String email = (String)comms.request.getParameter("email");
        String cash = (String)comms.request.getParameter("cash");
        String m = (String)comms.session.getSessionData().get("error");

        if (m != null) {
          createPlayer.setTextError(m);
        }
        else
          createPlayer.setTextError("");

        HTMLInputElement input = null;
        if (name != null) {
          input = createPlayer.getElementUsername();
          input.setValue(name);
        }
	      else {
          input = createPlayer.getElementUsername();
          input.setValue("");
        }

        if (pw != null) {
          input = createPlayer.getElementPassword();
          input.setValue(pw);
          input.setAttribute("type","password");
        }
        else {
          input = createPlayer.getElementPassword();
          input.setValue("");
        }

        if (email != null) {
          input = createPlayer.getElementEmail();
          input.setValue(email);
        }
        else {
          input = createPlayer.getElementEmail();
          input.setValue("");
        }
        if (cash != null) {
          input = createPlayer.getElementCash();
          input.setValue(cash);
        }
        else {
          input = createPlayer.getElementCash();
          input.setValue("500");
        }

        comms.response.writeDOM(createPlayer);
    }

}
