/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.login;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.util.KeywordValueException;
import org.w3c.dom.html.HTMLInputElement;

public class LoginPresentation implements HttpPresentation {


    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, KeywordValueException {

        LoginHTML login;
        login = (LoginHTML)comms.xmlcFactory.create(LoginHTML.class);

        // Get the initial text for the username (if any).
        String username =	(String)comms.session.getSessionData().get("oname");
        String password = "";
        String cash = "";
	      String id = comms.session.getSessionKey();
	      String m = (String)comms.session.getSessionData().get("loginMessage");
	      if (m != null) {
          login.setTextMessage(m);
        }
        else
          login.setTextMessage("Enter your username, password and desired" +
                                " additional cash amount!");

        if (username == null || username.equals("")) {
          username = comms.request.getParameter("username");
          password = comms.request.getParameter("pw");
          cash = comms.request.getParameter("cash");
        }
        if (username == null || username.equals("")) {
          username = comms.request.getParameter("");
          password = comms.request.getParameter("");
          cash = comms.request.getParameter("");
        }


        // Store the values, so they can be acessed as html fields.

        HTMLInputElement input = null;
        input = login.getElementId();
        input.setValue(id);
        input = login.getElementUsername();
        input.setValue(username);
        input = login.getElementPassword();
        input.setValue(password);
        input.setAttribute("type","password");
        input = login.getElementCash();
        input.setValue(cash);

        input = login.getElementUsernameCreate();
        input.setValue(username);
        input = login.getElementPasswordCreate();
        input.setValue(password);
        input = login.getElementCashCreate();
        input.setValue(cash);

        comms.response.writeDOM(login);
    }

}
