/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.login;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.util.KeywordValueException;

import poker.Poker;
import poker.spec.FortuneManager;

public class WelcomePresentation implements HttpPresentation {


  public void run(HttpPresentationComms comms)
      throws HttpPresentationException, KeywordValueException {

    WelcomeHTML welcome;
    welcome = (WelcomeHTML)comms.xmlcFactory.create(WelcomeHTML.class);
      
   try{
    Poker mainApp = (Poker)comms.session.getSessionData().get("app");
    FortuneManager fortuneManager = mainApp.getFortuneManager();
    String fortune = fortuneManager.getFortune();
   welcome.setTextMessage(fortune);
   }catch(Exception e){}
   

    comms.response.writeDOM(welcome);
  }

}
