/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.main;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import org.w3c.dom.html.HTMLInputElement;
import com.lutris.util.KeywordValueException;
import com.lutris.appserver.server.session.SessionException;

import poker.Poker;
import poker.spec.PokerGame;
import poker.spec.GameManager;

public class BankruptPresentation implements HttpPresentation {


    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, KeywordValueException, SessionException {

      BankruptHTML bankrupt;
      bankrupt = (BankruptHTML)comms.xmlcFactory.create(BankruptHTML.class);

      Poker mainApp = (Poker)comms.session.getSessionData().get("app");
      GameManager gameManager = mainApp.getGameManager();
      PokerGame game = (PokerGame)comms.session.getSessionData().get("game");

      HTMLInputElement input = null;
      String temp = null;

      temp = game.getName();
      input = bankrupt.getElementUsername();
      if (temp != null) {
        bankrupt.setTextName(temp);
        input.setValue(temp);
      }
      else {
        bankrupt.setTextName("");
        input.setValue("");
      }

      temp = game.getPassword();
      input = bankrupt.getElementPassword();
      if (temp != null)
        input.setValue(temp);
      else
        input.setValue("");

      temp = game.getEmail();
      input = bankrupt.getElementEmail();
      if (temp != null)
        input.setValue(temp);
      else
        input.setValue("");

      gameManager.removeGame(game.getName());
      comms.session.setUser(null);
      String message = "User is bankrupt and removed!";
      comms.session.getSessionData().set("error", message);

      comms.response.writeDOM(bankrupt);
  }

}
