/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.main;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
//import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
//import com.lutris.util.KeywordValueException;
import org.w3c.dom.html.HTMLDivElement;
import org.w3c.dom.html.HTMLInputElement;
import org.w3c.dom.html.HTMLImageElement;
import org.w3c.dom.html.HTMLTableRowElement;
import org.w3c.dom.Node;

import java.util.Vector;

import poker.Poker;
import poker.spec.*;

//import poker.data.game.*;


public class FirstDealPresentation implements HttpPresentation {

/*
 *  This Vector keeps track of the cards already dealt (no 2 cards are the same!)
 */
  private static Vector dealtCards = new Vector(0);

  private static int pointer = 0;


  public void run(HttpPresentationComms comms)
      throws Exception {

    FirstDealHTML firstDeal;
    firstDeal = (FirstDealHTML)comms.xmlcFactory.create(FirstDealHTML.class);

    this.startGame(comms, firstDeal);
    this.getCards(comms, firstDeal);
    this.checkHand(comms, firstDeal);

    HTMLDivElement div = null;
    HTMLTableRowElement row = null;
    Node parent = null;
    if(this.isLastDeal(comms)) {
      div = firstDeal.getElementIsNotLastDeal1();
      parent = div.getParentNode();
      parent.removeChild(div);

      firstDeal.setTextIsLastDeal2("Click on NEW HAND to play another round");
      firstDeal.setTextIsNotLastDeal2("");

      row = firstDeal.getElementIsNotLastDeal3();
      parent = row.getParentNode();
      parent.removeChild(row);

      row = firstDeal.getElementIsNotLastDeal4();
      parent = row.getParentNode();
      parent.removeChild(row);

      row = firstDeal.getElementIsNotLastDeal5();
      parent = row.getParentNode();
      parent.removeChild(row);
    }
    else {
      div = firstDeal.getElementIsLastDeal1();
      parent = div.getParentNode();
      parent.removeChild(div);

      firstDeal.setTextIsLastDeal2("");
      firstDeal.setTextIsNotLastDeal2("Select the cards you wish to keep, then press DRAW!");

      row = firstDeal.getElementIsLastDeal3();
      parent = row.getParentNode();
      parent.removeChild(row);

      row = firstDeal.getElementIsLastDeal4();
      parent = row.getParentNode();
      parent.removeChild(row);

      row = firstDeal.getElementIsLastDeal5();
      parent = row.getParentNode();
      parent.removeChild(row);
    }

    if(this.isBankrupt(comms)) {
      div = firstDeal.getElementIsNotBankrupt();
      parent = div.getParentNode();
      parent.removeChild(div);
    }
    else {
      div = firstDeal.getElementIsBankrupt();
      parent = div.getParentNode();
      parent.removeChild(div);
    }

    comms.response.writeDOM(firstDeal);
  }



  static public void getCards(HttpPresentationComms comms0, FirstDealHTML firstDeal0) throws Exception {
    PokerGame game = (PokerGame) comms0.session.getSessionData().get("game");
    Vector theseCards = game.getCardsInHand();
    Vector usedCards = game.getCardsUsed();
    Vector dropCards = game.getDropCards();
    String but[] ={ "DROP", "DROP", "DROP", "DROP", "DROP" };
    
    Dealer dealer = DealerFactory.getDealer("poker.business.DealerImpl");
    String flag;
    
    if (game.getPlayRound() == 3) {
      theseCards = dealer.drawMoreCards(theseCards, dropCards);
      for (int i = 0; i < 5; i ++) {
        flag = (String)dropCards.elementAt(i);
        if (flag.equals("DROP")) {
          dropCards.setElementAt("DEALT", i);
        }
        else {
          dropCards.setElementAt("HELD", i);
        }
      }
    }

    Integer card[] = new Integer[5];
    String[] drop = new String[5];

    for (int i = 0; i < 5; i++) {
      HTMLImageElement image = null;
      HTMLInputElement input = null;
      card[i] = (Integer) theseCards.elementAt(i);
      String srcImage =  "../media/" + card[i].toString() + ".gif";
      drop[i] = (String)dropCards.elementAt(i);

//      page.data.set("drop" + n, drop[i]);  ? gde ovo smestiti na html strani
      switch (i) {
        case 0 : {
          image = firstDeal0.getElementCard1();
          image.setSrc(srcImage);
          image = firstDeal0.getElementCard11();
          image.setSrc(srcImage);

          input = firstDeal0.getElementBut1();
          if (drop[i] != "DROP") {
            but[i] = "DROP";
          }
          input.setValue(but[i]);
          break;
        }
        case 1 : {
          image = firstDeal0.getElementCard2();
          image.setSrc(srcImage);
          image = firstDeal0.getElementCard22();
          image.setSrc(srcImage);

          input = firstDeal0.getElementBut2();
          if (drop[i] != "DROP") {
            but[i] = "DROP";
          }
          input.setValue(but[i]);
          break;
        }
        case 2 : {
          image = firstDeal0.getElementCard3();
          image.setSrc(srcImage);
          image = firstDeal0.getElementCard33();
          image.setSrc(srcImage);

          input = firstDeal0.getElementBut3();
          if (drop[i] != "DROP") {
            but[i] = "DROP";
          }
          input.setValue(but[i]);
          break;
        }
        case 3 : {
          image = firstDeal0.getElementCard4();
          image.setSrc(srcImage);
          image = firstDeal0.getElementCard44();
          image.setSrc(srcImage);

          input = firstDeal0.getElementBut4();
          if (drop[i] != "DROP") {
            but[i] = "DROP";
          }
          input.setValue(but[i]);
          break;
        }
        case 4 : {
          image = firstDeal0.getElementCard5();
          image.setSrc(srcImage);
          image = firstDeal0.getElementCard55();
          image.setSrc(srcImage);

          input = firstDeal0.getElementBut5();
          if (drop[i] != "DROP") {
            but[i] = "DROP";
          }
          input.setValue(but[i]);
          break;
        }
      }
    }
  }

  public void startGame(HttpPresentationComms comms0, FirstDealHTML firstDeal0) throws Exception {
   Dealer dealer = DealerFactory.getDealer("poker.business.DealerImpl");
    PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
    Poker mainApp = (Poker)comms0.session.getSessionData().get("app");
    GameManager gameManager = mainApp.getGameManager();
    if ((game.getBet() < game.getSmallestBet()) | (game.getSmallestBet() == 0)) {
      game.setSmallestBet(game.getBet());
    }
    if (game.getBet() > game.getLargestBet()) {
       game.setLargestBet(game.getBet());
    }
    if (game.getPlayRound() == 3) {
      game.setPlayRound(4);
    }
    String dl = (String)comms0.request.getParameter("DROP1");
    if ((dl != null) & (game.getPlayRound() < 4)) {
       game.setPlayRound(3);
    }
    if (game.getPlayRound() == 1) {
       game.setCardsInHand(dealer.dealFiveCards());
       game.setPlayRound(2);
    }
    String d[] = { "DROP", "DROP", "DROP", "DROP", "DROP" };
    String iS = "";
    for (int i=0; i < 5; i++) {
      iS = Integer.toString(i+1);
      if ((String)comms0.request.getParameter("DROP" + iS) != null) {
        d[i] = (String)comms0.request.getParameter("DROP" + iS);
      }
    }

    Vector dropCards = game.getDropCards();

    for (int i = 0; i < 5; i++) {
      String n = Integer.toString(i+1);
      if (d[i].equals("HOLD")) {
        dropCards.setElementAt("HOLD" ,i);
      }
      if (d[i].equals("DROP")){
        dropCards.setElementAt("DROP" ,i);
      }
    }

    firstDeal0.setTextName(game.getName());
    firstDeal0.setTextCash(Integer.toString(game.getCash()));
    firstDeal0.setTextBet(Integer.toString(game.getBet()));
    firstDeal0.setTextRank(Integer.toString(gameManager.getRank(game.getCash())));
    firstDeal0.setTextHandsPlayed(Integer.toString(game.getTotalPlayed()));
    firstDeal0.setTextWon(Integer.toString(game.getTotalWon()));

    //gameManager.updateGame(game);
   }


  static public void checkHand(HttpPresentationComms comms0, FirstDealHTML firstDeal0) throws Exception {
    Dealer dealer = DealerFactory.getDealer("poker.business.DealerImpl");
    PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
    Vector theseCards = game.getCardsInHand();
    String handTotal = dealer.checkHand(theseCards);
    int payRate = dealer.getPayout(handTotal);
    String message = handTotal + ",   pays $" +
      new Integer(payRate * game.getBet()).toString() + " (" +
      new Integer(payRate).toString() + " to 1)";
    firstDeal0.setTextResult(message);

    if (game.getPlayRound() > 2) {
      if (game.getCash() == 0) {
        Poker app =(Poker)comms0.session.getSessionData().get("app");
        GameManager g = app.getGameManager();
        g.setTotalBankrupt(+1);
      }
      Poker mainApp = (Poker)comms0.session.getSessionData().get("app");
      GameManager g = mainApp.getGameManager();
      if (game.getPlayRound() == 3) {
        if (payRate > 0) {
          game.setTotalWon(game.getTotalWon() + 1);
        }
        if (payRate > 0) {
          g.setTotalHandsWon(1);
        }
        g.setTotalDollars(-(game.getBet() * payRate));
        game.setCash(game.getCash() + (game.getBet() * payRate));
        firstDeal0.setTextCash(Integer.toString(game.getCash()));
      }
      g.updateGame(game);
    }
  }


  static public boolean isLastDeal( HttpPresentationComms comms0 ) throws Exception {
    PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
    if (game.getPlayRound() > 2){
      return true;
    }
    else {
      return false;
    }
  }


   static public boolean isBankrupt( HttpPresentationComms comms0 ) throws Exception {
      PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
      if ((game.getCash() == 0) & (game.getPlayRound() == 3)) {
        return true;
      }
      else {
        return false;
      }
   }


   static public void getMarker( HttpPresentationComms comms0, FirstDealHTML firstDeal0 ) throws Exception {
      PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
      Vector drops = game.getDropCards();
      String marker = (String)drops.elementAt(pointer);
      HTMLImageElement image = null;

      switch (pointer) {
        case 0: {
          image = firstDeal0.getElementGetMarker1();
          break;
        }
        case 1: {
          image = firstDeal0.getElementGetMarker2();
          break;
        }
        case 2: {
          image = firstDeal0.getElementGetMarker3();
          break;
        }
        case 3: {
          image = firstDeal0.getElementGetMarker4();
          break;
        }
        case 4: {
          image = firstDeal0.getElementGetMarker5();
          break;
        }
      }

      if ( (marker.equals("DROP")) | (marker.equals("DEALT")) ) {
        image.setSrc("../media/draw_n.gif");
        image.setName("\"but" + Integer.toString(pointer+1));
      }
      else {
        image.setSrc("../media/hold_n.gif");
        image.setName("\"but" + Integer.toString(pointer+1));
      }

      pointer++;
      if (pointer == 5) {
        pointer = 0;
      }
   }

}
