/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.main;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import org.w3c.dom.html.HTMLTextAreaElement;
import org.w3c.dom.html.HTMLInputElement;
import org.w3c.dom.html.HTMLImageElement;

import poker.Poker;
import poker.spec.PokerGame;
import poker.spec.GameManager;

import java.util.Vector;

public class PlaceBetPresentation implements HttpPresentation {

  public void run(HttpPresentationComms comms)
                        throws Exception {

    PlaceBetHTML placeBet;
    placeBet = (PlaceBetHTML)comms.xmlcFactory.create(PlaceBetHTML.class);
/*
 * Catch Null pointer exception ( we canot make a instances of classes from business layer when we run poker_pres )
 * We need  to allow poker_pres to be dynamic , so if the requested url is /poker_pres/..... the response
 * will be default HTML page
 */ 
   try{
    this.initGame(comms, placeBet);
}catch (NullPointerException  e){
	placeBet.setTextMessage("This is a default HTML page");
	}

    comms.response.writeDOM(placeBet);

  }

   static public void initGame(HttpPresentationComms comms0, PlaceBetHTML placeBet0)
                                                          throws Exception {
    PokerGame game = (PokerGame)comms0.session.getSessionData().get("game");
    Poker mainApp = (Poker)comms0.session.getSessionData().get("app");
    GameManager gameManager = mainApp.getGameManager();
      
    game.setPlayRound(1);

	  Vector freshDrops = new Vector(0);
	  for (int i = 0; i < 5; i++) {
	    freshDrops.addElement("DROP");
	  }
    game.setDropCards(freshDrops);

    placeBet0.setTextCash(Integer.toString(game.getCash()));
    placeBet0.setTextName(game.getName());
    placeBet0.setTextRank(Integer.toString(gameManager.getRank(game.getCash())));
    placeBet0.setTextWon(Integer.toString(game.getTotalWon()));
    placeBet0.setTextHandsPlayed(Integer.toString(game.getTotalPlayed()));

    HTMLImageElement image = null;
    image = placeBet0.getElementDeck1();
    image.setSrc("../media/" + game.getDeck() + ".jpg");
    image = placeBet0.getElementDeck2();
    image.setSrc("../media/" + game.getDeck() + ".jpg");
    image = placeBet0.getElementDeck3();
    image.setSrc("../media/" + game.getDeck() + ".jpg");
    image = placeBet0.getElementDeck4();
    image.setSrc("../media/" + game.getDeck() + ".jpg");
    image = placeBet0.getElementDeck5();
    image.setSrc("../media/" + game.getDeck() + ".jpg");

    HTMLInputElement input = null;
    input = placeBet0.getElementBetInput();
    input.setValue( Integer.toString(game.getDefaultBet()) );

    if (game.getDefaultBet() > 0) {
      input = placeBet0.getElementCheckInput();
      input.setChecked(true);
      input.setValue("on");
    }
    else {
      input = placeBet0.getElementCheckInput();
      input.setChecked(false);
      input.setValue("off");
    }

    if (game.getLastError() != "") {
      placeBet0.setTextMessage(game.getLastError());
      game.setLastError("");
    }
    else {
      placeBet0.setTextMessage("");
    }
  }


}
