/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.main;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.util.KeywordValueException;
import com.lutris.appserver.server.session.SessionException;

import poker.Poker;
import poker.spec.PokerGame;
import poker.spec.GameManager;

public class QuitPresentation implements HttpPresentation {

    public void run(HttpPresentationComms comms)
        throws HttpPresentationException, SessionException, KeywordValueException {

        QuitHTML quit;
        quit = (QuitHTML)comms.xmlcFactory.create(QuitHTML.class);

        Poker mainApp = (Poker)comms.session.getSessionData().get("app");
        GameManager gameManager = mainApp.getGameManager();
        PokerGame game = (PokerGame)comms.session.getSessionData().get("game");

/*
 * Catch Null pointer exception ( we canot make a instances of classes from business layer when we run poker_pres )
 * We need  to allow poker_pres to be dynamic , so if the requested url is /poker_pres/..... the response
 * will be default HTML page
 */
try{
        String name = game.getName();
        quit.setTextName(name);

        comms.session.setUser(null);
        if (game.getCash() < 1){
           gameManager.removeGame(name);
        }
}catch (NullPointerException  e){}
        comms.response.writeDOM(quit);
    }

}
