/*
 *  Poker
 *
 *  Enhydra super-servlet presentation object
 *
 */

package poker.presentation.main;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import com.lutris.util.KeywordValueException;
import org.w3c.dom.html.HTMLTableElement;
import org.w3c.dom.html.HTMLTableRowElement;
import org.w3c.dom.html.HTMLAnchorElement;

import poker.Poker;
import poker.spec.PokerGame;
import poker.spec.GameManager;

import java.util.Vector;

public class ScoresPresentation implements HttpPresentation {


  public void run(HttpPresentationComms comms)
          throws HttpPresentationException, KeywordValueException {

    ScoresHTML scores;
    scores = (ScoresHTML)comms.xmlcFactory.create(ScoresHTML.class);

    HTMLTableRowElement dummyRow = (HTMLTableRowElement)scores.getElementDummyRow();
    HTMLTableElement table = (HTMLTableElement)scores.getElementScoreTable();

    Poker mainApp = (Poker)comms.session.getSessionData().get("app");
    GameManager gameManager = mainApp.getGameManager();


/*
 * Catch Null pointer exception ( we canot make a instances of classes from business layer when we run poker_pres )
 * We need  to allow poker_pres to be dynamic , so if the requested url is /poker_pres/..... the response
 * will be default HTML page
 */    
try{   
    Vector topTen = gameManager.getTopTen();

    PokerGame game;
    for (int i = 0; i < 10; i++) {
      game = (PokerGame)topTen.elementAt(i);
      if (!game.getName().equals("")) {
        scores.setTextNumbers(Integer.toString(i));
        scores.setTextName(game.getName());
        scores.setTextCach(Integer.toString(game.getCash()));
        HTMLAnchorElement a = scores.getElementEmail();
        a.setHref("MAILTO:" + game.getEmail());
        scores.setTextHands(Integer.toString(game.getTotalPlayed()));
      }
      else {
        scores.setTextNumbers(Integer.toString(i));
        scores.setTextName(" ");
        scores.setTextCach(" ");
        HTMLAnchorElement a = scores.getElementEmail();
        a.setHref("MAILTO:a@a.co.yu");
        scores.setTextHands(" ");
      }
      HTMLTableRowElement clonedRow = (HTMLTableRowElement)dummyRow.cloneNode(true);
      table.insertBefore(clonedRow, table.getLastChild());
    }

    table.removeChild(dummyRow);
}catch (NullPointerException  e){}
    comms.response.writeDOM(scores);
  }

}
