/*
 *  poker
 *
 *  Enhydra super-servlet specification object
 *  
 */
package poker.spec;

import java.lang.reflect.Constructor;

public class PokerGameFactory {
    
    /**
     * Constructor can't be used.
     */
    private PokerGameFactory() {
    }

    /**
     * Create a PokerGame as state object/value object/data transfer object
     */
    public static PokerGame getPokerGame(String fullClassName) {
        
        PokerGame result = null;
       
        Class objectClass = null;

        try {
            // Create the value object
       
      
         objectClass = Class.forName(fullClassName);
                                   
          result = (PokerGame)objectClass.newInstance();
               
                       
                    
      } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }

   /**
     * Create a PokerGame as state object/value object/data transfer object
     */
  public static PokerGame getPokerGame(String fullClassName,String username,String pw,String id,int cash) {
        
        PokerGame result = null;
       
        Class objectClass = null;

        try {
            // Create the value object
        
         objectClass = Class.forName(fullClassName);
                    
         Class[] parameterTypes =new Class[4];
         
         parameterTypes[0]= String.class;                    
         parameterTypes[1]= String.class; 
         parameterTypes[2]= String.class; 
         parameterTypes[3]= int.class;
       
         Constructor constr =  objectClass.getConstructor(parameterTypes);
         
        
         
        Object[] objects = new Object[4];
        objects[0]=username;
        objects[1]=pw;
        objects[2]=id;
        objects[3]=new Integer(cash);
      
        Object obj =   constr.newInstance(objects);
      
       return (PokerGame)obj;
        
        
                       
                    
      } catch (Exception ex) {
            System.out.println("Error on creating the object" + ex);
        }

        return result;
    }








}