/*
 * projectManagement
 *
 * Enhydra super-servlet
 *
 */

package projectmanagement;


import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.lutris.util.*;

/**
 * The application object.
 *
 * Application-wide data would go here.
 */
public class ProjectManagement extends StandardApplication {

   // The user who is allowed to run this application. Used with basic auth.
   private String adminUsername, adminPassword, locale;

   /**
    * Start the application.
    *
    * @param appConfig
    *   Configuration object for this application.
    * @exception ApplicationException
    *   If an error occurs starting the application.
    */
   public void startup(Config appConfig) throws ApplicationException {
      //Mandatory config settings.
      try {
         adminUsername = appConfig.getString("ProjectManagement.AdminUsername");
         adminPassword = appConfig.getString("ProjectManagement.AdminPassword");

      } catch (ConfigException except) {
         throw new ApplicationException(except);
      }
      super.startup(appConfig);
   }

   public boolean requestPreprocessor(HttpPresentationComms comms)
         throws Exception {

      return super.requestPreprocessor(comms);
   }

   public String getAdminUsername () {
      return adminUsername;
   }

   public String getAdminPassword () {
      return adminPassword;
   }

   /**
    * This is an optional function, used only by the Multiserver's graphical
    * administration. This bit of HTML appears in the status page for this
    * application. You could add extra status info, for example
    * a list of currently logged in users.
    *
    * @return HTML that is displayed in the status page of the Multiserver.
    */
   public String toHtml() {
      return "This is <I>projectManagement</I>";
   }

}

