package projectmanagement.presentation;

import com.lutris.logging.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.*;
import java.io.*;

/**
 * Class to handle authorization errors.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class AuthorizationError implements HttpPresentation {

   /**
    * This implements the run method in HttpPresentation.
    *
    * @param HttpPresentationComms
    * @exception HttpPresentationException
    */
   public void run(HttpPresentationComms comms)
         throws HttpPresentationException {

      AuthorizationErrorHTML page = new AuthorizationErrorHTML();
      String aem="You either don't have appropriate authorization level "+
         "to execute wanted action or your session data dissapeared!"+
         "Please, log in with appropriate authorization so you can "+
         "get access to the wanted action item.";
      page.setTextLblAuthorizationErrorMessage(aem);

      comms.response.writeDOM(page);
   }
}
