package projectmanagement.presentation;

import projectmanagement.presentation.BasePO;
import com.lutris.appserver.server.httpPresentation.*;
import org.enhydra.xml.xmlc.XMLObject;

/**
 * Menu.java just offers menu for further actions.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class Menu extends BasePO {

   /**
    * Superclass method override. Returns 1.
    */
   protected int getRequiredAuthLevel() {
      return 1;
   }

   /**
    *  Default event. Just show the page.
    */
   public XMLObject handleDefault()
         throws HttpPresentationException {
     
      MenuHTML page=new MenuHTML();
      if (getCurrentAuthLevel()==1) {
         // disable some button images
         page.getElementImgCustomer().getParentNode().removeChild(page.getElementImgCustomer());
         page.getElementImgProject().getParentNode().removeChild(page.getElementImgProject());
         page.getElementImgPayRate().getParentNode().removeChild(page.getElementImgPayRate());
         page.getElementImgWorksheet().getParentNode().removeChild(page.getElementImgWorksheet());
      } else {
         page.getElementImgPersonalWorksheet().getParentNode().removeChild(page.getElementImgPersonalWorksheet());
      }
      return page;
   }

}


