/*
 *  projectManagement
 *
 *  Enhydra super-servlet presentation object
 *
 */

package projectmanagement.presentation.projects;

import projectmanagement.presentation.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.*;
import org.enhydra.xml.xmlc.XMLObject;

// Standard imports
import java.io.IOException;

/**
* Generates the blank HTML page.
*/
public class Context extends BasePO {

   private static String CUSTOMER= "customer";
   private static String DISPLAY_ADMIN= "displayAdmin";

   /**
    * Superclass method override. Returns 2.
    */
   protected int getRequiredAuthLevel() {
      return 2;
   }

   /**
    *  Default event. Just show the page.
    */
   public XMLObject handleDefault() throws HttpPresentationException {

      ContextHTML page=new ContextHTML();
      String customerID=this.getComms().request.getParameter(CUSTOMER);
      String displayAdmin=this.getComms().request.getParameter(DISPLAY_ADMIN);
      if (customerID!=null) {
         page.getElementFrameControl().setSrc("Controls.po?"+CUSTOMER+"="+customerID);
      }
      if (displayAdmin!=null && displayAdmin.equalsIgnoreCase("true")) {
         page.getElementFrameAdministering().setSrc("Administering.po?"+CUSTOMER+"="+customerID);
      }

      return page;
   }

}
