/*
 *  projectManagement
 *
 *  Enhydra super-servlet presentation object
 *
 */

package projectmanagement.presentation.worksheets;

import projectmanagement.presentation.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.*;
import org.enhydra.xml.xmlc.XMLObject;

// Standard imports
import java.io.IOException;

/**
* Generates the blank HTML page.
*/
public class Context extends BasePO {

   private static String IS_PERSONAL = "isPersonal";
   private static String DISPLAY_ADMIN= "displayAdmin";
   private static String EMPLOYEE= "employee";

   /**
    * Superclass method override. Returns 1 or 2, depending on action.
    */
   protected int getRequiredAuthLevel() {
      String isPersonal="";
      try {
         isPersonal=this.getComms().request.getParameter(IS_PERSONAL);
      } catch (Exception ex) {}

      if (isPersonal!=null && isPersonal.equalsIgnoreCase("true")) {
         return 1;
      } else {
         return 2;
      }
   }

   /**
    *  Default event. Just show the page.
    */
   public XMLObject handleDefault() throws HttpPresentationException {

      ContextHTML page=new ContextHTML();

      String isPersonal=this.getComms().request.getParameter(IS_PERSONAL);
      String displayAdmin=this.getComms().request.getParameter(DISPLAY_ADMIN);
      String employee=this.getComms().request.getParameter(EMPLOYEE);

      if (isPersonal!=null && isPersonal.equalsIgnoreCase("true")) {
         page.getElementFrameControl().setSrc("Controls.po?isPersonal=true");
      }

      return page;
   }

}
