/*
 *  tableApp
 *
 *  Enhydra super-servlet presentation object
 *
 * Prozone
 *
 */

package tableapp.presentation;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;
import org.enhydra.xml.xmlc.*;
import com.lutris.appserver.server.httpPresentation.*;
import org.w3c.dom.html.*;
import org.w3c.dom.*;
import org.enhydra.apache.html.dom.HTMLDocumentImpl;
// Enhydra SuperServlet specification imports
import tableapp.spec.*;

// Standard imports
import java.io.IOException;

public class WelcomePresentation
    implements HttpPresentation {
  static TableHTML table = null;
  static Access access = null;
  WelcomeHTML welcome;
  static Node accTable = null;
  static int i = 0;
  static HTMLTableRowElement templateRow;
  Document doc;
  public void run(HttpPresentationComms comms) throws HttpPresentationException,
      IOException {

    String now;
    welcome = (WelcomeHTML) comms.xmlcFactory.create(WelcomeHTML.class);
    if (access == null) {
      access = (Access) AccessFactory.createAccess(
          "tableapp.business.AccessImpl");
    }
    if (table == null) {
      table = (TableHTML) comms.xmlcFactory.create(TableHTML.class);
    }
    try {
      Dater dater = DaterFactory.createDater("tableapp.business.DaterImpl");
      now = dater.getDate();
    }
    catch (Exception ex) {
      now = "Could not get business object!!!";
    }

    welcome.setTextTime(now);
    tableNode(now);
    comms.response.writeDOM(welcome);

  }

  public Document tableDoc() {
    if (accTable == null) {
      return null;
    }

    Document doc = accTable.getOwnerDocument();

    return (Document) accTable.getOwnerDocument();
  }

  private void tableNode(String now) {
    if (templateRow == null) {
      templateRow = table.getElementTemplateRow();
    }
    HTMLElement accNumCellTemplate = table.getElementAccNum();
    HTMLElement accTimeCellTemplate = table.getElementAccTime();

    templateRow.removeAttribute("id");
    accNumCellTemplate.removeAttribute("id");
    accTimeCellTemplate.removeAttribute("id");

    i++;
    access.setNoAccesses(i);
    table.setTextAccNum(" " + i);
    table.setTextAccTime(now);
    if (accTable == null) {
      accTable = templateRow.getParentNode();
      accTable.appendChild(templateRow.cloneNode(true));
      accTable.removeChild(templateRow);
    }
    else {
      if (i % 10 == 0) {
        Node header = accTable.getFirstChild();
        Node subNode = null;
        while ( (subNode = header.getNextSibling()) != null) {
          accTable.removeChild(subNode);
        }
      }
      accTable.appendChild(templateRow.cloneNode(true));
    }

    HTMLTableElement welcomeTable = welcome.getElementTemplateTable();
    Node welcomeNode = welcome.adoptNode(accTable.cloneNode(true));
    Node parentNode = welcomeTable.getParentNode();
    parentNode.appendChild(welcomeNode);

    return;
  }

  public WelcomeHTML returnWelcome() {
    return welcome;
  }
  public Access returnAccess(){
    return access;
  }
}