/*
 *  tableAppClient
 *
 *  Enhydra super-servlet presentation object
 *
 * Prozone
 *
 */

package tableappclient.presentation;

// Enhydra SuperServlet imports
import com.lutris.appserver.server.httpPresentation.HttpPresentation;
import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;
import com.lutris.appserver.server.httpPresentation.HttpPresentationException;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.html.HTMLTableElement;
import org.w3c.dom.html.HTMLTableRowElement;
import org.w3c.dom.html.HTMLElement;

// Enhydra SuperServlet specification imports
import tableappclient.spec.*;

// Standard imports
import java.io.IOException;

public class WelcomePresentation
    implements HttpPresentation {
  static final String FOUND = "The following table has been retrieved from the TableApp application and transferred in a Document object, via Axis/Soap:";
  static final String NOTFOUND = "The server application TableApp has not been accessed yet. Access and refresh it few times, then refresh this window.";
  static final String FOUNDOBJ = "The following data have been retrieved from the TableApp application and transferred in a custom serialized object, via Axis/Soap:";
  static final String NOTFOUNDOBJ = "The following data will be retrieved from the TableApp application and transferred in a custom serialized object, via Axis/Soap:";
  public void run(HttpPresentationComms comms) throws HttpPresentationException,
      IOException {
    String server = null;
    try {
      server = comms.request.getServerName();
    } catch (Exception e) {}
    	String port = null;
    try {
      port = new Integer(comms.request.getServerPort()).toString();
    } catch (Exception e) {}
	    
    String text = "1";
    String textObj = "2";
    WelcomeHTML welcome = (WelcomeHTML) comms.xmlcFactory.create(WelcomeHTML.class);
    try {
      TableNode tableNode = TableNodeFactory.createTableNode(
          "tableappclient.business.TableNodeImpl");
      AccessData accessData = AccessDataFactory.createAccessData(
          "tableappclient.business.AccessDataImpl",server,port);
      Node node = tableNode.getTableNode(server,port);
      if (node == null) {
        text = NOTFOUND;
        textObj = NOTFOUNDOBJ;
      }
      else {
        text = FOUND;
        textObj = FOUNDOBJ;
        HTMLTableElement welcomeTable = welcome.getElementTemplateTable();
        Node welcomeNode = welcome.importNode(node, true);
        Node parentNode = welcomeTable.getParentNode();
        parentNode.appendChild(welcomeNode);
        HTMLTableRowElement templateRow = welcome.getElementTemplateRow();
        HTMLElement noAccessesElement = welcome.getElementAccNum();
        HTMLElement timeElement = welcome.getElementAccTime();
        templateRow.removeAttribute("id");
        noAccessesElement.removeAttribute("id");
        timeElement.removeAttribute("id");
        Node parrent = templateRow.getParentNode();
        welcome.setTextAccNum(new Integer(accessData.getNoAccesses()).toString());
        welcome.setTextAccTime(accessData.getAccessTime());
        parrent.appendChild(templateRow.cloneNode(true));
        parrent.removeChild(templateRow);
      }
    }
    catch (Exception ex) {
      System.out.println("Exception: " + ex);
      text = "Could not get business object!!!";
    }
    welcome.setTextObjectTextTemplate(textObj);
    welcome.setTextTextTemplate(text);
    comms.response.writeDOM(welcome);
  }
}