/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: XalanDoc.java,v 1.2 2005/01/17 14:03:39 slobodan Exp $
 */

/*
 * xalanDoc
 * A sample Enhydra Application
 * 
 */

package xalanDoc;

import java.io.File;

import com.lutris.appserver.server.*;
import com.lutris.appserver.server.httpPresentation.*;
import com.lutris.appserver.server.session.*;
import com.lutris.util.*;

import com.lutris.logging.Logger;
/**
 * The application object.
 * 
 * Application-wide data would go here.
 */
public class XalanDoc extends StandardApplication {
    
	protected static Config config = null;
    
    protected static String contactsDir="";
    protected String DEFAULT_DIRECTORY = "contacts";
    
    /*
     *  A few methods you might want to add to.
     *  See StandardApplication for more details.
     */
    public void startup(Config appConfig) throws ApplicationException {
        super.startup(appConfig);
        
        if (logChannel != null) {
            logChannel.write(Logger.INFO,
                             "Welcome to the XalanDoc application!");
        }
        
        //  Here is where you would read application-specific settings from
        //  your config file.
        config = appConfig;
        
        File tempFile = null;
        String tempString = null;
        
        // XalanDoc.Contacts.Directory parameter initialization
         
        try{
         contactsDir = XalanDoc.config.getString("XalanDoc.Contacts.Directory");
         tempFile = new File(contactsDir+File.separator+"contact-table.xsl");

         if (!tempFile.exists()){
         	// in case a relative path is given (relative from configuration file)
         	tempString = XalanDoc.config.getConfigFile().getFile().getParent();
         	contactsDir = tempString+File.separator+contactsDir;
         	tempFile = new File(contactsDir+File.separator+"contact-table.xsl");
         	
         	if (!tempFile.exists()){
         		try{
             		tempString = this.getClass().getClassLoader().getResource(DEFAULT_DIRECTORY).getPath();
             		contactsDir = tempString;
             		tempFile = new File(contactsDir+File.separator+"contact-table.xsl");
         		} catch (NullPointerException exc){
         			contactsDir = DEFAULT_DIRECTORY;
                	if (logChannel != null) {
                        logChannel.write(Logger.INFO,
                                         "XalanDoc.Contacts.Directory application parameter isn't properly initialized!");
                    }
         		}
         	}
         }
        } catch (ConfigException e) {
        	try{
         		tempString = this.getClass().getClassLoader().getResource(DEFAULT_DIRECTORY).getPath();
         		contactsDir = tempString;
         		tempFile = new File(contactsDir+File.separator+"contact-table.xsl");
     		} catch (NullPointerException exc){
     			contactsDir = DEFAULT_DIRECTORY;
            	if (logChannel != null) {
                    logChannel.write(Logger.INFO,
                                     "XalanDoc.Contacts.Directory application parameter isn't properly initialized!");
                }
     		}
        }
    }
    public boolean requestPreprocessor(HttpPresentationComms comms)
                   throws Exception {
        return super.requestPreprocessor(comms);
    }

    /**
     * This is an optional function, used only by the Multiserver's graphical
     * administration. This bit of HTML appears in the status page for this
     * application. You could add extra status info, for example
     * a list of currently logged in users.
     *
     * @return HTML that is displayed in the status page of the Multiserver.
     */
    public String toHtml() {
        return "This is <I>xalanDoc</I>";
    }
    
    public static String getContactsDir() {
        return contactsDir;
    }
}

