/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: ContactList.java,v 1.2 2005/01/17 14:03:39 slobodan Exp $
 */

package xalanDoc.presentation;

//import org.apache.xalan.xslt.XSLTProcessor; 
//import org.apache.xalan.xslt.XSLTInputSource; 
//import org.apache.xalan.xslt.XSLTResultTarget; 
//import org.apache.xalan.xslt.XSLTProcessorFactory; 
//import org.apache.xalan.xslt.StylesheetRoot; 

//import org.apache.xalan.xpath.xdom.XercesLiaison; 

import org.w3c.dom.*; 
import org.w3c.dom.html.*; 

import com.lutris.appserver.server.httpPresentation.*; 
import com.lutris.appserver.server.user.User; 

//Slobodan Vujasinovic
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import xalanDoc.XalanDoc;

import xalanDoc.spec.*;

public class ContactList implements HttpPresentation { 

    public void run(HttpPresentationComms comms) 
        throws HttpPresentationException { 

        // Instantiate the page 
        ContactListHTML page = (ContactListHTML) 
            comms.xmlcFactory.create(ContactListHTML.class); 

        // Get the user from session 
        User user = comms.session.getUser(); 

        // Figure out the username 
        String username; 
        if (user != null) { 
            username = user.getName(); 
        } else { 
            username = "Enhydra User"; 
        }
        
        // set the name of the username, using an XMLC convenience method 
        page.setTextUsername(username); 

        try { 
         String dir= XalanDoc.getContactsDir();

         Manager manager = ManagerFactory.getManager("xalanDoc.business.ManagerImpl");
         manager.transform(dir,new DOMResult(page.getElementContactList()));

/*
 *You cannot create instances of classes from business layer when start xalanDoc_pres
 *Catch NullPointerException , response will be default HTML page
 */
        }catch(NullPointerException e){
           
        } catch (Exception e) { 
            e.printStackTrace(); 
	    try {
		    writeError("Couldn't process XSL", comms); 
	    } catch (java.io.IOException ioe) {
		      ioe.printStackTrace();
	    }
            return; 
        } 

        // Write the page 
        comms.response.writeDOM(page); 
    } 

    private void writeError(String msg, HttpPresentationComms comms) 
        throws HttpPresentationException, java.io.IOException { 
        comms.response.setContentType("text/plain"); 
        comms.response.getOutputStream().print(msg); 
    } 
} 
