/*
 * Copyright (c) 1999-2001 Lutris Technologies, Inc. All Rights
 * Reserved.
 * 
 * This source code file is distributed by Lutris Technologies, Inc. for
 * use only by licensed users of product(s) that include this source
 * file. Use of this source file or the software that uses it is covered
 * by the terms and conditions of the Lutris Enhydra Development License
 * Agreement included with this product.
 * 
 * This Software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the License for the specific terms
 * governing rights and limitations under the License.
 * 
 * Contributor(s):
 * 
 * $Id: Redirect.java,v 1.1 2004/08/16 10:51:42 slobodan Exp $
 */

/*
 *  This is a sample presentation object written by hand (not using the
 *  Jolt compiler). Since this presentation object only redirects, and does
 *  not emit any HTML, it does not need Jolt.
 *  This type of presentation object could, for example, be the target of
 *  a form's submit button, process the data, and then decide where to send
 *  the user (back or on to the next page).
 */

package xalanDoc.presentation;

import com.lutris.appserver.server.httpPresentation.*;


public class Redirect implements HttpPresentation {

   /*
    * There is the only function needed in order to be a presentation object.
    */
    public void run(HttpPresentationComms comms) throws Exception {
        throw new ClientPageRedirectException(
                      comms.request.getAppFileURIPath("Welcome.po"));
    }

}
