@echo off
cls
rem *********************************************
rem *  Initialize environment variables
rem *********************************************

SET SET_VERSION=off
SET SET_RELEASE=off
SET SET_JDKHOME=off
SET SET_DEBUG=off
SET SET_OPTIMIZE=off
SET SET_JONAS_TOMCAT_HOME=off
SET SET_JONAS_JETTY_HOME=off
SET SET_EAF_ROOT=off
SET SET_DODS_ROOT=off


SET JDKHOME=
rem
rem Set value JDKHOME by Java Home directory with value from registry file or
rem if this key not exist reading enviroment variable JAVA_HOME else generate
rem warning dialog
rem
call .\build\readregistry.exe
if errorlevel==1 goto end
for /F "tokens=1,2* delims==" %%i in (instdir.txt) do SET JDKHOME=%%j
del instdir.txt>nul

SET VERSION=7.0
SET RELEASE=1
SET DEBUG=off
SET OPTIMIZE=on
SET JONAS_TOMCAT_HOME=
SET JONAS_JETTY_HOME=
SET EAF_ROOT=
SET DODS_ROOT=

set OLDCLASSPATH=%CLASSPATH%
set CLASSPATH=%CD%\tools\Ant\lib\ant.jar

java -cp %CLASSPATH% org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% configure

set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=


if exist build.properties goto init

rem *********************************************
rem *  Set properties values from user input
rem *********************************************
:start
if %~1.==. goto default
if %~1==-help goto help
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
goto error

rem *********************************************
rem *  Set default values
rem *********************************************
:default
SET JDKHOME=

rem
rem Set value JDKHOME by Java Home directory with value from registry file or
rem if this key not exist reading enviroment variable JAVA_HOME else generate
rem warning dialog
rem
call .\build\readregistry.exe
if errorlevel==1 goto end
for /F "tokens=1,2* delims==" %%i in (instdir.txt) do SET JDKHOME=%%j
del instdir.txt>nul

SET DEBUG=off
SET OPTIMIZE=on
goto make


rem *********************************************
rem *  Init build.properties parameters
rem *********************************************
:init
find "jdk.dir" < build.properties > javadir.txt
for /F "tokens=1,2* delims==" %%i in (javadir.txt) do SET JDKHOME=%%j
del javadir.txt>nul
if "X%JDKHOME%"=="X" goto initjava
goto initdebug
:initjava
call .\build\readregistry.exe
if errorlevel==1 goto end
for /F "tokens=1,2* delims==" %%i in (instdir.txt) do SET JDKHOME=%%j
del instdir.txt>nul
goto initversion
:initversion
find "version" < build.properties > version.txt
for /F "tokens=1,2* delims==" %%i in (version.txt) do SET VERSION=%%j
del version.txt>nul
goto initrelease
:initrelease
find "release" < build.properties > release.txt
for /F "tokens=1,2* delims==" %%i in (release.txt) do SET RELEASE=%%j
del release.txt>nul
goto initdebug
:initdebug
find "build.debug" < build.properties > builddebug.txt
for /F "tokens=1,2* delims==" %%i in (builddebug.txt) do SET DEBUG=%%j
del builddebug.txt>nul
goto initopt
:initopt
find "build.optimize" < build.properties > buildoptimize.txt
for /F "tokens=1,2* delims==" %%i in (buildoptimize.txt) do SET OPTIMIZE=%%j
del buildoptimize.txt>nul
goto initeafdir
:initeafdir
find "eaf.dir" < build.properties > eaf-root-dir.txt
for /F "tokens=1,2* delims==" %%i in (eaf-root-dir.txt) do SET EAF_ROOT=%%j
del eaf-root-dir.txt>nul
goto initdodsdir
:initdodsdir
find "dods.dir" < build.properties > dods-root-dir.txt
for /F "tokens=1,2* delims==" %%i in (dods-root-dir.txt) do SET DODS_ROOT=%%j
del dods-root-dir.txt>nul
goto start


rem *********************************************************
rem *  Edit parameters (build.properties, servlet_containers)
rem *********************************************************
:make
if exist build.properties del build.properties
echo version=^%VERSION%>build.properties
echo release=^%RELEASE%>>build.properties
echo jdk.dir=^%JDKHOME%>>build.properties
echo build.debug=^%DEBUG%>>build.properties
echo build.optimize=^%OPTIMIZE%>>build.properties
echo eaf.dir=%EAF_ROOT%>>build.properties
echo dods.dir=%DODS_ROOT%>>build.properties

goto end


rem *********************************************************
rem *  Display ERROR message
rem *********************************************************
:error
echo.
echo Invalid options using with configure.bat
echo.


rem *********************************************************
rem *  Display HELP message
rem *********************************************************
:help
echo.
echo Parameters value for using with configure.bat :
echo.
echo configure       - Make build.properties file with default values
echo.
echo configure -help - Display this screen
echo.
echo configure [-version version_tag] [-release release_tag] [-jdkhome jdk_home_dir] [-debug on/off] [-optimize on/off] [-eaf.dir eaf_root] [-dods.dir dods_root] [-jonas_tomcat jonas_tomcat_home] [-jonas_jetty jonas_jetty_home]
echo.
echo.
echo Examples :
echo.
echo configure -version 7.0 -release 1 -debug on -optimize off -jdkhome C:/j2sdk1.4.1 -eaf.dir C:/eaf -dods.dir C:/dods5.1 -jonas_tomcat C:/jonas3.3-tomcat -jonas_jetty C:/jonas3.3-jetty
echo.
goto end


rem *********************************************************
rem *  Set VERSION parameter value
rem *********************************************************
:version
if %SET_VERSION%==on goto error
shift
if "X%~1"=="X" goto error
SET VERSION=%~1
SET SET_VERSION=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto error
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error


rem *********************************************************
rem *  Set RELEASE parameter value
rem *********************************************************
:release
if %SET_RELEASE%==on goto error
shift
if "X%~1"=="X" goto error
SET RELEASE=%~1
SET SET_RELEASE=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto error
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error


rem *********************************************************
rem *  Set JDKHOME parameter value
rem *********************************************************
:jdkhome
if %SET_JDKHOME%==on goto error
shift
if "X%~1"=="X" goto error
SET JDKHOME=%~f1
SET SET_JDKHOME=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto error
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error


rem *********************************************************
rem *  Set DEBUG parameter value
rem *********************************************************
:debug
if %SET_DEBUG%==on goto error
shift
if "X%~1"=="X" goto error
if /i "%~1"=="on" goto setdebug
if /i "%~1"=="off" goto setdebug
goto error
:setdebug
SET DEBUG=%~1
SET SET_DEBUG=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto error
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error


rem *********************************************************
rem *  Set OPTIMIZE parameter value
rem *********************************************************
:optimize
if %SET_OPTIMIZE%==on goto error
shift
if "X%~1"=="X" goto error
if /i "%~1"=="on" goto setoptimize
if /i "%~1"=="off" goto setoptimize
goto error
:setoptimize
SET OPTIMIZE=%~1
SET SET_OPTIMIZE=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto error
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error

rem *********************************************************
rem *  Set EAF_ROOT parameter value
rem *********************************************************
:eaf.dir
if %SET_EAF_ROOT%==on goto error
shift
SET EAF_ROOT=%~f1
SET SET_EAF_ROOT=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto error
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error

rem *********************************************************
rem *  Set DODS_ROOT parameter value
rem *********************************************************
:dods.dir
if %SET_DODS_ROOT%==on goto error
shift
SET DODS_ROOT=%~f1
SET SET_DODS_ROOT=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto error
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto jonas_jetty
goto error

rem *********************************************************
rem *  Set JONAS_TOMCAT_HOME parameter value
rem *********************************************************
:jonas_tomcat
if %SET_JONAS_TOMCAT_HOME%==on goto error
shift
SET JONAS_TOMCAT_HOME=%~f1
SET SET_JONAS_TOMCAT_HOME=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto error
if %~1==-jonas_jetty goto jonas_jetty
goto error


rem *********************************************************
rem *  Set JONAS_JETTY_HOME parameter value
rem *********************************************************
:jonas_jetty
if %SET_JONAS_JETTY_HOME%==on goto error
shift
SET JONAS_JETTY_HOME=%~f1
SET SET_JONAS_JETTY_HOME=on
shift
if "X%~1"=="X" goto make
if %~1==-help goto error
if %~1==-version goto version
if %~1==-release goto release
if %~1==-jdkhome goto jdkhome
if %~1==-debug goto debug
if %~1==-optimize goto optimize
if %~1==-eaf.dir goto eaf.dir
if %~1==-dods.dir goto dods.dir
if %~1==-jonas_tomcat goto jonas_tomcat
if %~1==-jonas_jetty goto error
goto error


rem *********************************************************
rem *  Reset evironment variables
rem *********************************************************
:end
SET VERSION=
SET RELEASE=
SET JDKHOME=
SET DEBUG=
SET OPTIMIZE=
SET EAF_ROOT=
SET DODS_ROOT=
SET JONAS_TOMCAT_HOME=
SET JONAS_JETTY_HOME=

SET SET_VERSION=
SET SET_RELEASE=
SET SET_JDKHOME=
SET SET_DEBUG=
SET SET_OPTIMIZE=
SET SET_EAF_ROOT=
SET SET_DODS_ROOT=
SET SET_JONAS_TOMCAT_HOME=
SET SET_JONAS_JETTY_HOME=
