@echo off
cls

SET VERSION=7.0
SET TARGET=buildAll
SET OLD_JAVA_HOME=%JAVA_HOME%
SET JAVA_HOME=
SET EAF_HOME=

if %SYSTEMROOT% == "" goto errorsystemroot

if not exist build.properties call configure.bat
find "jdk.dir" < build.properties >javahome.txt
for /F "tokens=1,2* delims==" %%i in (javahome.txt) do SET JAVA_HOME=%%j
del javahome.txt>nul
if "X%JAVA_HOME%"=="X" goto errorjava

find "eaf.dir" < build.properties >eaf_home.txt
for /F "tokens=1,2* delims==" %%i in (eaf_home.txt) do SET EAF_HOME=%%j
del eaf_home.txt>nul
if not exist %EAF_HOME%\lib\enhydra.jar SET EAF_HOME=%CD%\tools\EAF

find "dods.dir" < build.properties >dods_home.txt
for /F "tokens=1,2* delims==" %%i in (dods_home.txt) do SET DODS_ROOT=%%j
del dods_home.txt>nul
if not exist %DODS_ROOT%\lib\dods.jar SET DODS_ROOT=%CD%\tools\DODS

if "X%~1"=="X" goto buildAll
if %~1==help goto help
if %~1==buildAll goto continue
if %~1==configure goto configure
if %~1==clean goto continue
if %~1==distributions goto buildAllDistribution
goto error

:continue
SET TARGET=%~1
goto continueuild

:configure
SET TARGET=configureForContainers
goto continueuild

:buildAll
SET TARGET=buildAll
goto continueuild

:buildAllDistribution
SET TARGET=buildAllDistribution
goto continueuild

:continueuild
set OLDCLASSPATH=%CLASSPATH%
set OLDPATH=%PATH%
set PATH="%JAVA_HOME%\bin"
set CLASSPATH=%CLASSPATH%;%CD%\tools\Ant\lib\ant.jar
set CLASSPATH=%CLASSPATH%;%CD%\tools\log4j\lib\log4j.jar
set CLASSPATH=%CLASSPATH%;"%JAVA_HOME%\lib\tools.jar"
set CLASSPATH=%CLASSPATH%;%EAF_HOME%\lib\xercesImpl.jar
set CLASSPATH=%CLASSPATH%;%EAF_HOME%\lib\xml-apis.jar
set CLASSPATH=%CLASSPATH%;%EAF_HOME%\lib\util.jar
set CLASSPATH=%CLASSPATH%;%EAF_HOME%\lib\eaf_api.jar
set CLASSPATH=%CLASSPATH%;%EAF_HOME%\lib\eaf.jar
set CLASSPATH=%CLASSPATH%;%DODS_ROOT%\lib\dods.jar;%DODS_ROOT%\lib\dbmanager.jar;%DODS_ROOT%\lib\dbmanager-api.jar;%DODS_ROOT%\lib\stdcaches.jar;%DODS_ROOT%\lib\ejen.jar;%DODS_ROOT%\lib-ext\xalan.jar

java -Xmx128M -cp %CLASSPATH% -DJAVA_HOME="%JAVA_HOME%" -DDODS_HOME=%DODS_ROOT% org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT% %TARGET%

set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
set PATH=%OLDPATH%
set OLDPATH=
goto end


:help
echo.
echo Parameters value for using with make.bat :
echo.
echo make                      - builds and configures EnhydraDemos
echo.                            
echo make buildAll             - builds and configures EnhydraDemos
echo.                             
echo make configure            - builds and configures EnhydraDemos with
echo                             aditional containers configurations (due to
echo                             jonas_tomcat_home and jonas_jetty_home property
echo                             from build.properties file) 
echo make clean                - removes the output folder (in order to
echo                             start a new compilation from scratch)
echo make distributions        - build distribution source zip file
echo.
goto end

:errorsystemroot
echo.
echo          Enviroment variable SYSTEMROOT does not exist.
echo.
echo Set variable SYSTEMROOT to system root of your Windows installation ...
echo.
pause
goto end

:error
echo.
echo Invalid parameter value!
echo.
goto help

:errorjava
echo.
echo Invalid java parameter value in build.properties file.
echo Please use configure command to set this parameter to right value.
echo.
echo     configure.bat -jdkhome java_home_directory
echo.
goto end

:end
SET VERSION=
SET TARGET=
SET EAF_HOME=
SET JAVA_HOME=%OLD_JAVA_HOME%
