<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:common="org.enhydra.dods.Common"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                xmlns:miu="org.enhydra.dods.xslt.XSLTUtil"
                xmlns:stu="org.ejen.ext.StringUtil"
                version="1.0">
    <xsl:output method="text" encoding="utf-8"/>
<xsl:template name="memberStuff">
    /**
     * Used for query caching.
     */
    static public final int COLUMN_<xsl:value-of select="common:upperCaseName(@name)"/> = <xsl:value-of select="dodst:getCounter()"/>;<xsl:value-of select="dodst:incCounter()"/><xsl:text>

    </xsl:text><xsl:value-of select="JAVADOC"/>
    private <xsl:if test="not(REFERENCE_OBJECT)"><xsl:value-of select="JAVA_TYPE"/></xsl:if><xsl:if test="REFERENCE_OBJECT">ObjectId</xsl:if><xsl:text> </xsl:text> <xsl:value-of select="@name"/> = <xsl:if test="not(REFERENCE_OBJECT)"><xsl:value-of select="miu:fixDefault(JAVA_TYPE,JAVA_DEFAULT_VALUE)"/></xsl:if><xsl:if test="REFERENCE_OBJECT"> null </xsl:if>;

    /**
     * Sets <xsl:value-of select="common:capitalizeName(@name)"/> column.
     * @param val4<xsl:value-of select="@name"/> new column value.
     */
    public void set<xsl:value-of select="common:capitalizeName(@name)"/>(<xsl:if test="not(REFERENCE_OBJECT)"><xsl:value-of select="JAVA_TYPE"/></xsl:if><xsl:if test="REFERENCE_OBJECT">ObjectId</xsl:if> val4<xsl:value-of select="@name"/>) {
        if (readOnly) throw newError(&quot;<xsl:value-of select="common:capitalizeName(@name)"/>&quot;);
        this.<xsl:value-of select="@name"/> = val4<xsl:value-of select="@name"/>;
    }

    /**
     * Return value of <xsl:value-of select="common:capitalizeName(@name)"/> column.
     * @return value of <xsl:value-of select="common:capitalizeName(@name)"/> column.
     */
    public <xsl:if test="not(REFERENCE_OBJECT)"><xsl:value-of select="JAVA_TYPE"/></xsl:if><xsl:if test="REFERENCE_OBJECT">ObjectId</xsl:if> get<xsl:value-of select="common:capitalizeName(@name)"/>() {
        return this.<xsl:value-of select="@name"/>;
    }
</xsl:template>
</xsl:stylesheet>
