<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:miu="org.enhydra.dods.xslt.XSLTUtil"
                xmlns:common="org.enhydra.dods.Common"
                version="1.0">
<xsl:output method="text" encoding="utf-8"/>
<xsl:template name="resultSetExstractionForLONGDO">
<xsl:if test="not(IS_CONSTANT='true')"> <xsl:if test="DB_TYPE='LONGVARCHAR'"> {
		java.io.InputStream is = null;
		java.io.Reader ir = null;
		if(useBinaryStreamForLongvarchar){
			is = rs.getBinaryStream( &quot;<xsl:value-of select="@name"/>&quot; );
		}else{
			ir = rs.getCharacterStream( &quot;<xsl:value-of select="@name"/>&quot; );
		}
        StringBuffer sb = new StringBuffer();
		int bufSize = 2000;
        if (is != null || ir!=null)  {
	        int n = 0;
	        try {
				if(useBinaryStreamForLongvarchar){
						byte[] bbuf = new byte[bufSize];
		                while ( -1 != ( n = is.read( bbuf ) ) ) {
		                    sb.append(new String( bbuf, 0, n ));
		                }
				}else{
						char[] cbuf = new char[bufSize];
		                while ( -1 != ( n = ir.read( cbuf ) ) ) {
		                    sb.append( cbuf, 0, n );
		                }
				}
            } catch ( Exception e ) {
                throw new DataObjectException("IO error processing input stream for column <xsl:value-of select="@name"/>: ", e );
            }
			try{
				if(is!=null)is.close();
				if(ir!=null)ir.close();
			}catch ( Exception e ) {} 
			is=null;
			ir=null;
<xsl:if test="DO_IS_MULTIDB_BASED='true'">
            if (get_OriginDatabase() != null) {
                set<xsl:value-of select="common:capitalizeName(@name)"/>(<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'"><xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/>.ceInternal(get_OriginDatabase(),new BigDecimal(</xsl:if></xsl:if>sb.toString()<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'">), get_transaction())</xsl:if></xsl:if> );
            } else {</xsl:if>
               set<xsl:value-of select="common:capitalizeName(@name)"/>(<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'"><xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/>.ceInternal(new BigDecimal(</xsl:if></xsl:if>sb.toString()<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'">), get_transaction())</xsl:if></xsl:if> );
           <xsl:if test="DO_IS_MULTIDB_BASED='true'">
            }
         </xsl:if>
        } else {
            if (get_OriginDatabase() != null) {
                 set<xsl:value-of select="common:capitalizeName(@name)"/>(<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'"><xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/>.ceInternal(get_OriginDatabase(),</xsl:if></xsl:if> null<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'"> )</xsl:if></xsl:if> );
            } else {
               set<xsl:value-of select="common:capitalizeName(@name)"/>(<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'"><xsl:value-of select="miu:adjustJavaType(JAVA_TYPE)"/>.ceInternal(</xsl:if></xsl:if> null<xsl:if test="REFERENCE_OBJECT"><xsl:if test="REFERENCE_OBJECT/IS_FOREIGN_KEY='false'">, get_transaction())</xsl:if></xsl:if> );
            }    
        }
    }</xsl:if>  </xsl:if>
</xsl:template>
</xsl:stylesheet>
