<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                version="1.0">
    <xsl:output method="text" encoding="utf-8"/>
<xsl:template name="fileFooter3">
<xsl:if test="not(IS_CONSTANT='true')">

    private boolean isDeletedFromDatabase = false;
    /**
     * Prepares the statement used to insert this object
     * into the database.
     *
     * @param conn The database connection.
     *
     * @return The insert statement.
     *
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getInsertStatement(DBConnection conn)
    throws SQLException {
	if (isDeletedFromDatabase) 
            throw new DBRowUpdateException("Object "+get_OId()+" is already deleted");
		PreparedStatement stmt = null;
		
		String stmtStr = &quot;insert into <xsl:value-of select="TABLE_NAME"/>&quot;
						+&quot; ( <xsl:value-of select="dodst:insertColumnNames()"/> )&quot;;
						
		if (objectIdentityType()==CommonConstants.OBJECT_IDENTITY_TYPE_OID ){
			stmtStr+=&quot; values (<xsl:for-each select="//COLUMN"><xsl:call-template name="questionMarks"/></xsl:for-each> ?, ?)&quot;;
		} else {
			stmtStr+=&quot; values (<xsl:for-each select="//COLUMN"><xsl:call-template name="questionMarks"/></xsl:for-each> ?)&quot;;
		}
		
		if (objectIdentityType()==CommonConstants.OBJECT_IDENTITY_TYPE_AUTOGENERATED){
         	stmt= ((ExtendedDBConnection)conn).prepareStatement(stmtStr,true);  
		}else{
         	stmt= conn.prepareStatement(stmtStr);	
        }
        int[] param = new int[1]; param[0] = 1;
        try {
</xsl:if>
</xsl:template>
<xsl:template name="questionMarks">
    <xsl:if test="DB_TYPE='LONGVARBINARY'"> &quot;+((tweak.isBlobAccessSpecial())?&quot;empty_blob()&quot;:&quot;?&quot;)+&quot;,</xsl:if>
    <xsl:if test="not(DB_TYPE='LONGVARBINARY')"> ?,</xsl:if>
</xsl:template>
</xsl:stylesheet>
