<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                xmlns:stu="org.ejen.ext.StringUtil"
                version="1.0">
<xsl:output method="text" encoding="utf-8"/>
<xsl:template name="fileFooter4">
<xsl:if test="not(IS_CONSTANT='true')">
<xsl:if test="DO_IS_OID_BASED='true'">
            /* The ObjecId/Version columns form the primary key.  */
            if(objectIdentityType()==CommonConstants.OBJECT_IDENTITY_TYPE_OID){
            	setPrepStmtParam_BigDecimal( stmt, param, get_OId().toBigDecimal() );
            }
            setPrepStmtParam_int( stmt, param, get_NewVersion() );
</xsl:if>
        } catch ( Exception e ) {
            throw new SQLException( "Data Object error: " + e.getMessage() );
        }
        statistics.incrementInsertNum();
        return stmt;
    }

<xsl:if test="not(IS_CONSTANT='true')"><xsl:if test="DO_IS_OID_BASED='true'">
    /**
     *
     */
    private boolean _lockDO = false;

    /**
     * Specifies whether to lock this DO (row) in database just before commit.
     * Locking is attempted via "dummy" update:
     * "update set version=OLD_ONE where OID=X and version=OLD_ONE".
     * @param value true for locking, false otherwise
     */
    public void doCheck(boolean value) {
        _lockDO = value;
    }

    /**
     * Locks this DO in database by performing
     * "update set version=OLD_ONE where OID=X and version=OLD_ONE".
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public void doLock() throws SQLException {
        if (null!=transaction) {
            incrementVersionToo = false;
            boolean _ol = _lockDO;
            _lockDO = true;
            transaction.lockDO(this);
            _lockDO = _ol;
        }
    }

    private boolean incrementVersionToo = true;
    /**
     * Locks this DO in database by performing
     * "update set version=INCREMENTED where OID=X and version=OLD_ONE".
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     * @exception ObjectIdException
     * @exception DataObjectException
     */
    public void doTouch() 
    throws SQLException, DatabaseManagerException, 
    com.lutris.appserver.server.sql.ObjectIdException, DataObjectException {
        if (null!=transaction) {
	    checkLoad(true);
  	    markNewValue();
            incrementVersionToo = true;
            boolean _ol = _lockDO;
            _lockDO = true;
            transaction.lockDO(this);
            _lockDO = _ol;
        }
    }

    /**
     * Prepares and executes the statement used to lock this object
     * in the database.
     *
     * @param conn The database connection
     *
     * @exception java.sql.SQLException if an error occurs.
     */
    public void executeLockingStatement(DBConnection conn) throws SQLException {
        if (!_lockDO)
            return;
        StringBuffer updateStmt = new StringBuffer();
        PreparedStatement stmt = null;
        if (isDeletedFromDatabase)
            throw new SQLException("<xsl:value-of select="TABLE_NAME"/> ("
					+get_OId()+") is already deleted, "
					+"cannot lock it.");

        int[] param = new int[1]; param[0] = 1;
        try {
            updateStmt.append(&quot;Update <xsl:value-of select="TABLE_NAME"/> set &quot;);
            updateStmt.append(get_versionColumnName()).append(&quot; = ? &quot;);
            updateStmt.append(&quot; where <xsl:value-of select="dodst:updateWhereClause()"/>&quot;);

            stmt = conn.prepareStatement(updateStmt.toString());
            setPrepStmtParam_int(stmt, param, get_Version()+(incrementVersionToo?1:0));
            setPrepStmtParam_BigDecimal( stmt, param, get_OId().toBigDecimal() );
            setPrepStmtParam_int(stmt, param, get_Version());
            if (null != stmt) {
	        conn.executeUpdate(stmt, "execute update");
                if (incrementVersionToo) {
                    set_Version(get_Version()+1);
                }
            }
        } catch ( Exception e ) {
            e.printStackTrace();
            throw new SQLException( "Data Object error: " + e.getMessage() );
        }
    }
</xsl:if></xsl:if>

    /**
     * Prepares the statement used to update this object
     * in the database.
     *
     * @param conn The database connection
     *
     * @return The update statement.
     *
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getUpdateStatement(DBConnection conn)
    throws SQLException {
        StringBuffer updateStmt = new StringBuffer();
        PreparedStatement stmt;

	     if (isDeletedFromDatabase)
            throw new SQLException("Object "+get_OId()+" is already deleted");

        data.set_Version(get_Version()+1);
        int[] param = new int[1]; param[0] = 1;
        try {
            updateStmt.append(&quot;Update <xsl:value-of select="TABLE_NAME"/> set &quot;);
            updateStmt.append(get_versionColumnName()).append(&quot; = ? &quot;);

</xsl:if>
</xsl:template>
</xsl:stylesheet>
