<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XML Spy v4.3 U (http://www.xmlspy.com) by predrag (none) -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
   <xsl:output method="text"/>
   <!-- Converting doml 3.1 file into doml 6.0 file. -->
   <xsl:template match="/">
      <xsl:apply-templates select="doml"/>
   </xsl:template>
   <!-- doml -->
   <xsl:template match="doml">
      <xsl:text>&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;doml&gt;
</xsl:text>
      <xsl:apply-templates select="database"/>
      <xsl:text>  &lt;/database&gt;
&lt;/doml&gt;</xsl:text>
   </xsl:template>
   <!-- database -->
   <xsl:template match="database">
      <xsl:text>  &lt;database database="</xsl:text>
      <xsl:choose>
         <xsl:when test="@database='Standard_JDBC'">Standard"&gt;
</xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="@database"/>"&gt;
</xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="package"/>
      <xsl:text/>
   </xsl:template>   
   <!-- package -->
   <xsl:template match="package">
      <xsl:text>     &lt;</xsl:text>package id="<xsl:value-of select="@id"/>
      <xsl:text>"&gt;
</xsl:text>
      <xsl:apply-templates select="package"/>
      <xsl:apply-templates select="table"/>
      <xsl:text>     &lt;</xsl:text>/package<xsl:text>&gt;
</xsl:text>
   </xsl:template>
   <!-- table -->
   <xsl:template match="table">
      <xsl:text>     &lt;</xsl:text>table id="<xsl:value-of select="@id"/>
      <xsl:text>"</xsl:text>
      <xsl:choose>
         <xsl:when test="@dbTableName"> dbTableName="<xsl:value-of select="@dbTableName"/>"</xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isFinal">
         	<xsl:message terminate="no">Warning: "isFinal" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isLazyLoading">
            <xsl:message terminate="no">Warning: "isLazyLoading" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@caching">
            <xsl:message terminate="no">Warning: "caching" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isIndex">
            <xsl:message terminate="no">Warning: "isIndex" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isAbstract">
            <xsl:message terminate="no">Warning: "isAbstract" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isEJB">
            <xsl:message terminate="no">Warning: "isEJB" is not suported in this version</xsl:message>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isView"> isView="<xsl:value-of select="@isView"/>"</xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@notUsingOid">
            <xsl:if test="@notUsingOid ='true' ">
               <xsl:message terminate="yes">Fatal error:"notUsingOid" is not suported in this version</xsl:message>
            </xsl:if>
            <xsl:if test="@notUsingOid ='false' ">
               <xsl:message terminate="no">Warning: "notUsingOid" is not suported in this version</xsl:message>
            </xsl:if>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:text>&gt;
</xsl:text>
      <!-- <xsl:for-each select="column[not(@isIndex='true')]">-->
      <xsl:for-each select="column">
         <xsl:call-template name="column"/>
      </xsl:for-each>
      <xsl:apply-templates select="index"/>
      <xsl:choose>
         <xsl:when test="column[@isIndex='true']">
            <xsl:choose>
               <xsl:when test="column[@isUnique='true']">
                  <xsl:text>        &lt;index id="indexUnique" unique="true"&gt;
</xsl:text>
                  <xsl:for-each select="column[@isIndex='true']">
                     <xsl:choose>
                        <xsl:when test="@isUnique">
                           <xsl:if test="@isUnique='true'">
                              <xsl:text>          &lt;indexColumn id="</xsl:text>
                              <xsl:value-of select="@id"/>
                              <xsl:text>"/&gt;
</xsl:text>
                           </xsl:if>
                        </xsl:when>
                        <xsl:otherwise/>
                     </xsl:choose>
                  </xsl:for-each>
                  <xsl:text>        &lt;/index&gt;</xsl:text>
               </xsl:when>
               <xsl:otherwise>
                  <xsl:text>        &lt;index id="indexNotUnique" unique="false"&gt;
 </xsl:text>
                  <xsl:for-each select="column[@isIndex='true']">
                     <xsl:choose>
                        <xsl:when test="@isUnique">
                           <xsl:if test="@isUnique='false'">
                              <xsl:text>        &lt;indexColumn id="</xsl:text>
                              <xsl:value-of select="@id"/>
                              <xsl:text>"/&gt;
</xsl:text>
                           </xsl:if>
                        </xsl:when>
                        <xsl:otherwise>
                           <xsl:text>        &lt;indexColumn id="</xsl:text>
                           <xsl:value-of select="@id"/>
                           <xsl:text>"/&gt;
</xsl:text>
                        </xsl:otherwise>
                     </xsl:choose>
                  </xsl:for-each>
                  <xsl:text>       &lt;/index&gt;   
</xsl:text>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:text>     &lt;/table&gt;
      
 </xsl:text>
   </xsl:template>
   <!-- column -->
   <xsl:template name="column">
      <xsl:text>        &lt;column id="</xsl:text>
      <xsl:value-of select="@id"/>
      <xsl:text>"</xsl:text>
      <xsl:choose>
         <xsl:when test="@usedForQuery"> usedForQuery="<xsl:value-of select="@usedForQuery"/>"</xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="@isConstant"> isConstant="<xsl:value-of select="@isConstant"/>"</xsl:when>
         <xsl:otherwise/>
      </xsl:choose>
      <xsl:text>&gt;
</xsl:text>
      <xsl:for-each select="error">
         <xsl:text>           &lt;error&gt;</xsl:text>
         <xsl:value-of select="."/>&lt;/error&gt;
</xsl:for-each>
      <xsl:for-each select="javadoc">
         <xsl:text>           &lt;javadoc&gt;</xsl:text>
         <xsl:value-of select="."/>&lt;/javadoc&gt;
</xsl:for-each>
      <xsl:for-each select="referenceObject">
         <xsl:text>           &lt;referenceObject </xsl:text>
         <xsl:choose>
            <xsl:when test="@constraint"> constraint="<xsl:value-of select="@constraint"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose> 
         <xsl:choose>
            <xsl:when test="@foreignKeyGroup">
               <xsl:message terminate="yes">Fatal error: "foreignKeyGroup" is not suported in this version</xsl:message>
            </xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:choose>
            <xsl:when test="@foreignKeyColumn">
               <xsl:message terminate="yes">Fatal error: "foreignKeyColumn" is not suported in this version</xsl:message>
            </xsl:when>
            <xsl:otherwise/>
         </xsl:choose> reference="<xsl:value-of select="@reference"/>
         <xsl:text>"/&gt;
</xsl:text>
      </xsl:for-each>
      <xsl:for-each select="type">
         <xsl:text>           &lt;type</xsl:text>
         <xsl:choose>
            <xsl:when test="@canBeNull"> canBeNull="<xsl:value-of select="@canBeNull"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:choose>
            <xsl:when test="@dbType"> dbType="<xsl:value-of select="@dbType"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:choose>
            <xsl:when test="@javaType"> javaType="<xsl:value-of select="@javaType"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:choose>
            <xsl:when test="@size"> size="<xsl:value-of select="@size"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:text>/&gt;
</xsl:text>
      </xsl:for-each>
      <xsl:for-each select="initialValue">
         <xsl:text>           &lt;initialValue&gt;</xsl:text>
         <xsl:value-of select="."/>
         <xsl:text>&lt;/initialValue&gt;
</xsl:text>
      </xsl:for-each>
      <xsl:text>        &lt;/column&gt;
</xsl:text>
   </xsl:template>
   <!-- index -->
   <xsl:template match="index">
         <xsl:text>        &lt;index id="</xsl:text>
         <xsl:value-of select="@id"/>
         <xsl:text>"</xsl:text>
         <xsl:choose>
            <xsl:when test="@unique">  unique="<xsl:value-of select="@unique"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:choose>
            <xsl:when test="@clustered">  clustered="<xsl:value-of select="@clustered"/>"</xsl:when>
            <xsl:otherwise/>
         </xsl:choose>
         <xsl:text>&gt;
</xsl:text>
         <xsl:for-each select="indexColumn">
            <xsl:text>           &lt;indexColumn id="</xsl:text> <xsl:value-of select="@id"/><xsl:text>"/&gt;
</xsl:text>
</xsl:for-each>
            <xsl:text>        &lt;/index&gt;
</xsl:text>
   </xsl:template>
</xsl:stylesheet>
