<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:cwr="org.enhydra.dods.xslt.ConfigWritter" extension-element-prefixes="cwr">
	<xsl:output method="xml" encoding="utf-8" indent="yes"/>
	
	<xsl:param name="outputPath"/>
	<xsl:param name="defaultLazyLoading"/>
	<xsl:param name="defaultCaching"/>
	<xsl:param name="database">
			<xsl:value-of select="/doml/database/@database"/>
	</xsl:param>
	
	
	<xsl:template match="/">
	  <xsl:value-of select="cwr:writeDefaultsToConfig($outputPath)"/>
		<xsl:apply-templates/>
	</xsl:template>
	
	<xsl:template match="*|@*">
		<xsl:choose>
			<xsl:when test="name()='table'">
			   <xsl:choose>
					<xsl:when test="@isLazyLoading='true' or @isLazyLoading='false'">
							<xsl:apply-templates select="@*"/>
							 <xsl:value-of select="cwr:writeToConfig($outputPath,$database,@dbTableName,'isLazyLoading',@isLazyLoading)"/>
							<xsl:apply-templates select="node()"/>
					</xsl:when>
					<xsl:otherwise>
							<xsl:apply-templates select="@*"/>
							 <xsl:value-of select="cwr:writeToConfigDefault($outputPath,$database,@dbTableName,'isLazyLoading',$defaultLazyLoading)"/>
							<xsl:apply-templates select="node()"/>
					</xsl:otherwise>
				 </xsl:choose>
				 <xsl:choose>
					<xsl:when test="@caching='none' or @caching='partial' or @caching='full'">
							<xsl:apply-templates select="@*"/>
						    <xsl:value-of select="cwr:writeToConfig($outputPath,$database,@dbTableName,'caching',@caching)"/> 
							<xsl:apply-templates select="node()"/>
					</xsl:when>
					<xsl:otherwise>
							<xsl:apply-templates select="@*"/>
						    <xsl:value-of select="cwr:writeToConfigDefault($outputPath,$database,@dbTableName,'caching',$defaultCaching)"/> 
							<xsl:apply-templates select="node()"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
					<xsl:apply-templates select="node()|@*"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet> 